SUBROUTINE AggregateTransitionPath

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER		:: it,ic,ia,ij
LOGICAL, DIMENSION(nsimtrans)   :: lmask,workmask,retmask

write(*,*) 'Calculating aggregate transition path'
DO it = -1,Ttransition+Tadditionalsim

   workmask = simtrans(it)%jsim .LE. Jwork
   retmask = (simtrans(it)%jsim .LT. Jtot .and. simtrans(it)%jsim .GT. Jwork) 
	DO ic = 1,3 !any rebate or control: note this is not control in the JPS sense, that is done RebateRgressions.f90
	
		IF (ic == 1) THEN !control group
			lmask = rebatetypeI==0
		ELSE IF (ic==2)	THEN !rebate group A
			lmask = rebatetypeI==1
		ELSE IF (ic==3)	THEN !rebate group B
			lmask = rebatetypeI==2
		END IF

	
		pathEage(it,ic) = SUM(simtrans(it)%jsim,MASK=lmask)/real(COUNT(lmask))
		pathEinc(it,ic) = SUM(simtrans(it)%ysim,MASK=lmask)/real(COUNT(lmask .and. simtrans(it)%jsim<=Jwork))
	
		pathElabinc(it,ic) = SUM(simtrans(it)%ysim,MASK=lmask .and. simtrans(it)%usimI==1)/real(count(lmask .and. simtrans(it)%usimI==1))
		IF (count(simtrans(it)%usimI==2)>0) THEN 
			pathEuiben(it,ic) = SUM(simtrans(it)%ysim,MASK=lmask .and. simtrans(it)%usimI==2)/real(count(lmask .and. simtrans(it)%usimI==2))
		ELSE
			pathEuiben(it,ic) = 0.0
		END IF
		
		
		pathEunemp(it,ic) = SUM(simtrans(it)%usim,MASK=lmask)/real(COUNT(lmask))
	
		pathEcon(it,ic) = SUM(simtrans(it)%csim,MASK=lmask)/real(COUNT(lmask))
		pathEass(it,ic) = SUM(simtrans(it)%asim,MASK=lmask)/real(COUNT(lmask))
		pathEliq(it,ic) = SUM(simtrans(it)%lsim,MASK=lmask)/real(COUNT(lmask))
		pathEadjust(it,ic) = SUM(simtrans(it)%adjsim,MASK=lmask)/real(COUNT(lmask))
		pathEtax(it,ic) = SUM(simtrans(it)%taxsim,MASK=lmask)/real(COUNT(lmask))
		pathEasspos(it,ic) = COUNT(lmask .and. simtrans(it)%asim>0.0)/real(COUNT(lmask))
		pathEliqpos(it,ic) = COUNT(lmask .and. simtrans(it)%lsim>0.0)/real(COUNT(lmask))

		pathEpen(it,ic) = SUM(simtrans(it)%psim, MASK=lmask .and. simtrans(it)%jsim>Jwork) / real(COUNT(lmask .and. simtrans(it)%jsim>Jwork))
		pathEdie(it,ic) = SUM(simtrans(it)%diesimI,MASK=lmask)/real(COUNT(lmask))
		pathErebate(it,ic) = SUM(simtrans(it)%rebsim,MASK=lmask)/real(COUNT(lmask))
		IF (COUNT(lmask .and. simtrans(it)%rebsim>0.0)>0) THEN
			pathEavrebsize(it,ic) = SUM(simtrans(it)%rebsim,MASK=lmask)/real(COUNT(lmask .and. simtrans(it)%rebsim>0.0))
		ELSE
			pathEavrebsize(it,ic) = 0.0
		END IF





                path0liq(it,ic)=COUNT(simtrans(it)%lsim == 0.0 .and. lmask)/real(COUNT(lmask))
                path0liqposill(it,ic)=COUNT(simtrans(it)%lsim == 0.0 .and. simtrans(it)%asim .GT. 0.0 .and. lmask)/real(COUNT(lmask))
                pathposliqposill(it,ic)=COUNT(simtrans(it)%lsim .GT. 0.0 .and. simtrans(it)%asim .GT. 0.0 .and. lmask)/real(COUNT(lmask))

                IF(Borrowing == 1) THEN

                   pathEliqlim(it,ic)=0.0d0
                   pathEliqlimapos(it,ic)=0.0d0
                   pathEcstr5(it,ic)=0.0d0
                   pathEcstr5noill(it,ic)=0.0d0
                   IF(it<Ttransition+Tadditionalsim) THEN
                      DO ij=1,nsimtrans
                      
                         
                         IF(simtrans(it)%jsim(ij)<Jtot) THEN
                            IF(simtrans(it)%jsim(ij) .LT. Jwork) THEN

                               IF(simtrans(it)%lsim(ij) .eq. abl(simtrans(it)%jsim(ij),fysimtransI(ij),simtrans(it)%zysimI(ij))) THEN
                                  
                                  pathEliqlim(it,ic)=pathEliqlim(it,ic)-lmask(ij)

                                  IF(simtrans(it)%asim(ij) .gt. 0.0d0) THEN

                                     pathEliqlimapos(it,ic)=pathEliqlimapos(it,ic)-lmask(ij)

                                  ENDIF

                               ENDIF

                               IF( ((simtrans(it)%lsim(ij) .eq. abl(simtrans(it)%jsim(ij),fysimtransI(ij),simtrans(it)%zysimI(ij)) ) .and. (simtrans(it+1)%lsim(ij) .eq. abl(simtrans(it+1)%jsim(ij),fysimtransI(ij),simtrans(it+1)%zysimI(ij)))) .or. ((simtrans(it)%lsim(ij) .eq. 0.0) .and. (simtrans(it+1)%lsim(ij) .eq. 0.0))) THEN


                                  IF(simtrans(it)%adjsim(ij) .eq. 0.0) pathEcstr5(it,ic) = pathEcstr5(it,ic) - lmask(ij) 
                                  IF(simtrans(it)%adjsim(ij) .eq. 0.0 .and. simtrans(it)%asim(ij)==0.0d0) pathEcstr5noill(it,ic) = pathEcstr5noill(it,ic) - lmask(ij) 
                               ENDIF

                            ELSEIF(simtrans(it)%jsim(ij) .eq. Jwork) THEN

                               IF( ((simtrans(it)%lsim(ij) .eq. abl(simtrans(it)%jsim(ij),fysimtransI(ij),simtrans(it)%zysimI(ij)) ) .and. (simtrans(it+1)%lsim(ij) .eq. 0.0)) .or. ((simtrans(it)%lsim(ij) .eq. 0.0) .and. (simtrans(it+1)%lsim(ij) .eq. 0.0))) THEN
                               
                                  IF(simtrans(it)%adjsim(ij) .eq. 0.0) pathEcstr5(it,ic) = pathEcstr5(it,ic) - lmask(ij)
                                  IF(simtrans(it)%adjsim(ij) .eq. 0.0 .and. simtrans(it)%asim(ij)==0.0d0) pathEcstr5noill(it,ic) = pathEcstr5noill(it,ic) - lmask(ij) 
                               
                               ENDIF


                            ELSE

                               IF((simtrans(it)%lsim(ij) .eq. 0.0) .and. (simtrans(it+1)%lsim(ij) .eq. 0.0)) THEN
                            
                                  IF(simtrans(it)%adjsim(ij) .eq. 0.0) pathEcstr5(it,ic) = pathEcstr5(it,ic) + lmask(ij)
                                  IF(simtrans(it)%adjsim(ij) .eq. 0.0 .and. simtrans(it)%asim(ij)==0.0d0) pathEcstr5noill(it,ic) = pathEcstr5noill(it,ic) - lmask(ij) 
                               
                               ENDIF
                         
                            ENDIF

                         ENDIF
                      

                      ENDDO

                   pathEliqlim(it,ic)=3.0*pathEliqlim(it,ic)/real(nsimtrans)
                   pathEliqlimapos(it,ic)=3.0*pathEliqlimapos(it,ic)/real(nsimtrans)
                   pathEcstr5(it,ic)=3.0*pathEcstr5(it,ic)/real(nsimtrans)
                   pathEcstr5noill(it,ic)=3.0*pathEcstr5noill(it,ic)/real(nsimtrans)
                ENDIF

                ELSE

                   !Nothing here



                ENDIF


             END DO

          
	!calculate aggregate transition path for different ages: 1,41,81,121,121,161,201 ...
	DO ij = 1,12
		ia = 1 + 40*(ij-1)
		IF (ia<=Jtot) THEN
			lmask = simtrans(it)%jsim==ia
			agepathEage(it,ij) = SUM(simtrans(it)%jsim,MASK=lmask)/real(COUNT(lmask))
			IF(ia<=Jwork) THEN
				agepathEinc(it,ij) = SUM(simtrans(it)%ysim,MASK=lmask)/real(COUNT(lmask))
				agepathElabinc(it,ij) = SUM(simtrans(it)%ysim,MASK=lmask .and. simtrans(it)%usimI==1)/real(count(lmask .and. simtrans(it)%usimI==1))
				IF (count(simtrans(it)%usimI==2)>0) agepathEuiben(it,ij) = SUM(simtrans(it)%ysim,MASK=lmask .and. simtrans(it)%usimI==2)/real(count(lmask .and. simtrans(it)%usimI==2))
				agepathEunemp(it,ij) = SUM(simtrans(it)%usim,MASK=lmask)/real(COUNT(lmask))
			ELSE
				agepathEinc(it,ij) = 0.0
				agepathElabinc(it,ij) = 0.0
				agepathEuiben(it,ij) = 0.0
				agepathEunemp(it,ij) = 0.0
			END IF
		
			agepathEcon(it,ij) = SUM(simtrans(it)%csim,MASK=lmask)/real(COUNT(lmask))
			agepathEsav(it,ij) = SUM(simtrans(it)%ssim,MASK=lmask)/real(COUNT(lmask))
			agepathEass(it,ij) = SUM(simtrans(it)%asim,MASK=lmask)/real(COUNT(lmask))
			agepathEliq(it,ij) = SUM(simtrans(it)%lsim,MASK=lmask)/real(COUNT(lmask))
			agepathEadjust(it,ij) = SUM(simtrans(it)%adjsim,MASK=lmask)/real(COUNT(lmask))
			agepathEcash(it,ij) = SUM(simtrans(it)%xsim,MASK=lmask)/real(COUNT(lmask))
		
			IF(ia>Jwork) THEN
				agepathEpen(it,ij) = SUM(simtrans(it)%psim, MASK=lmask) / real(COUNT(lmask))
			ELSE
				agepathEpen(it,ij) = 0.0
			END IF

		
			agepathEtax(it,ij) = SUM(simtrans(it)%taxsim,MASK=lmask)/real(COUNT(lmask))
			agepathEasspos(it,ij) = COUNT(lmask .and. simtrans(it)%asim>0.0)/real(COUNT(lmask))
			agepathEliqpos(it,ij) = COUNT(lmask .and. simtrans(it)%lsim>0.0)/real(COUNT(lmask))
			agepathEdie(it,ij) = SUM(simtrans(it)%diesimI,MASK=lmask)/real(COUNT(lmask))
			agepathErebate(it,ij) = SUM(simtrans(it)%rebsim,MASK=lmask)/real(COUNT(lmask))
		END IF

	END DO


END DO


rebateamt = DOT_PRODUCT(rebgrid,rebdist)



write(*,*) ' fraction of rebate spent t0, group A:', (pathEcon(0,2)-pathEcon(0,1))/rebateamt
write(*,*) ' fraction of rebate spent t0, group B:', (pathEcon(0,3)-pathEcon(0,1))/rebateamt

write(*,*) ' fraction of rebate spent t1, group A:', (pathEcon(1,2)-pathEcon(1,1))/rebateamt
write(*,*) ' fraction of rebate spent t1, group B:', (pathEcon(1,3)-pathEcon(1,1))/rebateamt

write(*,*) ' fraction of rebate spent t2, group A:', (pathEcon(2,2)-pathEcon(2,1))/rebateamt
write(*,*) ' fraction of rebate spent t2, group B:', (pathEcon(2,3)-pathEcon(2,1))/rebateamt

write(*,*) ' fraction of rebate spent t3, group A:', (pathEcon(3,2)-pathEcon(3,1))/rebateamt
write(*,*) ' fraction of rebate spent t3, group B:', (pathEcon(3,3)-pathEcon(3,1))/rebateamt


IF(nrebgrid .gt. 1) THEN

   OPEN(3, FILE = trim(OutputDir) // 'pathAB_het.txt', STATUS = 'replace')
   
ELSE

   OPEN(3, FILE = trim(OutputDir) // 'pathAB.txt', STATUS = 'replace')
ENDIF

write(3,*) (pathEcon(0,2)-pathEcon(0,1))/rebateamt
write(3,*) (pathEcon(0,3)-pathEcon(0,1))/rebateamt
write(3,*) (pathEcon(1,2)-pathEcon(1,1))/rebateamt
write(3,*) (pathEcon(1,3)-pathEcon(1,1))/rebateamt
write(3,*) (pathEcon(2,2)-pathEcon(2,1))/rebateamt
write(3,*) (pathEcon(2,3)-pathEcon(2,1))/rebateamt
write(3,*) (pathEcon(3,2)-pathEcon(3,1))/rebateamt
write(3,*) (pathEcon(3,3)-pathEcon(3,1))/rebateamt

CLOSE(3)
   



END SUBROUTINE AggregateTransitionPath
