SUBROUTINE AllocateArrays

USE Parameters
USE Globals

IMPLICIT NONE

ALLOCATE(initss1(nsim))
ALLOCATE(initss2(nsim))

!allocate required memory for big decision rules
IF (SolveTransition==1) THEN
	ALLOCATE(decInitialSS(1),dectrans(0:Ttransition))
	IF ((sunset==0 .and. NoChangeTaxSystem==0) .or. GovtBudgetConstraint==1) ALLOCATE(decFinalSS(1))
	IF (DoRebateCalcs==1 .and. BothRebateSurprises==0) THEN
		IF(announcequ==3) ALLOCATE(decrebateB(0:0,nrebgrid))
		IF(announcequ==2) ALLOCATE(decrebateB(0:1,nrebgrid))
		IF(announcequ==2) ALLOCATE(decrebateA(0:0,nrebgrid))
	END IF
	
ELSE IF (SolveTransition==0) THEN
	ALLOCATE(decInitialSS(1))
	IF (DoRebateCalcs==1 .and. BothRebateSurprises==0) THEN
		IF(announcequ==3) ALLOCATE(decrebateB(0:0,nrebgrid))
		IF(announcequ==2) ALLOCATE(decrebateB(0:1,nrebgrid))
		IF(announcequ==2) ALLOCATE(decrebateA(0:0,nrebgrid))
	END IF
END IF

!allocate memory for random numbers for transition
IF(SameRandomNumbersRebate == 0) THEN
	ALLOCATE(uerand(nsimtrans,0:Ttransition+Tadditionalsim))
	ALLOCATE(zyrand(nsimtrans,0:Ttransition+Tadditionalsim))
	ALLOCATE(eyrand(nsimtrans,0:Ttransition+Tadditionalsim))
	ALLOCATE(dierand(nsimtrans,0:Ttransition+Tadditionalsim))
	ALLOCATE(initliqrand(nsimtrans,0:Ttransition+Tadditionalsim))
	ALLOCATE(initillrand(nsimtrans,0:Ttransition+Tadditionalsim))
ELSE
	ALLOCATE(uerand(nsimrebateA,0:Ttransition+Tadditionalsim))
	ALLOCATE(zyrand(nsimrebateA,0:Ttransition+Tadditionalsim))
	ALLOCATE(eyrand(nsimrebateA,0:Ttransition+Tadditionalsim))
	ALLOCATE(dierand(nsimrebateA,0:Ttransition+Tadditionalsim))
	ALLOCATE(initliqrand(nsimrebateA,0:Ttransition+Tadditionalsim))
	ALLOCATE(initillrand(nsimrebateA,0:Ttransition+Tadditionalsim))
END IF

IF (DoRebateCalcs==1) THEN

    ALLOCATE(dCtp1((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(dlogCtp1((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(age_reg((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(rebamt_reg((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(rebind_reg((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(liq_reg((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(inc_reg((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(lpl_reg((2+allquarters)*(nsimrebateA+nsimrebateB)))
    ALLOCATE(tempvect((2+allquarters)*(nsimrebateA+nsimrebateB)))
    
    ALLOCATE(quarter_reg((2+allquarters)*(nsimrebateA+nsimrebateB),(2+allquarters)))
    ALLOCATE(X_reg((2+allquarters)*(nsimrebateA+nsimrebateB),(4+allquarters)))
    ALLOCATE(Z_reg((2+allquarters)*(nsimrebateA+nsimrebateB),(4+allquarters)))
        
END IF
        

END SUBROUTINE AllocateArrays
