SUBROUTINE DecisionsRebate

USE Parameters
USE Globals

IMPLICIT NONE

INTEGER	:: ir



!group A get it in 2001 qu3
!group B get it in 2001 qy2

IF (BothRebateSurprises==0) THEN	!if ==1 then no new policy functions needed
IF (announcequ==3) THEN 	!need policy fn in 2001 q3 for those getting rebate in q4 (group B)
	write(*,*) 'Solving for period 0 of rebate policy rules, group B'
	taxincr = 0.0
	taxincrN = 0.0
	IF (NoChangeTaxSystem==1) THEN
		taxsys = WhichTaxSystem
		taxsysN = WhichTaxSystem
	ELSE
		taxsys = 1
		taxsysN = 1 
	END IF
	
	IF(SolveTransition==0) THEN 
		emucnext = decInitialSS(1)%emuc
		evalnext = decInitialSS(1)%eval
		hfnnext = decInitialSS(1)%hfn

		emucretnext = decInitialSS(1)%emucret
		evalretnext = decInitialSS(1)%evalret
		hfnretnext = decInitialSS(1)%hfnret

		emucretJ1next = decInitialSS(1)%emucretJ1
		evalretJ1next = decInitialSS(1)%evalretJ1
		hfnretJ1next = decInitialSS(1)%hfnretJ1
	
	ELSE IF(SolveTransition==1) THEN 
		emucnext = dectrans(1)%emuc
		evalnext = dectrans(1)%eval
		hfnnext = dectrans(1)%hfn

		emucretnext = dectrans(1)%emucret
		evalretnext = dectrans(1)%evalret
		hfnretnext = dectrans(1)%hfnret
	
		emucretJ1next = dectrans(1)%emucretJ1
		evalretJ1next = dectrans(1)%evalretJ1
		hfnretJ1next = dectrans(1)%hfnretJ1
		
		IF(ModelRecession==1) THEN
			ygrid = MERGE((1.0-recdepthcond/real(recndrop))*holdygrid,holdygrid,ygrid .le. recylim)
			ypsgrid = MERGE((1.0-recdepthcond/real(recndrop))*holdypsgrid,holdypsgrid,ypsgrid .le. recylim)
! 			pgrid = (1.0-recdepth/real(recndrop))*holdpgrid
			pgrid = holdpgrid
		END IF
		
	END IF
	
	rebatenext = 1    
	DO ir = 1,nrebgrid
	
		rebateamt = rebgrid(ir)
        CALL DecisionsRet
        CALL Decisions

		decrebateB(0,ir)%valAret	= valAret
		decrebateB(0,ir)%assAret	= assAret
		decrebateB(0,ir)%savAret	= savAret

		decrebateB(0,ir)%valNret	= valNret
		decrebateB(0,ir)%savNret	= savNret

		decrebateB(0,ir)%valA	= valA
		decrebateB(0,ir)%assA	= assA
		decrebateB(0,ir)%savA	= savA

		decrebateB(0,ir)%valN	= valN
		decrebateB(0,ir)%savN	= savN

		decrebateB(0,ir)%evalret	= evalret
		decrebateB(0,ir)%emucret	= emucret
		decrebateB(0,ir)%hfnret		= hfnret
		decrebateB(0,ir)%dvalret	= dvalret

		decrebateB(0,ir)%evalretJ1	= evalretJ1
		decrebateB(0,ir)%emucretJ1	= emucretJ1
		decrebateB(0,ir)%hfnretJ1	= hfnretJ1

		decrebateB(0,ir)%eval	= eval
		decrebateB(0,ir)%emuc	= emuc
		decrebateB(0,ir)%hfn	= hfn
		decrebateB(0,ir)%dval	= dval
	END DO
	rebatenext = 0
	
	
ELSE IF (announcequ==2) THEN !need policy fn in 2001 q2 for those getting rebate in q3 (group A), and in q3,q3 for those getting rebate in q4 (group B)
	taxincr = 0.0
	taxincrN = 0.0

	IF (NoChangeTaxSystem==1) THEN
		taxsys = WhichTaxSystem
		taxsysN = WhichTaxSystem
	ELSE
		taxsys = 1
		taxsysN = 1 
	END IF
	
	!Group A
	write(*,*) 'Solving for period 0 of rebate policy rules, group A'

	IF(SolveTransition==0) THEN 
		emucnext = decInitialSS(1)%emuc
		evalnext = decInitialSS(1)%eval
		hfnnext = decInitialSS(1)%hfn

		emucretnext = decInitialSS(1)%emucret
		evalretnext = decInitialSS(1)%evalret
		hfnretnext = decInitialSS(1)%hfnret

		emucretJ1next = decInitialSS(1)%emucretJ1
		evalretJ1next = decInitialSS(1)%evalretJ1
		hfnretJ1next = decInitialSS(1)%hfnretJ1
	ELSE IF(SolveTransition==1) THEN 
		emucnext = dectrans(1)%emuc
		evalnext = dectrans(1)%eval
		hfnnext = dectrans(1)%hfn

		emucretnext = dectrans(1)%emucret
		evalretnext = dectrans(1)%evalret
		hfnretnext = dectrans(1)%hfnret

		emucretJ1next = dectrans(1)%emucretJ1
		evalretJ1next = dectrans(1)%evalretJ1
		hfnretJ1next = dectrans(1)%hfnretJ1
		
		IF(ModelRecession==1) THEN
			ygrid = MERGE((1.0-recdepthcond/real(recndrop))*holdygrid,holdygrid,ygrid .le. recylim)
			ypsgrid = MERGE((1.0-recdepthcond/real(recndrop))*holdypsgrid,holdypsgrid,ypsgrid .le. recylim)
! 			pgrid = (1.0-recdepth/real(recndrop))*holdpgrid
			pgrid = holdpgrid
		END IF
		
	END IF

	rebatenext = 1    
	DO ir = 1,nrebgrid


		rebateamt = rebgrid(ir)
		CALL DecisionsRet
		CALL Decisions

		decrebateA(0,ir)%valAret	= valAret
		decrebateA(0,ir)%assAret	= assAret
		decrebateA(0,ir)%savAret	= savAret

		decrebateA(0,ir)%valNret	= valNret
		decrebateA(0,ir)%savNret	= savNret

		decrebateA(0,ir)%valA	= valA
		decrebateA(0,ir)%assA	= assA
		decrebateA(0,ir)%savA	= savA

		decrebateA(0,ir)%valN	= valN
		decrebateA(0,ir)%savN	= savN

		decrebateA(0,ir)%evalret	= evalret
		decrebateA(0,ir)%emucret	= emucret
		decrebateA(0,ir)%hfnret		= hfnret
		decrebateA(0,ir)%dvalret	= dvalret

		decrebateA(0,ir)%evalretJ1	= evalretJ1
		decrebateA(0,ir)%emucretJ1	= emucretJ1
		decrebateA(0,ir)%hfnretJ1	= hfnretJ1

		decrebateA(0,ir)%eval	= eval
		decrebateA(0,ir)%emuc	= emuc
		decrebateA(0,ir)%hfn	= hfn
		decrebateA(0,ir)%dval	= dval
	END DO
	rebatenext = 0
	
	!Group B
	write(*,*) 'Solving for period 1 of rebate policy rules, group B'

	IF(SolveTransition==0) THEN 
		emucnext = decInitialSS(1)%emuc
		evalnext = decInitialSS(1)%eval
		hfnnext = decInitialSS(1)%hfn

		emucretnext = decInitialSS(1)%emucret
		evalretnext = decInitialSS(1)%evalret
		hfnretnext = decInitialSS(1)%hfnret

		emucretJ1next = decInitialSS(1)%emucretJ1
		evalretJ1next = decInitialSS(1)%evalretJ1
		hfnretJ1next = decInitialSS(1)%hfnretJ1
	ELSE IF(SolveTransition==1) THEN 

		emucnext = dectrans(2)%emuc
		evalnext = dectrans(2)%eval
		hfnnext = dectrans(2)%hfn

		emucretnext = dectrans(2)%emucret
		evalretnext = dectrans(2)%evalret
		hfnretnext = dectrans(2)%hfnret

		emucretJ1next = dectrans(2)%emucretJ1
		evalretJ1next = dectrans(2)%evalretJ1
		hfnretJ1next = dectrans(2)%hfnretJ1
		IF(ModelRecession==1) THEN
			ygrid = MERGE((1.0-2.0*recdepthcond/real(recndrop))*holdygrid,holdygrid,ygrid .le. recylim)
			ypsgrid = MERGE((1.0-2.0*recdepthcond/real(recndrop))*holdypsgrid,holdypsgrid,ypsgrid .le. recylim)
			pgrid = holdpgrid
! 			pgrid = (1.0-2.0*recdepth/real(recndrop))*holdpgrid
		END IF
		
	END IF
	
	DO ir = 1,nrebgrid

		rebatenext = 1    
		rebateamt = rebgrid(ir)
		CALL DecisionsRet
		CALL Decisions

		rebatenext = 0
	
		decrebateB(1,ir)%valAret	= valAret
		decrebateB(1,ir)%assAret	= assAret
		decrebateB(1,ir)%savAret	= savAret

		decrebateB(1,ir)%valNret	= valNret
		decrebateB(1,ir)%savNret	= savNret

		decrebateB(1,ir)%valA	= valA
		decrebateB(1,ir)%assA	= assA
		decrebateB(1,ir)%savA	= savA

		decrebateB(1,ir)%valN	= valN
		decrebateB(1,ir)%savN	= savN

		decrebateB(1,ir)%evalret	= evalret
		decrebateB(1,ir)%emucret	= emucret
		decrebateB(1,ir)%hfnret		= hfnret
		decrebateB(1,ir)%dvalret	= dvalret

		decrebateB(1,ir)%evalretJ1	= evalretJ1
		decrebateB(1,ir)%emucretJ1	= emucretJ1
		decrebateB(1,ir)%hfnretJ1	= hfnretJ1

		decrebateB(1,ir)%eval	= eval
		decrebateB(1,ir)%emuc	= emuc
		decrebateB(1,ir)%hfn	= hfn
		decrebateB(1,ir)%dval	= dval

		write(*,*) 'Solving for period 0 of rebate policy rules, group B'
		emucnext = decrebateB(1,ir)%emuc
		evalnext = decrebateB(1,ir)%eval
		hfnnext = decrebateB(1,ir)%hfn

		emucretnext = decrebateB(1,ir)%emucret
		evalretnext = decrebateB(1,ir)%evalret
		hfnretnext = decrebateB(1,ir)%hfnret

		emucretJ1next = decrebateB(1,ir)%emucretJ1
		evalretJ1next = decrebateB(1,ir)%evalretJ1
		hfnretJ1next = decrebateB(1,ir)%hfnretJ1

		IF(ModelRecession==1) THEN
			ygrid = MERGE((1.0-recdepthcond/real(recndrop))*holdygrid,holdygrid,ygrid .le. recylim)
			ypsgrid = MERGE((1.0-recdepthcond/real(recndrop))*holdypsgrid,holdypsgrid,ypsgrid .le. recylim)
	! 		pgrid = (1.0-recdepth/real(recndrop))*holdpgrid
			pgrid = holdpgrid
		END IF

		rebatenext = 0
		CALL DecisionsRet
		CALL Decisions
		decrebateB(0,ir)%valAret	= valAret
		decrebateB(0,ir)%assAret	= assAret
		decrebateB(0,ir)%savAret	= savAret

		decrebateB(0,ir)%valNret	= valNret
		decrebateB(0,ir)%savNret	= savNret

		decrebateB(0,ir)%valA	= valA
		decrebateB(0,ir)%assA	= assA
		decrebateB(0,ir)%savA	= savA

		decrebateB(0,ir)%valN	= valN
		decrebateB(0,ir)%savN	= savN

		decrebateB(0,ir)%evalret	= evalret
		decrebateB(0,ir)%emucret	= emucret
		decrebateB(0,ir)%hfnret		= hfnret
		decrebateB(0,ir)%dvalret	= dvalret

		decrebateB(0,ir)%evalretJ1	= evalretJ1
		decrebateB(0,ir)%emucretJ1	= emucretJ1
		decrebateB(0,ir)%hfnretJ1	= hfnretJ1

		decrebateB(0,ir)%eval	= eval
		decrebateB(0,ir)%emuc	= emuc
		decrebateB(0,ir)%hfn	= hfn
		decrebateB(0,ir)%dval	= dval
	END DO
END IF
END IF


IF(ModelRecession==1) THEN
	ygrid = holdygrid
	ypsgrid = holdypsgrid
	pgrid = holdpgrid
END IF


END SUBROUTINE DecisionsRebate
