SUBROUTINE DecisionsRet

USE Parameters
USE Globals
USE Procedures
! use omp_lib

IMPLICIT NONE

INTEGER		:: iRl,ip,io,nlocopt,ibestopt(1),nsoln,is,ided,ibestded(1),iRliq,ipl
REAL(8)		:: lxN,lass,lcon,lmuc,ldval,lval,lhfn,lxa,lxb,clocopt(2*nbrackets+2),alocopt(2*nbrackets+2),slocopt(2*nbrackets+2),vlocopt(2*nbrackets+2),hlocopt(2*nbrackets+2),llocopt(2*nbrackets+2),lvalded(ngpdret),jlocopt(2*nbrackets+2)
REAL(8), EXTERNAL	:: FnBondPrice, FnBondPriceD, FnTax, FnValAssChoiceRet, FnNoAdjEERet, FnEERet,FnInvQA,FnPortfolioRet
REAL(8)				:: xb1(nbrackets),xb2(nbrackets),fb1(nbrackets),fb2(nbrackets)


DO gij = Jret,1,-1
	if (Display>=1) write(*,*) 'Solving for decision rules at age ', Jwork+gij				

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	!! CHOICE SPECIFIC DECISION RULES !!
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SELECT CASE(gij)

	CASE(Jret) 	!FINAL PERIOD

		assAret(Jret,:,:,:) = 0.0_8
		liqAret(Jret,:,:,:) = 0.0_8
		savAret(Jret,:,:,:) = 0.0_8
		liqNret(Jret,:,:,:,:) = 0.0_8
		savNret(Jret,:,:,:,:) = 0.0_8

		!$OMP PARALLEL DO COPYIN(gij) PRIVATE(ibestded,lvalded,lxA)
		DO giR = 1,ngpR
			gip = pRind(giR)

			!adjust
			gadjcost = fixcost + varcost*pgrid(Jwork+gij,gip)
			gutilcost = -log(1-utilcost)	!with - it is a positive number, so we subtract it below
			
			DO gix = 1,ngpxAret
			DO gid = 1,ngpdret	!coice
				IF (xAgridret(gij,gix,gip)-gadjcost .le. 0.0) THEN
					conAret(gij,gix,gid,giR) = cmin
				ELSE 
					conAret(gij,gix,gid,giR) = (xAgridret(gij,gix,gip)-gadjcost) / (1.0+ctax)				
				END IF
				IF(sigC .ne. 1.0) valAret(gij,gix,gid,giR) = ((1.0-bet)**(1.0/(1.0-sigC)))*conAret(gij,gix,gid,giR) - gutilcost
				IF(sigC == 1.0) valAret(gij,gix,gid,giR) = conAret(gij,gix,gid,giR)**(1.0-bet) - gutilcost
			END DO
			END DO
			
			!not adjust
			DO gix = 1,ngpxNret
			DO gia = 1,ngparet
			DO gid = 1,ngpdret !state
			
				conNret(gij,gix,gia,gid,giR) = xNgridret(gij,gix,gia,gip,gid)/ (1.0+ctax)
				IF(sigC .ne. 1.0) valNret(gij,gix,gia,gid,giR) = ((1.0-bet)**(1.0/(1.0-sigC)))*conNret(gij,gix,gia,gid,giR)
				IF(sigC == 1.0) valNret(gij,gix,gia,gid,giR) = conNret(gij,gix,gia,gid,giR)**(1.0-bet)
				mucNret(gij,gix,gia,gid,giR) = conNret(gij,gix,gia,gid,giR)**(-sigC) 
				gfnret(gij,gix,gia,gid,giR) = 0.0_8 !assumes no service flow in last period of life
			END DO
			END DO
			END DO
		
			!work out adjustment
			DO gix = 1,ngpxNret	
			DO gia = 1,ngparet
			DO gid = 1,ngpdret !state
				!choose best deduction if adjust
				DO gidn = 1,ngpdret
					lxA = xNgridret(gij,gix,gia,gip,gid) + agridret(gij,gia,gip) - dgridret(gid)*agridret(gij,gia,gip)
					CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),valAret(gij,:,gidn,giR),lxA,lvalded(gidn))					
				END DO				 
				ibestded = maxloc(lvalded(:))
				dvalret(gij,gix,gia,gid,giR) = lvalded(ibestded(1)) - valNret(gij,gix,gia,gid,giR)
				END DO
			END DO
			END DO
		END DO
		!$OMP END PARALLEL DO
	
	CASE(1:Jret-1)	!RETIRED AGENTS
	
	    !$OMP PARALLEL DO PRIVATE(lxa,lxb,lass,lval,lhfn,nlocopt,clocopt,alocopt,slocopt,llocopt,vlocopt,hlocopt,ibestopt,ibestded,lvalded,io,xb1,xb2,fb1,fb2,nsoln,is) COPYIN(gij)
		DO giR = 1,ngpR
			gip = pRind(giR)

			!!!! ADJUST ILLIQUID ASSETS !!!!
			gadjcost = fixcost + varcost*pgrid(Jwork+gij,gip)
			gutilcost = -log(1-utilcost)	!with - it is a positive number, so we subtract it below
		
			DO gix = 1,ngpxAret !could combine with iR and parallelize
			DO gid = 1,ngpdret	!choice of j+1 deduction
				
				gcoh = xAgridret(gij,gix,gip) - gadjcost
				gsavmax = min(gcoh - cmin*(1.0+ctax),lmax+amax)	!this needs more thought
				gsavmin = 0.0
				gliqmin = 0.0	
			
				IF(gcoh<=gsavmin) THEN !fixed cost might make it infeasible
					lval  = 1.0e-20
					gcon = cmin*(1.0+ctax)
					conAret(gij,gix,gid,giR) = gcon
					valAret(gij,gix,gid,giR) = EZAGG(gcon,lval) - gutilcost
					GO TO 20
				END IF
				
				nlocopt = 0

				!1. check for local min at constrained liquid 
				IF (FnEERet(gsavmin) .ge. 0.0) THEN	!both constrained
					nlocopt  = nlocopt+1
					clocopt(nlocopt) = (gcoh-gsavmin)/(1.0+ctax)
					alocopt(nlocopt) = 0.0
					slocopt(nlocopt) = gsavmin
					llocopt(nlocopt) = gliqmin				
					jlocopt(nlocopt) = 1.0				
				END IF
				
				
				!2. check for solution with sav>0.0 and positive liquid
				IF (gsavmax>0.0) THEN
					lxa = 1.0e-4!10
					lxb = gsavmax
					IF(FnEERet(lxb)<=0.0) THEN	!upper bound binds
						IF (gliq>10.0*bisxtol) THEN
							nlocopt  = nlocopt+1
							gsav = gsavmax
							clocopt(nlocopt) = gcon
							alocopt(nlocopt) = gass
							slocopt(nlocopt) = gsav
							llocopt(nlocopt) = gliq			
							jlocopt(nlocopt) = 2.5				
						END IF
					ELSE IF (FnEERet(lxb)>0.0 .and. FnEERet(lxa)<0.0) THEN		 ! use zbrak to search for regions containing multiple local optima and compare values
						CALL zbrak(FnEERet,lxa,lxb,nbrackets,xb1,xb2,fb1,fb2,nsoln)
						IF(nsoln>=1) THEN
							DO is = 1,nsoln
							IF(fb2(is)>fb1(is)) THEN 	!SOC holds, possible solution: 2nd derivative positive in a'
								lxa = xb1(is)
								lxb = xb2(is)
								CALL rtbis(FnEERet,lxa,lxb,bisxtol,bisftol,gsav)
								IF (gliq>10.0*bisxtol) THEN
									nlocopt  = nlocopt+1
									clocopt(nlocopt) = gcon
									alocopt(nlocopt) = gass
									slocopt(nlocopt) = gsav
									llocopt(nlocopt) = gliq
									jlocopt(nlocopt) = 2.0	
								END IF
							END IF
							END DO
						END IF
					END IF
				END IF				
				
				
				!3. check for solution with sav>0.0 and zero liquid
				IF (gsavmax>0.0) THEN
					lxa = 0.0
					lxb = gsavmax/qill
					gUsePortfolioAsEE = 1
					IF (FnPortfolioRet(lxb)<=0.0) THEN !upper bound binds
						nlocopt  = nlocopt+1
						gsav = gsavmax
						clocopt(nlocopt) = gcon
						alocopt(nlocopt) = gass
						slocopt(nlocopt) = gsav
						llocopt(nlocopt) = gliq		
						jlocopt(nlocopt) = 3.5																			
					ELSE  ! use zbrak to search for regions containing multiple local optima and compare values
						CALL zbrak(FnPortfolioRet,lxa,lxb,nbrackets,xb1,xb2,fb1,fb2,nsoln)
						IF(nsoln>=1) THEN
							DO is = 1,nsoln
! 								IF(fb2(is)<fb1(is)) THEN 	!SOC holds, possible solution: 2nd derivative positive in a'
									nlocopt = nlocopt +1
									lxa = xb1(is)
									lxb = xb2(is)
									CALL rtbis(FnPortfolioRet,lxa,lxb,bisxtol,bisftol,gass)
									clocopt(nlocopt) = gcon
									alocopt(nlocopt) = gass
									slocopt(nlocopt) = gsav
									llocopt(nlocopt) = gliq
									jlocopt(nlocopt) = 3.0													
! 								END IF 
							END DO
						END IF
					END IF
					gUsePortfolioAsEE = 0						
				END IF				
				
				!4. explicitly check for soution with sav>0.0 and zero illiquid
				IF (gsavmax>0.0) THEN
					lxa = 1.0e-10_8
					lxb = gsavmax
					gImposeA0inEE = 1
					IF (FnEERet(lxa)<0.0 .and. FnEERet(lxb)>0.0) THEN		! use zbrak to search for regions containing multiple local optima and compare values
						CALL zbrak(FnEERet,lxa,lxb,nbrackets,xb1,xb2,fb1,fb2,nsoln)
						IF(nsoln>=1) THEN
							DO is = 1,nsoln
								IF(fb2(is)>fb1(is)) THEN 	!SOC holds, possible solution: 2nd derivative positive in a'
									nlocopt = nlocopt +1
									lxa = xb1(is)
									lxb = xb2(is)
									CALL rtbis(FnEERet,lxa,lxb,bisxtol,bisftol,gsav)
									clocopt(nlocopt) = gcon
									alocopt(nlocopt) = gass
									slocopt(nlocopt) = gsav
									llocopt(nlocopt) = gliq
	 							END IF 
							END DO
						END IF
					END IF				
					gImposeA0inEE = 0
				END IF

				IF (nlocopt==0) THEN
					if (Display>=1) write(*,*) 'no solutions to FOC found'

				ELSE IF (nlocopt>=1) THEN
					!calculate value at each local optimum
	! 				if (Display==1) write(*,*) 'number of solutions to FOCs is: ',nlocopt
					DO io = 1,nlocopt
						gass = alocopt(io)
						gliq = llocopt(io) + rebateamt*rebatenext																		
						IF(Display >=1 .and. (gass<agridret(gij+1,1,gip) .or. gliq <lgridret(gij+1,1,gip))) write(*,*) 'trying to extrapolate out of range (adjust)'
						CALL Bi45DegInterp1(ngplret,lgridret(gij+1,:,gip),ngparet,agridret(gij+1,:,gip),evalretnext(gij+1,:,:,gid,giR),gliq,gass,lval,1)							
						vlocopt(io) = EZAGG(clocopt(io)+servflow*gass+liqflow*llocopt(io),lval)
				
					END DO !io
					ibestopt = maxloc(vlocopt(1:nlocopt))

					conAret(gij,gix,gid,giR) = clocopt(ibestopt(1))
					savAret(gij,gix,gid,giR) = slocopt(ibestopt(1))
					assAret(gij,gix,gid,giR) = alocopt(ibestopt(1))
					liqAret(gij,gix,gid,giR) = llocopt(ibestopt(1))
					valAret(gij,gix,gid,giR) = vlocopt(ibestopt(1)) - gutilcost
					
					!adjust for tolerance level in  bisection
					IF (abs(liqAret(gij,gix,gid,giR))<bisxtol*10.0) liqAret(gij,gix,gid,giR) = 0.0
					IF (abs(assAret(gij,gix,gid,giR))<bisxtol*10.0) assAret(gij,gix,gid,giR) = 0.0
					IF (abs(savAret(gij,gix,gid,giR))<bisxtol*10.0) savAret(gij,gix,gid,giR) = 0.0
										
				END IF
	
20				lval = lval
			END DO !gid
			END DO !gix
			 		
	
			!!!! DO NOT ADJUST ILLIQUID ASSETS !!!!

			DO gix = 1,ngpxNret
			DO gia = 1,ngparet
			DO gid = 1,ngpdret !current deduction

				gass = agridret(gij,gia,gip)*(1.0-dgridret(gid))/qill
				gcoh = xNgridret(gij,gix,gia,gip,gid)

				gsavmin = 0.0	!for working years, this comes from abl
				gliqmin = 0.0	!for working will use abl
				gsavmax = min(gcoh - cmin*(1.0+ctax),lmax)
				nlocopt = 0

				IF(gsavmin>=gsavmax) THEN !might be infeasible due to taxes on illiquid assets: we will make sure he never goes there
					gsav = gsavmin
					gcon = cmin*(1.0+ctax)
					gliq = FnInvQA(gsav,0.0_8)
					nlocopt  = nlocopt+1
					clocopt(nlocopt) = gcon
					slocopt(nlocopt) = gsav
					llocopt(nlocopt) = gliq
					GO TO 60			
				END IF
			
				!1. check for binding borrowing constraint
				IF(FnNoAdjEERet(gsavmin)>=0.0) THEN	
					gsav = gsavmin
					gcon = (gcoh-gsav)/(1.0+ctax)
					gliq = FnInvQA(gsav,0.0_8)
					nlocopt  = nlocopt+1
					clocopt(nlocopt) = gcon
					slocopt(nlocopt) = gsav
					llocopt(nlocopt) = gliq				
	
				END IF

				!2. not borrowng constrained, upper bound binds
				IF(FnNoAdjEERet(gsavmax)<=0.0) THEN
					gsav = gsavmax
					gcon = (gcoh-gsav)/(1.0+ctax)
					gliq = FnInvQA(gsav,0.0_8)
					nlocopt  = nlocopt+1
					clocopt(nlocopt) = gcon
					slocopt(nlocopt) = gsav
					llocopt(nlocopt) = gliq				
	
				END IF


				!3. positive interior solution 
				IF (gsavmax>0.0) THEN
					lxa = 0.0_8
					lxb = gsavmax
					CALL zbrak(FnNoAdjEERet,lxa,lxb,nbrackets,xb1,xb2,fb1,fb2,nsoln)
					IF(nsoln>=1) THEN
						DO is = 1,nsoln
							lxa = xb1(is)
							lxb = xb2(is)
							CALL rtbis(FnNoAdjEERet,lxa,lxb,bisxtol,bisftol,gsav)
							IF (gliq>10.0*bisxtol) THEN
								nlocopt  = nlocopt+1
								clocopt(nlocopt) = gcon
								slocopt(nlocopt) = gsav
								llocopt(nlocopt) = gliq
							END IF
						END DO
					END IF
				END IF


60				IF (nlocopt==0) THEN
								
					if (Display==1) write(*,*) 'no solutions to FOC found (no adjust)'				
				ELSE IF (nlocopt>=1) THEN
					!calculate value at each local optimum
					DO io = 1,nlocopt
						gliq = llocopt(io) + rebateamt*rebatenext

						IF(Display>=1 .and. (gass<agridret(gij+1,1,gip) .or. gliq <lgridret(gij+1,1,gip))) write(*,*) 'trying to extrapolate out of range (no adjust)'

						CALL Bi45DegInterp1(ngplret,lgridret(gij+1,:,gip),ngparet,agridret(gij+1,:,gip),evalretnext(gij+1,:,:,gid,giR),gliq,gass,lval,1)							
						CALL Bi45DegInterp1(ngplret,lgridret(gij+1,:,gip),ngparet,agridret(gij+1,:,gip),hfnretnext(gij+1,:,:,gid,giR),gliq,gass,lhfn,0)							

						vlocopt(io) = EZAGG(clocopt(io) + servflow*gass + liqflow*llocopt(io),lval)
						hlocopt(io) = lhfn
					
					END DO !io
				
					ibestopt = maxloc(vlocopt(1:nlocopt))
					conNret(gij,gix,gia,gid,giR) = clocopt(ibestopt(1))
					savNret(gij,gix,gia,gid,giR) = slocopt(ibestopt(1))
					liqNret(gij,gix,gia,gid,giR) = llocopt(ibestopt(1))
					valNret(gij,gix,gia,gid,giR) = vlocopt(ibestopt(1))
					mucNret(gij,gix,gia,gid,giR) = (clocopt(ibestopt(1))+servflow*gass+liqflow*llocopt(ibestopt(1)))**(-sigC)
					gfnret(gij,gix,gia,gid,giR)  = (bet/qill)*hlocopt(ibestopt(1)) + servflow*mucNret(gij,gix,gia,gid,giR)/qill

				END IF

				!adjust for tolerance level in  bisection
				IF (abs(liqNret(gij,gix,gia,gid,giR))<bisxtol*10.0) liqNret(gij,gix,gia,gid,giR) = 0.0
				IF (abs(savNret(gij,gix,gia,gid,giR))<bisxtol*10.0) savNret(gij,gix,gia,gid,giR) = 0.0
		
			END DO	!gid
			END DO	!gia
			END DO	!gix
			
			!work out adjustment
			DO gix = 1,ngpxNret	
			DO gia = 1,ngparet
			DO gid = 1,ngpdret !state
				!choose best deduction if adjust
				DO gidn = 1,ngpdret
					lxA = xNgridret(gij,gix,gia,gip,gid) + agridret(gij,gia,gip) - dgridret(gid)*agridret(gij,gia,gip)
					CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),valAret(gij,:,gidn,giR),lxA,lvalded(gidn))					
				END DO				 
				ibestded = maxloc(lvalded(:))
				dvalret(gij,gix,gia,gid,giR) = lvalded(ibestded(1)) - valNret(gij,gix,gia,gid,giR)
			END DO
			END DO
			END DO
	
		END DO !giR
		!$OMP END PARALLEL DO

	END SELECT


	!!!!!!!!!!!!!!!!!!!!
	!! EMAX FUNCTIONS !!
	!!!!!!!!!!!!!!!!!!!!

	SELECT CASE(gij)
	CASE(2:Jret)

		!$OMP PARALLEL DO PRIVATE(iRl,ided,ibestded,lxA,lxN,lass,lcon,lmuc,ldval,lval,lhfn,lvalded) COPYIN(gij)
		DO iRliq = 1,ngpR*ngplret
		
			iRL = RfromRl(iRliq)
			gil = lfromRl(iRliq)
			gip = pRind(iRl)

			DO gia = 1,ngparet
			DO gid = 1,ngpdret !current period deduction, relevant for N. The one for A choice will be maxed over.
				gded = dgridret(gid)
				lass = agridret(gij,gia,gip) 

				evalret(gij,gil,gia,gid,iRl) = 0.0
				emucret(gij,gil,gia,gid,iRl) = 0.0
				hfnret(gij,gil,gia,gid,iRl) = 0.0
		
				giR = Rind(gip)
				lxN = lgridret(gij,gil,gip) + pgrid(Jwork + gij,gip) -FnTax(taxsysN,pgrid(Jwork+gij,gip),0,0,taxincrN) - mturcg*lass + dgridret(gid)*lass
				lxA = lgridret(gij,gil,gip) + pgrid(Jwork + gij,gip) -FnTax(taxsysN,pgrid(Jwork+gij,gip),0,0,taxincrN) - mturcg*lass + lass 

					
				!adjustment decision 
				IF(UsePosNegDvalInterp==0) CALL	BiLinInterp1RatioXAret (ngpxNret,xNgridret(gij,:,:,gip,gid),ngpa,agridret(gij,:,gip),dvalret(gij,:,:,gid,giR),lxN,lass,ldval)
		
				IF(ldval>=0.0) THEN!ADJUST
					IF (lxA==xAgridret(gij,1,gip)) THEN
						ibestded 	= maxloc(valAret(gij,1,:,giR))
						ided 	= ibestded(1)
						lval	= valAret(gij,1,ided,giR)
						lcon	= conAret(gij,1,ided,giR)
						gass	= assAret(gij,1,ided,giR)
						gliq	= liqAret(gij,1,ided,giR)
					ELSE
						DO ided = 1,ngpdret
							CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),valAret(gij,:,ided,giR),lxA,lvalded(ided))
						END DO
						ibestded = maxloc(lvalded)
						ided = ibestded(1)
						lval = lvalded(ided)							
						CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),conAret(gij,:,ided,giR),lxA,lcon)
						CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),assAret(gij,:,ided,giR),lxA,gass)
						CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),liqAret(gij,:,ided,giR),lxA,gliq)
						
					END IF
					lmuc	= (lval**(sigC-gamC)) * (lcon+servflow*gass+liqflow*gliq)**(-sigC) 
					lhfn	= (1.0-mturcg)*lmuc
					
				ELSE !DO NOT ADJUST
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),valNret(gij,:,:,gid,giR),lxN,lass,lval)			
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),conNret(gij,:,:,gid,giR),lxN,lass,lcon)			
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),gfnret(gij,:,:,gid,giR),lxN,lass,lhfn)			
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),liqNret(gij,:,:,gid,giR),lxN,lass,gliq)			
		
					IF(Display>=1) THEN						
						IF(lval<0.0) write(*,*)'positive lval'
						IF(lcon<0.0) write(*,*)'negative lcon'
					END IF
					lmuc	= (lval**(sigC-gamC)) * (lcon+servflow*lass/qill+liqflow*gliq)**(-sigC)
					lhfn 	= (lval**(sigC-gamC)) * lhfn - lmuc*mturcg
					
				END IF
				 
				emucret(gij,gil,gia,gid,iRl) = emucret(gij,gil,gia,gid,iRl) + lmuc
				hfnret(gij,gil,gia,gid,iRl) = hfnret(gij,gil,gia,gid,iRl) + lhfn
				IF(gamC .ne. 1.0) evalret(gij,gil,gia,gid,iRl) = evalret(gij,gil,gia,gid,iRl) + lval**(1.0-gamC)
				IF(gamC == 1.0) evalret(gij,gil,gia,gid,iRl) = evalret(gij,gil,gia,gid,iRl) + log(lval)

			END DO !id
			END DO !ia
			
		END DO !iRl x gil
		!$OMP END PARALLEL DO
		
		IF(gamC .ne. 1.0) evalret(gij,:,:,:,:) = evalret(gij,:,:,:,:)**(1.0/(1.0-gamC))
		IF(gamC == 1.0) evalret(gij,:,:,:,:) = exp(evalret(gij,:,:,:,:))
		emucret(gij,:,:,:,:) = emucret(gij,:,:,:,:) * (evalret(gij,:,:,:,:)**(gamC-sigC))
		hfnret(gij,:,:,:,:) = hfnret(gij,:,:,:,:) * (evalret(gij,:,:,:,:)**(gamC-sigC))

		IF(TransitionPath == .false.) THEN
			emucretnext(gij,:,:,:,:) = emucret(gij,:,:,:,:)
			evalretnext(gij,:,:,:,:) = evalret(gij,:,:,:,:)
			hfnretnext(gij,:,:,:,:) = hfnret(gij,:,:,:,:)
		END IF

	CASE(1)	!first retirement period has slightly different state variables 
 
		!$OMP PARALLEL DO PRIVATE(ip,ided,ibestded,lxA,lxN,lass,lcon,lmuc,ldval,lval,lhfn,lvalded) COPYIN(gij)
		DO ipl = 1,ngpp*ngplret !need to get medical fixed effect
			ip = pfromplret(ipl)
			gip = ip
			gil = lfromplret(ipl)
			
			DO gia = 1,ngparet
			DO gid = 1,ngpdret

				gded = dgridret(gid)
				lass = agridret(gij,gia,gip) 

				evalretJ1(gil,gia,gid,gip) = 0.0
				emucretJ1(gil,gia,gid,gip) = 0.0
				hfnretJ1(gil,gia,gid,gip) = 0.0

				giR = Rind(gip)
				lxN = lgridret(gij,gil,gip) + pgrid(Jwork + gij,gip) -FnTax(taxsysN,pgrid(Jwork+gij,gip),0,0,taxincrN) - mturcg*lass + dgridret(gid)*lass
				lxA = lgridret(gij,gil,gip) + pgrid(Jwork + gij,gip) -FnTax(taxsysN,pgrid(Jwork+gij,gip),0,0,taxincrN) - mturcg*lass + lass 

				!adjustment decision
! 				IF(UsePosNegDvalInterp==1) CALL BiPosNegInterp1RatioXAret (nx,x,na,a,f,xi,ai,fi)
				IF(UsePosNegDvalInterp==0) CALL	BiLinInterp1RatioXAret (ngpxNret,xNgridret(gij,:,:,gip,gid),ngpa,agridret(gij,:,gip),dvalret(gij,:,:,gid,giR),lxN,lass,ldval)

				IF(ldval>=0.0) THEN!ADJUST
					IF (lxA==xAgridret(gij,1,gip)) THEN
						ibestded 	= maxloc(valAret(gij,1,:,giR))
						ided 	= ibestded(1)
						lval	= valAret(gij,1,ided,giR)
						lcon	= conAret(gij,1,ided,giR)
						gass	= assAret(gij,1,ided,giR)
						gliq	= liqAret(gij,1,ided,giR)
					ELSE
						DO ided = 1,ngpdret
							CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),valAret(gij,:,ided,giR),lxA,lvalded(ided))
						END DO
						ibestded = maxloc(lvalded)
						ided = ibestded(1)
						lval = lvalded(ided)							
						CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),conAret(gij,:,ided,giR),lxA,lcon)
						CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),assAret(gij,:,ided,giR),lxA,gass)
						CALL LinInterp1(ngpxAret,xAgridret(gij,:,gip),liqAret(gij,:,ided,giR),lxA,gliq)
					END IF
					lmuc	= (lval**(sigC-gamC)) *((lcon+servflow*gass+liqflow*gliq)**(-sigC)) 
					lhfn	= (1.0-mturcg)*lmuc
	
				ELSE !DO NOT ADJUST
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),valNret(gij,:,:,gid,giR),lxN,lass,lval)			
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),conNret(gij,:,:,gid,giR),lxN,lass,lcon)			
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),gfnret(gij,:,:,gid,giR),lxN,lass,lhfn)			
					CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(gij,:,:,gip,gid),ngparet,agridret(gij,:,gip),liqNret(gij,:,:,gid,giR),lxN,lass,gliq)			

					IF(Display>=1) THEN						
						IF(lval<0.0) write(*,*)'positive lval'
						IF(lcon<0.0) write(*,*)'negative lcon'
					END IF
					lmuc	= (lval**(sigC-gamC)) * ((lcon+servflow*lass/qill+liqflow*gliq)**(-sigC))
					lhfn 	= (lval**(sigC-gamC)) * lhfn - lmuc*mturcg
	
				END IF

				IF(gamC .ne. 1.0)  evalretJ1(gil,gia,gid,gip) = evalretJ1(gil,gia,gid,gip) + lval**(1.0-gamC)
				IF(gamC == 1.0)  evalretJ1(gil,gia,gid,gip) = evalretJ1(gil,gia,gid,gip) + log(lval)
				emucretJ1(gil,gia,gid,gip) = emucretJ1(gil,gia,gid,gip) + lmuc
				hfnretJ1(gil,gia,gid,gip) = hfnretJ1(gil,gia,gid,gip) + lhfn


			END DO !id
			END DO !ia

		END DO !ip*gil
		!$OMP END PARALLEL DO

		IF(gamC .ne. 1.0) evalretJ1(:,:,:,:) = evalretJ1(:,:,:,:)**(1.0/(1.0-gamC))
		IF(gamC == 1.0) evalretJ1(:,:,:,:) = exp(evalretJ1(:,:,:,:))
		emucretJ1(:,:,:,:) = emucretJ1(:,:,:,:) * (evalretJ1(:,:,:,:)**(gamC-sigC))
		hfnretJ1(:,:,:,:) = hfnretJ1(:,:,:,:) * (evalretJ1(:,:,:,:)**(gamC-sigC))
		
		IF(TransitionPath == .false.) THEN
			emucretJ1next(:,:,:,:) = emucretJ1(:,:,:,:)
			evalretJ1next(:,:,:,:) = evalretJ1(:,:,:,:)
			hfnretJ1next(:,:,:,:) = hfnretJ1(:,:,:,:)
		END IF
		
	END SELECT

! write(*,*) sum(valAret(gij,:,:))
! write(*,*) sum(valNret(gij,:,:,:))

END DO	!j: age




END SUBROUTINE DecisionsRet
