REAL(8) FUNCTION FnBeta(lbet)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lbet
REAL(8)             :: lcapital,lincome
REAL(8)				:: UsualKY,MeanIlliquid,MedianIlliquid,P75Illiquid

bet = lbet
write(*,*) '*******************************************'
write(*,*) ' Beta guess: 	',bet

CALL DecisionsRet
CALL Decisions
CALL Simulate

    IF (InfiniteFixedCostModel==0) MeanIlliquid=SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize)/(real(nsim)*SUM(popsize))
    IF (InfiniteFixedCostModel==1) MeanIlliquid=SUM(SUM(lsim(:,1:Jtot),DIM = 1)*popsize)/(real(nsim)*SUM(popsize))

    IF (InfiniteFixedCostModel==0) assvecJtot=reshape(asim(1:nsimforperc,1:Jtot),(/nsimforperc*Jtot /))
    IF (InfiniteFixedCostModel==1) assvecJtot=reshape(lsim(1:nsimforperc,1:Jtot),(/nsimforperc*Jtot /))

    CALL Percentile (nsimforperc*Jtot, assvecJtot, 0.5_8, MedianIlliquid)	
    CALL Percentile (nsimforperc*Jtot, assvecJtot, 0.75_8, P75Illiquid)	

    lcapital = SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) + SUM(SUM(lplsim(:,1:Jtot),DIM = 1)*popsize)
    lincome = (1.0-qfree)*SUM(SUM(lsim(:,1:Jtot),DIM = 1,MASK = lsim(:,1:Jtot)>0)*popsize) + (1.0-qill)*SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) + SUM(ysim) + SUM(SUM(psim(:,Jwork+1:Jtot), DIM = 1)*popsize(Jwork+1:Jtot))
    UsualKY = lcapital/lincome

    IF (MatchUsualKY==1) FnBeta = UsualKY-targetUsualKY
    IF (MatchMeanIlliquid==1) FnBeta = MeanIlliquid-targetMeanIlliquid
    IF (MatchMedianIlliquid==1) FnBeta =MedianIlliquid-targetMedianIlliquid
    IF (MatchP75Illiquid==1) FnBeta = P75Illiquid-targetP75Illiquid




    write(*,*) '  Simulated - Target : ',FnBeta
    OPEN(3, FILE = trim(OutputDir) // 'BetaCalibration.txt', ACCESS = 'append')
    WRITE(3,*) bet,FnBeta
    CLOSE(3)
    
    OPEN(3, FILE = trim(OutputDir) // 'CalibratedKY.txt', STATUS = 'replace')
    IF (MatchUsualKY==1) WRITE(3,*) UsualKY,targetUsualKY
    IF (MatchMeanIlliquid==1) WRITE(3,*) MeanIlliquid,targetMeanIlliquid
    IF (MatchMedianIlliquid==1) WRITE(3,*)MedianIlliquid,targetMedianIlliquid
    IF (MatchP75Illiquid==1) WRITE(3,*) P75Illiquid,targetP75Illiquid
    CLOSE(3)


END FUNCTION FnBeta
