REAL(8) FUNCTION FnPortfolio(lass)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lass
REAL(8)             :: lemuc,lhfn,lqpldq, lnliq
REAL(8), EXTERNAL	:: FnBondPrice,FnBondPriceD,FnInvQA

IF (gUsePortfolioAsEE==1) THEN
	gsav = lass*qill
	gcon = (gcoh - gsav)/(1.0+ctax)
END IF

gass = lass
gliq = FnInvQA(gsav-qill*gass,0.0_8)
IF(abs(gliq)<1.0e-10_8) gliq = 0.0_8
lnliq = gliq + rebateamt*rebatenext																		

IF(gij<Jwork) THEN
	CALL TransformBi45DegInterp1(-1.0/sigC,ngpl,lgrid(gij+1,:,gif,giz),ngpa,agrid(gij+1,:,gif,giz),emucnext(gij+1,:,:,gid,giW,giu),lnliq,gass,lemuc)
	CALL Bi45DegInterp1(ngpl,lgrid(gij+1,:,gif,giz),ngpa,agrid(gij+1,:,gif,giz),hfnnext(gij+1,:,:,gid,giW,giu),lnliq,gass,lhfn,0)
ELSE IF (gij==Jwork) THEN
	CALL TransformBi45DegInterp1(-1.0/sigC,ngplret,lgridret(1,:,gip),ngparet,agridret(1,:,gip),emucretJ1next(:,:,gid,gip),lnliq,gass,lemuc)							
	CALL Bi45DegInterp1(ngplret,lgridret(1,:,gip),ngparet,agridret(1,:,gip),hfnretJ1next(:,:,gid,gip),lnliq,gass,lhfn,0)							
END IF

lqpldq = FnBondPrice(gliq,0.0_8) + gliq*FnBondPriceD(gliq,0.0_8)

IF (gUsePortfolioAsEE==0) THEN
		
	gfoc = lemuc/lqpldq + (1.0+ctax)*liqflow*((gcon+servflow*gass+liqflow*max(gliq,0.0))**(-sigC))/(lqpldq*bet)
	FnPortfolio = gfoc- lhfn/qill - (1.0+ctax)*servflow*((gcon+servflow*gass+liqflow*max(gliq,0.0))**(-sigC))/(qill*bet)
ELSE IF (gUsePortfolioAsEE==1) THEN
	gfoc = lhfn/qill +  (1.0+ctax)*servflow*((gcon+servflow*gass+liqflow*max(gliq,0.0))**(-sigC))/(qill*bet)
	FnPortfolio = ((gcon+servflow*gass+liqflow*max(gliq,0.0))**(-sigC))- bet*gfoc 
END IF





END FUNCTION FnPortfolio


