REAL(8) FUNCTION FnTax(ltaxsys,ly,lmstat,luestat,ltaxincr)
USE Parameters
USE Globals
IMPLICIT NONE

INTEGER, INTENT(IN)	:: ltaxsys,lmstat,luestat
REAL(8), INTENT(IN) :: ly
REAL(8)				:: lsstax(2),lyind(2),agy,taxagy,ltaxincr
INTEGER				:: i,br,lltaxsys
REAL(long), DIMENSION(n_taxyears, n_gridtax-1, n_coeff) :: agyc

!taxsys is tax system, ly is labor inc, lb is stock of total assets,la is stock of illiquid assets, lmstat is indicator for working age,luestat is indicator for unemployed,ltaxincr is proportional tax to balance govt bc

IF(NoTaxes==1) THEN
	FnTax = 0.0
	return
END IF



IF(NoChangeTaxSystem==1) THEN
	lltaxsys = WhichTaxSystem
ELSE
	lltaxsys = ltaxsys
END IF

!Rename coefficients
agyc = aginc_coeff

!SS Tax
IF (lmstat==1 .and. luestat==0) THEN !working age
	!Determine individual labor income for SS taxation 
	lyind(1) = fracmainearner*ly
	lyind(2) = (1-fracmainearner)*ly

	DO i = 1,2
		lsstax(i) = 0.124*min(lyind(i),sstaxcap)
	END DO
ELSE	!retired or unemployed
	lsstax(:) = 0.0
ENDIF

!Compute adjusted gross income needed to determine tax bracket
agy = ly

!Determine tax bracket for labor income
IF ( agy .LT. gridtax(2) ) THEN
	br = 1
ELSE IF ( agy .GE. gridtax(2) .AND. agy .LT. gridtax(3) ) THEN
	br = 2
ELSE IF ( agy .GE. gridtax(3) .AND. agy .LT. gridtax(4) ) THEN
	br = 3
ELSE IF ( agy .GE. gridtax(4) .AND. agy .LT. gridtax(5) ) THEN
	br = 4
ELSE IF ( agy .GE. gridtax(5) .AND. agy .LT. gridtax(6) ) THEN
	br = 5
ELSE IF ( agy .GE. gridtax(6) .AND. agy .LT. gridtax(7) ) THEN
	br = 6
ELSE IF ( agy .GE. gridtax(7) .AND. agy .LT. gridtax(8) ) THEN
	br = 7
ELSE IF ( agy .GE. gridtax(8) .AND. agy .LT. gridtax(9) ) THEN
	br = 8
ELSE IF ( agy .GE. gridtax(9) ) THEN
	br = 9
ENDIF

!Determine tax liability
taxagy = agyc(lltaxsys,br,1)*(agy-gridtax(br))**3 + agyc(lltaxsys,br,2)*(agy-gridtax(br))**2 + agyc(lltaxsys,br,3)*(agy-gridtax(br)) + agyc(lltaxsys,br,4)

!Total tax liability
FnTax = taxagy + sum(lsstax) + ltaxincr*agy		!ltaxincr*agy is proportional tax to balance govt bc


END FUNCTION FnTax
