SUBROUTINE Grids

USE Parameters
USE Globals
USE Procedures
USE Random

IMPLICIT NONE

INTEGER			:: ie,ij,iff,iz,ip,iR,iW,ix,ia,il,id,iu,ifslo,iflev
REAL(8)         :: lwidth,lxa,lxb,lxc,lfa,lfb,lfc,lm,lfval,lylow,lEz,lSDz,lalpha,lbeta,lEyav,lSDyav,lEpen,lxmax,lxmin,lxminpos,slowidth,levwidth
REAL(8), EXTERNAL        :: FnTax,FnBondPrice,FnSSBenefit,FnGridPers,GOLDEN
REAL(8),dimension(ngpfylev)::xlevvals
REAL(8),dimension(ngpfyslo)::xslovals

!Unemployment
IF(ngpu==1) THEN
	ugrid(1) = 0.0
	udist(:,1) = 1.0
ELSE IF (ngpu==2) THEN
	ugrid(1) = 0.0
	ugrid(2) = 1.0
	udist(1,1) = 1.0-initialunemp
	udist(1,2)	= initialunemp
	DO ij = 2,Jwork
		udist(ij,1) = (1.0- jobloss(ij-1))*udist(ij-1,1) + jobfind(ij-1)*udist(ij-1,2)	!emp
		udist(ij,2) = jobloss(ij-1)*udist(ij-1,1) + (1.0-jobfind(ij-1))*udist(ij-1,2)	!unemp
	END DO
END IF

!Transitory shocks: earnings
IF (ngpey==1) THEN
	eygrid = 0.0
	eydist = 1.0
ELSE
	eygrid(1) = -sqrt((ngpey-1)*Vepsy)
	eygrid(ngpey) = -eygrid(1)
	eydist(1) = bin_prob(ngpey-1, 0.5_4, 0) 
	eydist(ngpey) = eydist(1)
	lwidth = (eygrid(ngpey)-eygrid(1))/real(ngpey-1)
	DO ie = 2,ngpey-1
		eygrid(ie) = eygrid(ie-1) + lwidth
		eydist(ie) = bin_prob(ngpey-1, 0.5_4, ie-1) 
	END DO
END IF

!Fixed effect: earnings levels
IF( NewFYDist==1 .AND. ngpfylev > 1 .AND. ngpfyslo > 1) THEN

    allocate(fylevgrid(ngpfylev*ngpfyslo))
    allocate(fyslogrid(ngpfylev*ngpfyslo))
    allocate(fylevdist(ngpfylev))
    allocate(fyslodist(ngpfyslo))

	xlevvals(1)=-sqrt(Vfey*real(ngpfylev-1))   
	xlevvals(ngpfylev)=-xlevvals(1)    
	xslovals(1)=-sqrt(Vphy*real(ngpfyslo-1))    
	xslovals(ngpfyslo)=-xslovals(1)    
	levwidth = (xlevvals(ngpfylev)-xlevvals(1))/real(ngpfylev-1)	
	slowidth = (xslovals(ngpfyslo)-xslovals(1))/real(ngpfyslo-1)    



	fylevdist(1) = bin_prob(ngpfylev-1, 0.5_4, 0) 
	fylevdist(ngpfylev)=fylevdist(1)

	DO iflev = 2,ngpfylev-1        
		xlevvals(iflev)=xlevvals(iflev-1)+levwidth    
		fylevdist(iflev) = bin_prob(ngpfylev-1, 0.5_4, iflev-1) 
	END DO    

	fyslodist(1) = bin_prob(ngpfyslo-1, 0.5_4, 0) 
	fyslodist(ngpfyslo)=fyslodist(1)

	DO ifslo = 2,ngpfyslo-1        
		xslovals(ifslo)=xslovals(ifslo-1)+slowidth    
		fyslodist(ifslo) = bin_prob(ngpfyslo-1, 0.5_4, ifslo-1) 
	END DO        

	iff=0
	DO iflev = 1,ngpfylev    
		DO ifslo = 1,ngpfyslo        	    
			iff = iff+1        

			fyslogrid(iff)=xslovals(ifslo)        
			fylevgrid(iff)=rholevslo*xslovals(ifslo)+sqrt((1.0d0-rholevslo**2))*xlevvals(iflev)
	    
			fylevind(iff) = iff	    
			fysloind(iff) = iff	    
			fyind(iflev,ifslo) = iff    
		END DO    
	END DO	


    OPEN(3, FILE = trim(OutputDir) // 'fylevdist.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpfylev,1,fylevdist)
    OPEN(3, FILE = trim(OutputDir) // 'fyslodist.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpfyslo,1,fyslodist)
    OPEN(3, FILE = trim(OutputDir) // 'fylevgrid.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpfy,1,fylevgrid)
    OPEN(3, FILE = trim(OutputDir) // 'fyslogrid.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpfy,1,fyslogrid)
    OPEN(3, FILE = trim(OutputDir) // 'fylevind.txt', STATUS = 'replace')
    CALL WriteMatrixInteger(3,ngpfy,1,fylevind)
    OPEN(3, FILE = trim(OutputDir) // 'fysloind.txt', STATUS = 'replace')
    CALL WriteMatrixInteger(3,ngpfy,1,fysloind)


ELSE
    allocate(fylevgrid(ngpfylev))
    allocate(fyslogrid(ngpfyslo))
    allocate(fylevdist(ngpfylev))
    allocate(fyslodist(ngpfyslo))

    IF (ngpfylev==1) THEN
	    fylevgrid = 0.0
	    fylevdist = 1.0
    ELSE 
	    fylevgrid(1) = -sqrt((ngpfylev-1)*Vfey)
	    fylevgrid(ngpfylev) = -fylevgrid(1)
	    fylevdist(1) = bin_prob(ngpfylev-1, 0.5_4, 0) 
	    fylevdist(ngpfylev) = fylevdist(1)
	    lwidth = (fylevgrid(ngpfylev)-fylevgrid(1))/real(ngpfylev-1)
	    DO ie = 2,ngpfylev-1
		    fylevgrid(ie) = fylevgrid(ie-1) + lwidth
		    fylevdist(ie) = bin_prob(ngpfylev-1, 0.5_4, ie-1) 
	    END DO
    END IF
       
    !Fixed effect: earnings slopes
    IF (ngpfyslo == 1 .or. FlatEarningsProfile==1) THEN
	    fyslogrid = 0.0
	    fyslodist = 1.0/real(ngpfyslo)
    ELSE
    	
	    fyslogrid(1) = -sqrt((ngpfyslo-1)*Vphy)
	    fyslogrid(ngpfyslo) = -fyslogrid(1)
	    fyslodist(1) = bin_prob(ngpfyslo-1, 0.5_4, 0) 
	    fyslodist(ngpfyslo) = fyslodist(1)
	    lwidth = (fyslogrid(ngpfyslo)-fyslogrid(1))/real(ngpfyslo-1)
	    DO ie = 2,ngpfyslo-1
		    fyslogrid(ie) = fyslogrid(ie-1) + lwidth
		    fyslodist(ie) = bin_prob(ngpfyslo-1, 0.5_4, ie-1) 
	    END DO
    END IF

    iff = 0
    DO iflev = 1,ngpfylev
    DO ifslo = 1,ngpfyslo
	    iff = iff+1
	    fylevind(iff) = iflev
	    fysloind(iff) = ifslo
	    fyind(iflev,ifslo) = iff
    END DO
    END DO
    OPEN(3, FILE = trim(OutputDir) // 'fylevdist.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpfylev,1,fylevdist)
    OPEN(3, FILE = trim(OutputDir) // 'fyslodist.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpfyslo,1,fyslodist)
    OPEN(3, FILE = trim(OutputDir) // 'fylevind.txt', STATUS = 'replace')
    CALL WriteMatrixInteger(3,ngpfy,1,fylevind)
    OPEN(3, FILE = trim(OutputDir) // 'fysloind.txt', STATUS = 'replace')
    CALL WriteMatrixInteger(3,ngpfy,1,fysloind)

ENDIF




!Persistent component: earnings. Rouwenhorst works poorly outside of steady state so use modified Tauchen method
IF (ngpzy==1) THEN
	Vzy = 0.0
	zygrid = 0.0
	zytrans = 1.0
	zydist = 1.0
ELSE
	
	Vzy(1) = Vzy0 + (rhoy**2)*Vetay
	DO ij = 2, Jwork
  		Vzy(ij) = (rhoy**2)*Vzy(ij-1) + Vetay
	END DO

	lxa = 1.0e-8
	lxb = 1.0
	CALL MNBRAK(lxa,lxb,lxc,lfa,lfb,lfc,FnGridPers)
	lfval = GOLDEN(lxa,lxb,lxc,FnGridPers,1.0e-6_8,lm)
	lfval = FnGridPers(lm)

    OPEN(3, FILE = trim(OutputDir) // 'zygrid.txt', STATUS = 'replace')
    CALL WriteMatrix(3,Jwork,ngpzy,zygrid)
    OPEN(3, FILE = trim(OutputDir) // 'zydist.txt', STATUS = 'replace')
    CALL WriteMatrix(3,Jwork,ngpzy,zydist)
    OPEN(3, FILE = trim(OutputDir) // 'zytrans1.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpzy,ngpzy,zytrans(1,:,:))
    OPEN(3, FILE = trim(OutputDir) // 'zytrans21.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpzy,ngpzy,zytrans(21,:,:))
    OPEN(3, FILE = trim(OutputDir) // 'zytrans41.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpzy,ngpzy,zytrans(41,:,:))
    OPEN(3, FILE = trim(OutputDir) // 'zytrans61.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpzy,ngpzy,zytrans(61,:,:))
    OPEN(3, FILE = trim(OutputDir) // 'zytrans81.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpzy,ngpzy,zytrans(81,:,:))
    OPEN(3, FILE = trim(OutputDir) // 'zytrans101.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpzy,ngpzy,zytrans(101,:,:))
    OPEN(3, FILE = trim(OutputDir) // 'zytrans121.txt', STATUS = 'replace')
    CALL WriteMatrix(3,ngpzy,ngpzy,zytrans(121,:,:))




END IF
!pause
!Earnings, conditional on working
DO ij = 1,Jwork
	DO ie = 1,ngpey
	DO iz = 1,ngpzy
	DO iff = 1,ngpfy
		iflev = fylevind(iff)
		ifslo = fysloind(iff)
		ygrid(ij,iff,iz,ie) = exp(kappay(ij)+ fylevgrid(iflev) + ij*fyslogrid(ifslo) + zygrid(ij,iz) + eygrid(ie))
		!persistent component of earnings
		if(ie==1) ypsgrid(ij,iff,iz) = exp(kappay(ij)+ fylevgrid(iflev) + ij*fyslogrid(ifslo) + zygrid(ij,iz))
	END DO
	END DO
	END DO
END DO
!print*,ygrid(:,1,:,1)
!print*,ypsgrid(Jwork,1,:)
!pause

! !Mean gross earnings grid for pension
CALL SimulateEarnings


IF (FixedPension==1) THEN
	pgrid(Jwork+1:Jtot,:) = meanpension
	pgrid(1:Jwork,:) = 0.0

ELSE IF(LinearPension==1) THEN
	IF (ngpp .ne. ngpzy*ngpfy) THEN
		write(*,*) 'ERROR: for pension fn of final persistent must have ngpp=ngpzy*ngpfy'
		stop
	END IF
	lEz = sum(ypssim(:,Jwork))/real(nsim)
	lSDz = sqrt(sum((ypssim(:,Jwork))**2)/real(nsim) - lEz**2)
	lbeta = stdvpension/lSDz
	lalpha = meanpension - lbeta*lEz
	ip = 1
	DO iz = 1,ngpzy
	DO iff = 1,ngpfy
		pgrid(Jwork+1:Jtot,ip) = lalpha + lbeta*ypsgrid(Jwork,iff,iz)
		ip = ip+1
	END DO
	END DO
	pgrid(1:Jwork,:) = 0.0
ELSE IF(ConcavePension==1) THEN
	IF (ngpp .ne. ngpzy*ngpfy) THEN
		write(*,*) 'ERROR: for pension fn of final persistent must have ngpp=ngpzy*ngpfy'
		stop
	END IF
	!rescale final persistent component so it has same mean and st dev as average accumulated earnings, then feed through sysetem
	lEz = sum(ypssim(:,Jwork))/real(nsim)
	lSDz = sqrt(sum((ypssim(:,Jwork))**2)/real(nsim) - lEz**2)
	lEyav = sum(yavsimforpen(:,Jwork))/real(nsim)
	lSDyav = sqrt(sum((yavsimforpen(:,Jwork))**2)/real(nsim) - lEyav**2)
	ip = 1
	DO iz = 1,ngpzy
	DO iff = 1,ngpfy
		pgrid(Jwork+1:Jtot,ip) = FnSSBenefit((ypsgrid(Jwork,iff,iz)-lEz)*lSDyav/lSDz +lEyav)
		ip = ip+1
	END DO
	END DO
	pgrid(1:Jwork,:) = 0.0
END IF
write(*,*) pgrid(1,1)	!for some reason, without writing an element of pgrid to the screen compilation gives wrong answers when compiling with -openmp

!finally re-scaler pension benefits to have correct mean: assumes no age effects in pension
IF(LinearPension==1 .or. ConcavePension==1) THEN
	lEpen = 0.0
	ip = 1

	IF( NewFYDist==1 .AND. ngpfylev > 1 .AND. ngpfyslo > 1) THEN
		DO iz = 1,ngpzy
		DO iflev = 1,ngpfylev
		DO ifslo = 1,ngpfyslo
			lEpen = lEpen +pgrid(Jwork+1,ip)*zydist(Jwork,iz)*fylevdist(iflev)*fyslodist(ifslo) 
			ip = ip+1
		END DO
		END DO
		END DO
	ELSE
		DO iz = 1,ngpzy
		DO iff = 1,ngpfy
			iflev = fylevind(iff)
			ifslo = fysloind(iff)
			lEpen = lEpen +pgrid(Jwork+1,ip)*zydist(Jwork,iz)*fylevdist(iflev)*fyslodist(ifslo) 
			ip = ip+1
		END DO
		END DO
	ENDIF
	pgrid = pgrid*meanpension/lEpen
END IF


!Per-person tax-base:
taxbase = (1.0*sum(popsize(1:Jwork))+meanpension*sum(popsize(Jwork+1:Jtot)))/sum(popsize)

IF(ModelRecession==1) THEN
	holdygrid = ygrid
	holdypsgrid = ypsgrid
	holdpgrid = pgrid
END IF


!Total state: working - why does this take so long?
iW = 1
DO iz = 1,ngpzy
DO iff = 1,ngpfy
	fWind(iW) = iff
	zWind(iW) = iz
	Wind(iff,iz) = iW
	iW = iW+1
END DO
END DO

!Total state: retired
iR = 1
DO ip = 1,ngpp
	pRind(iR) = ip
	Rind(ip) = iR
	iR = iR+1
END DO

!Deductions grid
dgrid(1) = 0.0
IF (ngpd>1) THEN
	DO id = 2,ngpd
		dgrid(id) = (id-1)*maxdeduction/real(ngpd-1)		
	END DO
END IF
dgridret(1) = 0.0
IF (ngpdret>1) THEN
	DO id = 2,ngpdret
		dgridret(id) = (id-1)*maxdedret/real(ngpdret-1)		
	END DO
END IF

!Natural borrowing limits: (amount you can take into j, chosen at j-1)
! DO ip = 1,ngpp
! 	nblret(Jret,ip) = -pgrid(Jwork + Jret,ip) + FnTax(1,pgrid(Jwork + Jret,ip),0,0,0.0_8)	+ 1.0e-4
! 	nblret(Jret,ip) = min(nblret(Jret,ip),0.0)
! 	DO ij = Jret-1,1,-1
! 	    nblret(ij,ip) = nblret(ij+1,ip)*FnBondPrice(nblret(ij+1,ip),0.0_8) - pgrid(Jwork + ij,ip) + FnTax(1,pgrid(Jwork + ij,ip),0,0,0.0_8)	+ 1.0e-4
! 		nblret(ij,ip) = min(nblret(ij,ip),0.0)
! 	END DO
! END DO 

DO iff = 1,ngpfy
	IF(NoUnempShocks==1) THEN
		lylow = (1.0-maxval(dgrid))*(ygrid(Jwork,iff,1,1)-FnTax(1,ygrid(Jwork,iff,1,1),1,0,0.0_8))
	ELSE
		lylow = min((1.0-maxval(dgrid))*ygrid(Jwork,iff,1,1)-FnTax(1,ygrid(Jwork,iff,1,1),1,0,0.0_8), &
					uemprepl*ypsgrid(Jwork,iff,1)-FnTax(1,uemprepl*ypsgrid(Jwork,iff,1),1,1,0.0_8))
	END IF
	nbl(Jwork,iff) = -lylow	+ 1.0e-4
	nbl(Jwork,iff) = min(nbl(Jwork,iff),0.0)
	DO ij = Jwork-1,1,-1
		IF(NoUnempShocks==1) THEN
			lylow = (1.0-maxval(dgrid))*(ygrid(ij,iff,1,1)-FnTax(1,ygrid(ij,iff,1,1),1,0,0.0_8))
		ELSE
			lylow = min((1.0-maxval(dgrid))*ygrid(ij,iff,1,1)-FnTax(1,ygrid(ij,iff,1,1),1,0,0.0_8), &
						uemprepl*ypsgrid(ij,iff,1)-FnTax(1,uemprepl*ypsgrid(ij,iff,1),1,1,0.0_8))		
		END IF
	    nbl(ij,iff) = nbl(ij+1,iff)*FnBondPrice(nbl(ij+1,iff),ypsgrid(ij,iff,1)) - lylow	+ 1.0e-4
		nbl(ij,iff) = min(nbl(ij,iff),0.0)
	END DO
END DO

!Actual borrowing limits: no borrowing in retirement (amount you can take into j, chosen at j-1)

! IF (NoBorrowInRetirement==1) THEN
! 	ablret(:,:) = 0.0
! ELSE
! 	DO ip = 1,ngpp
! 		ablret(Jret,ip) = max(nblret(Jret,ip),-borrowlim*pgrid(Jwork + Jret-1,ip))
! 		ablret(Jret,ip) = min(ablret(Jret,ip),0.0)
! 		DO ij = Jret-1,2,-1
! 		    ablret(ij,ip) = ablret(ij+1,ip)*FnBondPrice(ablret(ij+1,ip),0.0_8) - pgrid(Jwork + ij,ip) + FnTax(1,pgrid(Jwork + ij,ip),0,0,0.0_8)	+ 1.0e-4
! 			ablret(ij,ip) = max(ablret(ij,ip),-borrowlim * pgrid(Jwork+ij-1,ip))	!income at j-1 determines how much can take into j
! 			ablret(ij,ip) = min(ablret(ij,ip),0.0)
! 		END DO
! 		ij = 1
! 		ablret(ij,ip) = ablret(ij+1,ip)*FnBondPrice(ablret(ij+1,ip),0.0_8) - pgrid(Jwork + ij,ip) + FnTax(1,pgrid(Jwork + ij,ip),0,0,0.0_8)	+ 1.0e-4
! 		ablret(ij,ip) = max(ablret(ij,ip),-borrowlim * pgrid(Jwork+ij,ip))	!income at j-1 determines how much can take into j: but this is not done correclty here becasuse it would be a little toohard
! 		ablret(ij,ip) = min(ablret(ij,ip),0.0)
! 
! 	END DO 
! END IF


DO iz = 1,ngpzy !(at j-1)
DO iff = 1,ngpfy
	IF(sameborrowlim) THEN
		abl(Jwork,iff,iz) = max(nbl(Jwork,iff),-borrowlim * real(Numeraire) )
	
	ELSE
		abl(Jwork,iff,iz) = max(nbl(Jwork,iff),-borrowlim * ypsgrid(Jwork-1,iff,iz) )	!income at j-1 determines how much can take into j
	ENDIF


	abl(Jwork,iff,iz) = min(abl(Jwork,iff,iz),0.0)
	DO ij = Jwork-1,2,-1
! 		lylow = min(ygrid(ij,iff,1,1),uemprepl*ypsgrid(ij,iff,1))
		IF(NoUnempShocks==1) THEN
 			lylow = (1.0-maxval(dgrid))*(ygrid(ij,iff,1,1)-FnTax(1,ygrid(ij,iff,1,1),1,0,0.0_8))
!			lylow = (1.0-maxval(dgrid))*ygrid(ij,iff,iz,1)-FnTax(1,ygrid(ij,iff,iz,1),1,0,0.0_8)
		ELSE
 			lylow = min((1.0-maxval(dgrid))*ygrid(ij,iff,1,1)-FnTax(1,ygrid(ij,iff,1,1),1,0,0.0_8), &
 						uemprepl*ypsgrid(ij,iff,1)-FnTax(1,uemprepl*ypsgrid(ij,iff,1),1,1,0.0_8))
!			lylow = min((1.0-maxval(dgrid))*ygrid(ij,iff,iz,1)-FnTax(1,ygrid(ij,iff,iz,1),1,0,0.0_8), &
!						uemprepl*ypsgrid(ij,iff,1)-FnTax(1,uemprepl*ypsgrid(ij,iff,1),1,1,0.0_8))
		END IF
		abl(ij,iff,iz) = abl(ij+1,iff,1)*FnBondPrice(abl(ij+1,iff,1),ypsgrid(ij,iff,1)) - lylow 	+ 1.0e-4
		
		IF(sameborrowlim) THEN

			abl(ij,iff,iz) = max(abl(ij,iff,iz),-borrowlim * (real(Numeraire)))

		ELSE

			abl(ij,iff,iz) = max(abl(ij,iff,iz),-borrowlim * ypsgrid(ij-1,iff,iz))	!income at j-1 determines how much can take into j
		
		ENDIF

		abl(ij,iff,iz) = min(abl(ij,iff,iz),0.0)
	END DO
	abl(1,iff,iz) = max(nbl(1,iff),abl(2,iff,iz)) 
END DO
END DO

!Cash on hand grid /total asset grid! 
DO ij = 1,Jwork
	DO iz = 1,ngpzy
	DO iff = 1,ngpfy
		IF(NoUnempShocks==1) THEN
! 			lylow = ygrid(ij,iff,1,1)- FnTax(1,ygrid(ij,iff,1,1),1,0,0.0_8)
			lylow = ygrid(ij,iff,iz,1)- FnTax(1,ygrid(ij,iff,iz,1),1,0,0.0_8)
		ELSE
! 			lylow = min(ygrid(ij,iff,1,1)- FnTax(1,ygrid(ij,iff,1,1),1,0,0.0_8), &
! 						uemprepl*ypsgrid(ij,iff,1)- FnTax(1,uemprepl*ypsgrid(ij,iff,1),1,1,0.0_8))
			lylow = min(ygrid(ij,iff,iz,1)- FnTax(1,ygrid(ij,iff,iz,1),1,0,0.0_8), &
						uemprepl*ypsgrid(ij,iff,1)- FnTax(1,uemprepl*ypsgrid(ij,iff,1),1,1,0.0_8))
		END IF
		
		!agrid: illiquid assets
		CALL PowerSpacedGrid (ngpa,agridparam,0.0_8,amax,agrid(ij,:,iff,iz))
				
		!lgrid: liquid assets
		CALL PowerSpacedGrid (ngpl-ngplneg+1,lgridparam,0.0_8,lmax,lgrid(ij,ngplneg+1:ngpl,iff,iz))	!positive
		IF(ngplneg>0) THEN
			CALL PowerSpacedGrid (ngplneg/2+1,lgridparam,abl(ij,iff,iz),(0.0_8+abl(ij,iff,iz))/2.0,lgrid(ij,1:ngplneg/2+1,iff,iz))
			DO il = ngplneg/2+2,ngplneg
				lgrid(ij,il,iff,iz) = lgrid(ij,ngplneg+1,iff,iz) -(lgrid(ij,ngplneg+2-il,iff,iz)-lgrid(ij,1,iff,iz))
			END DO
		END IF
		
		 
		!xNgrid: cash on hand grid
		DO id = 1,ngpd
			DO ia = 1,ngpa
				lxmax = lmax -mturcg*agrid(ij,ia,iff,iz) +  ygrid(ij,iff,ngpzy,ngpey)- FnTax(1,ygrid(ij,iff,ngpzy,ngpey),1,0,0.0_8)
				lxminpos = max(0.0_8, (1.0-dgrid(id))*lylow - mturcg*agrid(ij,ia,iff,iz))
				!lxmin =  max(abl(ij,iff,iz),abl(ij,iff,iz)+ (1.0-dgrid(ngpd))*lylow - mturcg*agrid(ij,ia,iff,iz))
				lxmin =  max(abl(ij,iff,ngpzy),abl(ij,iff,ngpzy)+ (1.0-dgrid(id))*lylow - mturcg*agrid(ij,ia,iff,iz))
				CALL PowerSpacedGrid (ngpxN-ngpxNneg+1,xNgridparam,lxminpos,lxmax,xNgrid(ij,ngpxNneg+1:ngpxN,ia,iff,iz,id))	!positive l
				IF(ngpxNneg>0) THEN
					CALL PowerSpacedGrid (ngpxNneg/2+1,xNgridparam,lxmin,(lxmin+lxminpos)/2.0,xNgrid(ij,1:ngpxNneg/2+1,ia,iff,iz,id))
					DO ix = ngpxNneg/2+2,ngpxNneg
						xNgrid(ij,ix,ia,iff,iz,id) = xNgrid(ij,ngpxNneg+1,ia,iff,iz,id) -(xNgrid(ij,ngpxNneg+2-ix,ia,iff,iz,id)-xNgrid(ij,1,ia,iff,iz,id))
					END DO
				END IF
			END DO
		END DO
	
		!xAgrid: cash on hand grid (before adjustment cost)
		lxmax = lmax +  ygrid(ij,iff,ngpzy,ngpey)- FnTax(1,ygrid(ij,iff,ngpzy,ngpey),1,0,0.0_8)
		lxminpos = max(0.0_8, lylow-mturcg*amax)
                !lxmin =  max(abl(ij,iff,iz),abl(ij,iff,iz)+ (1.0-dgrid(ngpd))*lylow - mturcg*agrid(ij,ia,iff,iz))
		lxmin =  max(abl(ij,iff,ngpzy), abl(ij,iff,ngpzy)+lylow-mturcg*amax)
		CALL PowerSpacedGrid (ngpxN-ngpxNneg+1,xNgridparam,lxminpos,lxmax,xAgrid(ij,ngpxNneg+1:ngpxN,iff,iz))
		CALL PowerSpacedGrid (ngpxA-ngpxN+1,1.0_8,lxmax,lxmax+amax,xAgrid(ij,ngpxN:ngpxA,iff,iz))
		IF(ngpxAneg>0) THEN
			CALL PowerSpacedGrid (ngpxAneg/2+1,xNgridparam,lxmin,(lxmin+lxminpos)/2.0,xAgrid(ij,1:ngpxAneg/2+1,iff,iz))
			DO ix = ngpxAneg/2+2,ngpxAneg
				xAgrid(ij,ix,iff,iz) = xAgrid(ij,ngpxAneg+1,iff,iz) -(xAgrid(ij,ngpxAneg+2-ix,iff,iz)-xAgrid(ij,1,iff,iz))
			END DO
		END IF
			
	END DO
	END DO
END DO

DO ij = 1,Jret
	DO ip = 1,ngpp

	
		lylow = pgrid(Jwork+ij,ip) - FnTax(1,pgrid(Jwork+ij,ip),0,0,0.0_8)
	
		!agrid: illiquid assets
		CALL PowerSpacedGrid (ngparet,agridretparam,0.0_8,amax,agridret(ij,:,ip))
			
		!lgrid: liquid assets
		CALL PowerSpacedGrid (ngplret,lgridretparam,0.0_8,lmax,lgridret(ij,:,ip))

	 
		!xNgrid: cash on hand grid
		DO ia = 1,ngpa
		DO id = 1,ngpdret
			lxmax = lmax -mturcg*agridret(ij,ia,ip) +  lylow
			lxmin = max(0.0_8, lylow - mturcg*agridret(ij,ia,ip) + dgridret(id)*agridret(ij,ia,ip) )
			CALL PowerSpacedGrid (ngpxNret,xNgridretparam,lxmin,lxmax,xNgridret(ij,:,ia,ip,id))				
		END DO	
		END DO
	
		!xAgrid: cash on hand grid (before adjustment cost)
		lxmax = lmax  +  lylow
		lxmin = max(0.0_8, lylow-mturcg*amax)	!note this may lead to different results with and without borrowing....
! 		CALL PowerSpacedGrid (ngpxAret,xAgridretparam,lxmin,lxmax,xAgridret(ij,:,ip))
		CALL PowerSpacedGrid (ngpxNret,xNgridretparam,lxmin,lxmax,xAgridret(ij,1:ngpxNret,ip))
		CALL PowerSpacedGrid (ngpxAret-ngpxNret+1,1.0_8,lxmax,lxmax+amax,xAgridret(ij,ngpxNret:ngpxAret,ip))
				
	
	END DO
END DO

!combined grids for openmp loops
ij = 1
DO iW = 1,ngpW
DO iu = 1,ngpu
DO il = 1,ngpl
	WfromWul(ij) = iW
	ufromWul(ij) = iu
	lfromWul(ij) = il
	ij = ij+1
END DO
END DO
END DO

ij = 1
DO iR = 1,ngpR
DO il = 1,ngplret
	RfromRl(ij) = iR
	lfromRl(ij) = il
	ij = ij+1
END DO
END DO

ij = 1
DO ip = 1,ngpp
DO il = 1,ngplret
	pfromplret(ij) = ip
	lfromplret(ij) = il
	ij = ij+1
END DO
END DO

IF (Display==1) write(*,*) 'Finished forming grids'


END SUBROUTINE Grids
