SUBROUTINE LifecycleStats

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER		:: ij,jL,jH,id,in
INTEGER     :: sortorder(nsimforpercJ)
REAL(8)     :: tempvec(nsimforpercJ),allagevec(nsimforperc*Jtot)
REAL(8)     :: lcapital,lincome,whichperc(3),lperc(3),whichperc2(5),tempsigx,tempsigy,latax,lltax


write(*,*) 'Calculating lifecycle stats'
!quarterly stats
Eadj = SUM(adjsim(:,:),dim=1)/real(nsim)
Econ = SUM(csim(:,:),dim=1)/real(nsim)
Etotcon = SUM(ctotsim(:,:),dim=1)/real(nsim)
Eflow = SUM(flowsim(:,:),dim=1)/real(nsim)
Eass = SUM(asim(:,:),dim=1)/real(nsim)
Eliq = SUM(lsim(:,:),dim=1)/real(nsim)
Eliqpl = SUM(lplsim(:,:),dim=1)/real(nsim)
Elpl3 = SUM(lpl3sim(:,:),dim=1)/real(nsim)
Elpl6 = SUM(lpl6sim(:,:),dim=1)/real(nsim)
Einc = SUM(ysim(:,:),dim=1)/real(nsim)
Elabinc = SUM(ysim(:,:),dim=1,mask=usimI(:,:)==1)/real(count(usimI(:,:)==1,dim=1))
Enetlabinc(1:Jwork) = SUM(ysim(:,:)-taxsim(:,1:Jwork),dim=1)/real(nsim)
Enetlabinc(Jwork+1:Jtot) = SUM(psim(:,Jwork+1:Jtot)-taxsim(:,Jwork+1:Jtot),dim=1)/real(nsim)


IF(NoUnempShocks==0) Euiben = SUM(ysim(:,:),dim=1,mask=usimI(:,:)==2)/real(count(usimI(:,:)==2,dim=1))
IF(NoUnempShocks==1) Euiben = 0.0
Eunemp = SUM(usim(:,:),dim=1)/real(nsim)
Etax = SUM(taxsim(:,:),dim=1)/real(nsim)
Epen = SUM(psim(:,Jwork+1:Jtot),dim=1)/real(nsim)
Eyav = SUM(yavsim(:,:),dim=1)/real(nsim)
DO ij = 1,ngpd
	PRded(:,ij) = real(count(dedsimI(:,:)==ij,dim=1))/real(nsim)
END DO
Eded(1:Jwork) = MATMUL(PRded(1:Jwork,:),dgrid)
Eded(Jwork+1:Jtot) = MATMUL(PRded(Jwork+1:Jtot,:),dgridret)

!Fraction of people on their borrowing limits
IF(Borrowing==1) THEN
	Eliqlim=0.0d0
	Eliqlimapos=0.0d0
	DO ij=2,Jwork-1
		DO in=1,nsim
		IF( lsim(in,ij) .lt. abl(ij,fysimI(in),zysimI(in,ij-1)) + 100.0/(DataAvAnnualEarns/real(Numeraire)) ) THEN
			Eliqlim(ij)=Eliqlim(ij)+1.0d0
			IF(asim(in,ij) .gt. 0.0d0) THEN
				Eliqlimapos(ij) = Eliqlimapos(ij)+1.0d0
			ENDIF
		ENDIF
		ENDDO
	ENDDO
	Eliqlim=Eliqlim/real(nsim)
	Eliqlimapos=Eliqlimapos/real(nsim)
END IF

!Fraction of people with exactly 0 liquid assets
Eliq0 = COUNT(lsim(:,:) .eq. 0.0d0,dim=1)/real(nsim)
Eaposliq0 = (COUNT( ( (lsim(:,:) .eq. 0.0d0) .and. (asim(:,:) > 0.0d0)),dim=1)/real(nsim))


!Fraction of people with positive liquid assets
Eliqpos = COUNT(lsim(:,:)>0.0,dim=1)/real(nsim)
Eliqposapos = (COUNT( ( (lsim(:,:) > 0.0d0) .and. (asim(:,:) > 0.0d0)),dim=1)/real(nsim))

Easspos = COUNT(asim(:,:)>0.0,dim=1)/real(nsim)
Esavpos = COUNT((lsim(:,:)*asim(:,:))>0.0,dim=1)/real(nsim)

!Fraction with liq_t+1<=0 and not adjsuting
Eliq0negnoadj(1:Jwork) = COUNT(lsim(:,2:Jwork+1) <= 0.0 .and. adjsim(:,1:Jwork) == 0.0,dim=1)/real(nsim)
Eliq0negnoadj(Jwork+1:Jtot-1) = COUNT(lsim(:,Jwork+2:Jtot) <= 0.0 .and. adjsim(:,Jwork+2:Jtot) == 0.0,dim=1)/real(nsim)
Eliq0negnoadj(Jwork+1:Jtot) = COUNT(lsim(:,Jtot+1) <= 0.0,dim=1)/real(nsim)

print*,'ok up to constrained'

Ecstr1 = COUNT(lsim(:,2:Jtot)==0.0,dim=1)/real(nsim)
Ecstr2 = COUNT(lsim(:,2:Jtot) .ne. 0.0,dim=1)/real(nsim)
IF(Borrowing==1) THEN
        Ecstr3=0.0d0
        Ecstr3noill=0.0d0
        
        DO ij=2,Jwork+1
                DO in=1,nsim
                IF( (lsim(in,ij) .eq. abl(ij,fysimI(in),zysimI(in,ij-1)) .or. lsim(in,ij) .eq. 0.0) .and. adjsim(in,ij-1) .eq. 0) THEN
                   Ecstr3(ij-1)=Ecstr3(ij-1)+1.0d0
                   IF(asim(in,ij) .eq. 0.0) Ecstr3noill(ij-1)=Ecstr3noill(ij-1)+1.0d0
                ENDIF
             ENDDO
          ENDDO

ELSE
Ecstr3(1:Jwork) = COUNT(lsim(:,2:Jwork+1) == 0.0 .and. adjsim(:,1:Jwork) == 0.0,dim=1)/real(nsim)
Ecstr3noill(1:Jwork) 		= COUNT(lsim(:,2:Jwork+1) == 0.0 .and. adjsim(:,1:Jwork) == 0.0 .and. asim(:,2:Jwork+1)==0.0,dim=1)/real(nsim)
ENDIF


Ecstr3(Jwork:Jtot-1)	= COUNT(lsim(:,Jwork+1:Jtot) == 0.0 .and. adjsim(:,Jwork+1:Jtot) == 0.0,dim=1)/real(nsim)
Ecstr4(1:Jwork) 		= COUNT(lsim(:,1:Jwork) .ne. 0.0 .or. lsim(:,2:Jwork+1) .ne. 0.0 .or. adjsim(:,1:Jwork) == 1.0,dim=1)/real(nsim)
Ecstr4(Jwork+1:Jtot-1) 	= COUNT(lsim(:,Jwork+1:Jtot-1) .ne. 0.0 .or. lsim(:,Jwork+2:Jtot) .ne. 0.0 .or. adjsim(:,Jwork+2:Jtot) == 1.0,dim=1)/real(nsim)
Ecstr5(1:Jwork) 		= COUNT(lsim(:,1:Jwork) == 0.0 .and. lsim(:,2:Jwork+1) == 0.0 .and. adjsim(:,1:Jwork) == 0.0,dim=1)/real(nsim)
Ecstr5(Jwork+1:Jtot-1) 	= COUNT(lsim(:,Jwork+1:Jtot-1) == 0.0 .and. lsim(:,Jwork+2:Jtot) == 0.0 .and. adjsim(:,Jwork+2:Jtot) == 0.0,dim=1)/real(nsim)


Ecstr1noill                 = COUNT(lsim(:,2:Jtot)==0.0 .and. asim(:,2:Jtot)==0.0,dim=1)/real(nsim)
Ecstr2noill                 = COUNT(lsim(:,2:Jtot) .ne. 0.0 .and. asim(:,2:Jtot)==0.0,dim=1)/real(nsim)
Ecstr3noill(Jwork:Jtot-1) 	= COUNT(lsim(:,Jwork+1:Jtot) == 0.0 .and. adjsim(:,Jwork+1:Jtot) == 0.0 .and. asim(:,Jwork+1:Jtot)==0.0,dim=1)/real(nsim)
Ecstr4noill(1:Jwork)        = COUNT((lsim(:,1:Jwork) .ne. 0.0 .or. lsim(:,2:Jwork+1) .ne. 0.0 .or. adjsim(:,1:Jwork) == 1.0) .and. asim(:,2:Jwork+1)==0.0,dim=1)/real(nsim)
Ecstr4noill(Jwork+1:Jtot-1) = COUNT((lsim(:,Jwork+1:Jtot-1) == 0.0 .ne. lsim(:,Jwork+2:Jtot) .ne. 0.0 .or. adjsim(:,Jwork+2:Jtot) == 1.0) .and. asim(:,Jwork+2:Jtot)==0.0,dim=1)/real(nsim)
Ecstr5noill(1:Jwork)       	= COUNT(lsim(:,1:Jwork) == 0.0 .and. lsim(:,2:Jwork+1) == 0.0 .and. adjsim(:,1:Jwork) == 0.0 .and. asim(:,2:Jwork+1)==0.0,dim=1)/real(nsim)
Ecstr5noill(Jwork+1:Jtot-1) = COUNT(lsim(:,Jwork+1:Jtot-1) == 0.0 .and. lsim(:,Jwork+2:Jtot) == 0.0 .and. adjsim(:,Jwork+1:Jtot-1) == 0.0 .and. asim(:,Jwork+2:Jtot)==0.0,dim=1)/real(nsim)

IF(Borrowing==1) THEN
	Ecstr5(1:Jwork)=0.0
	Ecstr5noill(1:Jwork)=0.0
	Empccstr5(1:Jwork)=0.0
	Empccstr5noill(1:Jwork)=0.0

	ij = 1
	DO in=1,nsim
	IF( (lsim(in,ij) .eq. 0.0 .and. lsim(in,ij+1) .eq. abl(ij+1,fysimI(in),zysimI(in,ij))) .or. (lsim(in,ij) .eq. 0.0 .and. lsim(in,ij+1) .eq. 0.0) ) THEN
		IF(adjsim(in,ij) == 0.0) Ecstr5(ij) = Ecstr5(ij)+1.0
		IF(adjsim(in,ij) == 0.0 .and. asim(in,ij+1) == 0.0) Ecstr5noill(ij) = Ecstr5noill(ij)+1.0
	END IF
	END DO

	DO ij=2,Jwork-1
		DO in=1,nsim
		IF( (lsim(in,ij) .eq. abl(ij,fysimI(in),zysimI(in,ij-1)) .and. lsim(in,ij+1) .eq. abl(ij+1,fysimI(in),zysimI(in,ij))) .or. (lsim(in,ij) .eq. 0.0 .and. lsim(in,ij+1) .eq. 0.0) ) THEN
			IF(adjsim(in,ij) == 0.0) Ecstr5(ij) = Ecstr5(ij)+1.0
			IF(adjsim(in,ij) == 0.0 .and. asim(in,ij+1) == 0.0) Ecstr5noill(ij) = Ecstr5noill(ij)+1.0
		END IF
		END DO
	END DO
	
	ij = Jwork
	DO in=1,nsim
	IF (lsim(in,ij) .eq. 0.0 .and. lsim(in,ij+1) .eq. 0.0) THEN
		IF(adjsim(in,ij) == 0.0) Ecstr5(ij) = Ecstr5(ij)+1.0
		IF(adjsim(in,ij) == 0.0 .and. asim(in,ij+1) .eq. 0.0) Ecstr5noill(ij) = Ecstr5noill(ij)+1.0
	ENDIF
	ENDDO
	
	WHERE (Ecstr5(1:Jwork)>0.0)
		Empccstr5(1:Jwork) = Empccstr5(1:Jwork) / Ecstr5(1:Jwork)
		Empccstr5noill(1:Jwork) = Empccstr5noill(1:Jwork) / Ecstr5noill(1:Jwork)
	ELSEWHERE	
		Empccstr5(1:Jwork) = 0.0
	END WHERE
	Ecstr5(1:Jwork) = Ecstr5(1:Jwork)/real(nsim)
	Ecstr5noill(1:Jwork) = Ecstr5noill(1:Jwork)/real(nsim)
END IF

Vlogcon = SUM(log(csim(:,:))**2,dim=1)/real(nsim) -(SUM(log(csim(:,:)),dim=1)/real(nsim))**2
Vlogtotcon = SUM(log(ctotsim(:,:))**2,dim=1)/real(nsim) -(SUM(log(ctotsim(:,:)),dim=1)/real(nsim))**2
Vlogflow = SUM(log(flowsim(:,:))**2,dim=1)/real(nsim) -(SUM(log(flowsim(:,:)),dim=1)/real(nsim))**2
Vloglabinc = SUM(log(ysim(:,:))**2,dim=1,mask=usimI(:,:)==1)/real(count(usimI(:,:)==1,dim=1)) -(SUM(log(ysim(:,:)),dim=1,mask=usimI(:,:)==1)/real(count(usimI(:,:)==1,dim=1)))**2
Vloginc = SUM(log(ysim(:,:))**2,dim=1)/real(nsim) -(SUM(log(ysim(:,:)),dim=1)/real(nsim))**2
Vlogpen = SUM(log(psim(:,Jwork+1:Jtot))**2,dim=1)/real(nsim)-(SUM(log(psim(:,Jwork+1:Jtot)),dim=1)/real(nsim))**2

whichperc2 = (/0.10, 0.25, 0.5, 0.75, 0.90/)
DO ij = 1,Jtot
	DO id = 1,5
		CALL Percentile(nsimforpercJ,csim(1:nsimforpercJ,ij),whichperc2(id),DISTcon(ij,id))
		CALL Percentile(nsimforpercJ,asim(1:nsimforpercJ,ij),whichperc2(id),DISTass(ij,id))
		CALL Percentile(nsimforpercJ,lsim(1:nsimforpercJ,ij),whichperc2(id),DISTliq(ij,id))
		CALL Percentile(nsimforpercJ,lpl6sim(1:nsimforpercJ,ij),whichperc2(id),DISTlpl6(ij,id))
		CALL Percentile(nsimforpercJ,lpl3sim(1:nsimforpercJ,ij),whichperc2(id),DISTlpl3(ij,id))
	END DO
END DO

allagevec=reshape(asim(1:nsimforperc,1:Jtot),(/nsimforperc*Jtot/))
DO id = 1,5
	CALL Percentile(nsimforperc*Jtot,allagevec,whichperc2(id),DISTALLass(id))
END DO
allagevec=reshape(csim(1:nsimforperc,1:Jtot),(/nsimforperc*Jtot/))
DO id = 1,5
	CALL Percentile(nsimforperc*Jtot,allagevec,whichperc2(id),DISTALLcon(id))
END DO
allagevec=reshape(lsim(1:nsimforperc,1:Jtot),(/nsimforperc*Jtot/))
DO id = 1,5
	CALL Percentile(nsimforperc*Jtot,allagevec,whichperc2(id),DISTALLliq(id))
END DO
allagevec=reshape(lpl3sim(1:nsimforperc,1:Jtot),(/nsimforperc*Jtot/))
DO id = 1,5
	CALL Percentile(nsimforperc*Jtot,allagevec,whichperc2(id),DISTALLlpl3(id))
END DO
allagevec=reshape(lpl6sim(1:nsimforperc,1:Jtot),(/nsimforperc*Jtot/))
DO id = 1,5
	CALL Percentile(nsimforperc*Jtot,allagevec,whichperc2(id),DISTALLlpl6(id))
END DO


IF(nsim>1) THEN
DO ij = 1,Jtot
    tempvec=asim(1:nsimforpercJ,ij)
    CALL quick_sort(tempvec,sortorder)
    DO id=1,4
        MedLiqbyAssAge(ij,id)=lsim(sortorder((1+2*(id-1))*nsimforpercJ/8),ij)
        MedLiqplbyAssAge(ij,id)=lplsim(sortorder((1+2*(id-1))*nsimforpercJ/8),ij)

        MeanLiqbyAssAge(ij,id)=SUM(lsim(sortorder(1+(id-1)*nsimforpercJ/4:id*nsimforpercJ/4),ij),dim=1)/real(nsimforpercJ/4)
        MeanLiqplbyAssAge(ij,id)=SUM(lplsim(sortorder(1+(id-1)*nsimforpercJ/4:id*nsimforpercJ/4),ij),dim=1)/real(nsimforpercJ/4)
        
    ENDDO
    if(ij<=Jwork) then
        tempvec=ysim(1:nsimforpercJ,ij)
    else
        tempvec=psim(1:nsimforpercJ,ij)
    endif
    CALL quick_sort(tempvec,sortorder)
    DO id=1,4
        MedLiqbyIncAge(ij,id)=lsim(sortorder((1+2*(id-1))*nsimforpercJ/8),ij)
        MedLiqplbyIncAge(ij,id)=lplsim(sortorder((1+2*(id-1))*nsimforpercJ/8),ij)

        MeanLiqbyIncAge(ij,id)=SUM(lsim(sortorder(1+(id-1)*nsimforpercJ/4:id*nsimforpercJ/4),ij),dim=1)/real(nsimforpercJ/4)
        MeanLiqplbyIncAge(ij,id)=SUM(lplsim(sortorder(1+(id-1)*nsimforpercJ/4:id*nsimforpercJ/4),ij),dim=1)/real(nsimforpercJ/4)
        
    ENDDO

   	tempsigx=(real(nsimforpercJ)*SUM(lsim(1:nsimforpercJ,ij)**2,dim=1) - SUM(lsim(1:nsimforpercJ,ij),dim=1)**2)    
	tempsigy=(real(nsimforpercJ)*SUM(asim(1:nsimforpercJ,ij)**2,dim=1) - SUM(asim(1:nsimforpercJ,ij),dim=1)**2)    
	if(tempsigy*tempsigx > 0.0d0) then	
		CORRillliq(ij)=real(nsimforpercJ)*SUM(lsim(1:nsimforpercJ,ij)*asim(1:nsimforpercJ,ij),dim=1) - SUM(lsim(1:nsimforpercJ,ij),dim=1)*SUM(asim(1:nsimforpercJ,ij),dim=1)    	
		CORRillliq(ij)=CORRillliq(ij)/sqrt(tempsigx*tempsigy)    
	else	
		CORRillliq(ij)=-2.0d0    
	endif    
	tempsigx=(real(nsimforpercJ)*SUM(lplsim(1:nsimforpercJ,ij)**2,dim=1) - SUM(lplsim(1:nsimforpercJ,ij),dim=1)**2)    
	tempsigy=(real(nsimforpercJ)*SUM(asim(1:nsimforpercJ,ij)**2,dim=1) - SUM(asim(1:nsimforpercJ,ij),dim=1)**2)    
	if(tempsigy*tempsigx > 0.0d0) then	    
		CORRillliqpl(ij)=real(nsimforpercJ)*SUM(lplsim(1:nsimforpercJ,ij)*asim(1:nsimforpercJ,ij),dim=1) - SUM(lplsim(1:nsimforpercJ,ij),dim=1)*SUM(asim(1:nsimforpercJ,ij),dim=1)	    
		CORRillliqpl(ij)=CORRillliqpl(ij)/sqrt( tempsigx*tempsigy)    
	else	
		CORRillliqpl(ij)=-2.0d0    
	endif

END DO
END IF


!annual stats
DO ij = 1, (Jwork+Jret)/4
	jL = (ij-1)*4 +1
	jH = ij*4
	annEcon(ij) = SUM(csim(:,jL:jH))/real(nsim)
	IF (ij<Jwork/4) THEN
		annEinc(ij) = SUM(ysim(:,jL:jH))/real(nsim)
		annEincfe(ij) = sum(sum(ysim(:,jL:jH),dim=2),mask=sum(usimI(:,jL:jH),dim=2)==4)	/ real(count(sum(usimI(:,jL:jH),dim=2)==4))
		annElabinc(ij) = SUM(ysim(:,jL:jH),mask=usimI(:,jL:jH)==1)/real(nsim)
		annEuiben = SUM(ysim(:,jL:jH),mask=usimI(:,jL:jH)==2)/real(nsim)
	END IF
END DO

!aggregate wealth stats
lcapital = SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) + SUM(SUM(lsim(:,1:Jtot),DIM = 1)*popsize)
lincome = (1.0-qfree)*SUM(SUM(lsim(:,1:Jtot),DIM = 1,MASK = lsim(:,1:Jtot)>0)*popsize) + (1.0-qill)*SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) + SUM(ysim) + SUM(SUM(psim(:,Jwork+1:Jtot), DIM = 1)*popsize(Jwork+1:Jtot))
whichperc = (/0.25, 0.5, 0.75/)

!get annual income for ratios and percentiles
DO ij = 1,Jtot/4
	jL = (ij-1)*4 +1
	jH = ij*4
	annasim(:,ij) = asim(1:nsimforpercJ,jH-1)	!use value at start of 3rd quarter
	annlsim(:,ij) = lsim(1:nsimforpercJ,jH-1)	!!use value at start of 3rd quarter
	annlplsim(:,ij) = lplsim(1:nsimforpercJ,jH-1)	!!use value at start of 3rd quarter
	annincsim(:,ij) = sum(incsim(1:nsimforpercJ,jL:jH),DIM=2)
END DO


!summary stats

	write(*,*) '******************************'
	write(*,*) 'AGGREGATE WEALTH STATS :'
	write(*,*) 'tot liquid(pl) ass / tot income is			',SUM(SUM(lplsim(:,1:Jtot),DIM = 1)*popsize) / lincome
	write(*,*) 'tot liquid ass / tot income is			',SUM(SUM(lsim(:,1:Jtot),DIM = 1)*popsize) / lincome
	write(*,*) 'tot illiquid ass / tot income is		',SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) / lincome
	write(*,*) 'total ass / tot income is			',(SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) + SUM(SUM(lplsim(:,1:Jtot),DIM = 1)*popsize))/ lincome

	write(*,*) '******************************'
	write(*,*) 'DISTRIBUTION OF WEALTH TO INC:'

	ratiovec = reshape((annasim(1:nsimforperc,:)+annlsim(1:nsimforperc,:))/annincsim(1:nsimforperc,:),(/nsimforperc*Jtot/4 /))
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(1), lperc(1))	
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(2), lperc(2))	
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(3), lperc(3))	
	write(*,*) 'total assets/income: '
	write(*,*) '	mean (quarterly): ',SUM(SUM((lplsim(:,1:Jtot)+asim(:,1:Jtot))/incsim(:,1:Jtot),DIM = 1)*popsize) / real(nsim*sum(popsize))
	write(*,*) '	P25    (annual) : ',lperc(1)
	write(*,*) '	median (annual) : ',lperc(2)
	write(*,*) '	P 75   (annual) : ',lperc(3)

	ratiovec = reshape(annlsim(1:nsimforperc,:)/annincsim(1:nsimforperc,:),(/nsimforperc*Jtot/4 /))
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(1), lperc(1))	
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(2), lperc(2))	
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(3), lperc(3))	
	write(*,*) 'liquid (pl)/income: '
	write(*,*) '	mean (quarterly): ',SUM(SUM(lplsim(:,1:Jtot)/incsim(:,1:Jtot),DIM = 1)*popsize) / real(nsim*sum(popsize))
	write(*,*) '	P25    (annual) : ',lperc(1)
	write(*,*) '	median (annual) : ',lperc(2)
	write(*,*) '	P 75   (annual) : ',lperc(3)
	
	ratiovec = reshape(annasim(1:nsimforperc,:)/annincsim(1:nsimforperc,:),(/nsimforperc*Jtot/4 /))
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(1), lperc(1))	
	CALL Percentile (nsimforperc*Jwork/4, ratiovec, whichperc(2), lperc(2))	
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(3), lperc(3))	
	write(*,*) 'illiquid/inc: '
	write(*,*) '	mean (quarterly): ',SUM(SUM(asim(:,1:Jtot)/incsim(:,1:Jtot),DIM = 1)*popsize) / real(nsim*sum(popsize))
	write(*,*) '	P25    (annual) : ',lperc(1)
	write(*,*) '	median (annual) : ',lperc(2)
	write(*,*) '	P 75   (annual) : ',lperc(3)
	
	ratiovec = reshape(annasim(1:nsimforperc,:)+annlsim(1:nsimforperc,:),(/nsimforperc*Jtot/4 /))
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(1), lperc(1))	
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(2), lperc(2))	
	CALL Percentile (nsimforperc*Jtot/4, ratiovec, whichperc(3), lperc(3))	
	write(*,*) 'total assets (relative to mean quarterly earnings): '
	write(*,*) '	mean (quarterly): ',SUM(SUM((lplsim(:,1:Jtot)+asim(:,1:Jtot)),DIM = 1)*popsize) / real(nsim*sum(popsize))
	write(*,*) '	P25    (annual) : ',lperc(1)
	write(*,*) '	median (annual) : ',lperc(2)
	write(*,*) '	P 75   (annual) : ',lperc(3)


	write(*,*) '******************************'
	write(*,*) 'OTHER AGGREGATE STATS :'

	write(*,*) 'fraction adjusting is			',SUM(SUM(adjsim(:,1:Jtot),DIM = 1)*popsize) / SUM(nsim*popsize)
	write(*,*) 'mean deduction working age is		',SUM(Eded(1:Jwork)*popsize(1:Jwork)) / SUM(popsize(1:Jwork))
	write(*,*) 'consumption / income is		',SUM(SUM(csim,DIM = 1)*popsize) /lincome
	write(*,*) 'consumption / pregovt earnings is	' ,SUM(SUM(csim,DIM = 1)*popsize) / SUM(SUM(ysim,MASK = usimI==1,DIM = 1)*popsize(1:Jwork))  
	write(*,*) 'income tax / income is 		', SUM(SUM(taxsim,DIM = 1)*popsize) / lincome
	write(*,*) 'frac work pop with neg or zero liquid ass	',1.0 - SUM(Eliqpos(2:Jwork))/real(Jwork-1)
	write(*,*) 'frac work pop with neg liquid ass	',SUM(Eliqneg(2:Jwork))/real(Jwork-1)
	write(*,*) 'frac work pop with zero illiquid ass		',1.0 - SUM(Easspos(2:Jwork))/real(Jwork-1)
	write(*,*) 'acc bequest per new born is			',SUM(SUM(asim(:,Jwork+2:Jtot) + lsim(:,Jwork+2:Jtot),dim=1) * popsize(Jwork+2:Jtot)*(1.0-surprob(1:Jret-1))) / real(nsim)  

       latax = (1.0+nomretill)**0.25 - (1.0+nomretill*(1.0-illtax*(1.0-taxurcg)))**0.25
       lltax = (1.0+nomretliq)**0.25 - (1.0+nomretliq*(1.0-liqtax))**0.25
       write(*,*) 'lab tax pc = ',SUM(SUM(taxsim,DIM=1)*popsize)/SUM(nsim*popsize)
       write(*,*) 'latax = ',latax
       write(*,*) 'ill tax pc = ',SUM(SUM(asim(:,1:Jtot)*latax,DIM=1)*popsize)/SUM(nsim*popsize)
       write(*,*) 'lltax = ',lltax
       write(*,*) 'liq tax pc = ',SUM(SUM(lsim(:,1:Jtot)*lltax,DIM=1)*popsize)/SUM(nsim*popsize)
       write(*,*) 'con tax pc = ',SUM(SUM(csim*ctax,DIM=1)*popsize)/SUM(nsim*popsize)
       write(*,*) 'pension payments pc = ',SUM(SUM(psim(:,Jwork+1:Jtot),DIM=1)*popsize(Jwork+1:Jtot))/SUM(nsim*popsize)

	write(*,*) '******************************'


END SUBROUTINE LifecycleStats
