SUBROUTINE LoadData

USE Parameters
USE Globals

IMPLICIT NONE
INTEGER		:: ij,it,ib,n
REAL(8)		:: lb(0:3)
integer :: ioerror1, ioerror2
real(8),dimension(n_taxyears*(n_gridtax-1))	:: col1,col2,col3,col4

IF (FlatEarningsProfile==1) THEN
	kappay = 0.0
ELSE
	SELECT CASE (WhichStochModel)

		CASE(0) 
		lb(0) = -2.06665738921957d0
		lb(1) = 0.00858498077162529d0
		lb(2) = -4.09994229331142e-005
		lb(3) = -1.14130361947752e-007


		CASE(1) 
		lb(0) = -2.26672876755943d0
		lb(1) = 0.01535062662749d0
		lb(2) = -1.26657491105105e-004
		lb(3) = 1.943843618504977e-007

	END SELECT

	DO ij = 1,Jwork 
		kappay(ij) = lb(0)
		DO ib = 1,3
			kappay(ij) = kappay(ij) + ((140-Jwork+ij-1)**ib)*lb(ib)		
		END DO
	END DO
END IF

!job loss, job finding rates
OPEN(1, FILE = InputDir // 'quartsep.txt')
READ(1,*) jobloss
CLOSE(1)
OPEN(1, FILE = InputDir // 'quartfind.txt')
READ(1,*) jobfind
CLOSE(1)

IF(NoUnempShocks==1) THEN
	jobloss = 0.0
	jobfind = 1.0
END IF

IF(SmoothInitialUnemp==1) initialunemp = jobloss(1)/(jobloss(1)+jobfind(1))

IF(NoInitialWealth==0) THEN
	IF(ngpzy .gt. 1) THEN
		OPEN(1, FILE = InputDir // 'initwstr.txt')
		DO ij=1,ngpzy
			READ(1,*) initliqdist(ij,1),initliqdist(ij,2),initliq(ij),initilldist(ij,1),initilldist(ij,2),initill(ij),initnwdist(ij,1),initnwdist(ij,2),initnw(ij)
		END DO
		CLOSE(1)
	ELSE
		OPEN(1, FILE = InputDir // 'hetinitwbroad.txt')
		DO ij=1,ngpfylev
			READ(1,*) initliqdist(ij,1),initliqdist(ij,2),initliq(ij),initilldist(ij,1),initilldist(ij,2),initill(ij),initnwdist(ij,1),initnwdist(ij,2),initnw(ij)
		END DO
		CLOSE(1)
	END IF

	initliq=initliq/(DataAvAnnualEarns/real(Numeraire))
	initill=initill/(DataAvAnnualEarns/real(Numeraire))
	initnw=initnw/(DataAvAnnualEarns/real(Numeraire))

	IF(InfiniteFixedCostModel .eq. 1) THEN
		initliqdist=initnwdist
		initliq=initnw
		initill=0.0d0
	END IF
END IF

IF(NoDeathInRetirement==1)surprob(1:Jret-1) = 1.0
surprob(Jret) = 0.0



popsize(1:Jwork+1) = 1.0
DO ij = 1,Jret-1
	popsize(Jwork+ij+1) = popsize(Jwork+ij)*surprob(ij)
END DO

DO ij = 1,Jtot
	popdist(ij) = popsize(ij)/sum(popsize)
END DO

!breakpoints and interpolation data for tax functions
OPEN(UNIT=1, FILE = InputDir //'break_interpol.dat', STATUS='old', ACTION="read") 
READ(UNIT=1, FMT='(F16.3)',IOSTAT=ioerror1) gridtax
CLOSE(1)
IF (IOERROR1 .ne. 0) print *, 'error reading gridtax file'

OPEN(UNIT=2, FILE = InputDir //'aginc_coeff_interpol_col1.txt', STATUS='old', ACTION="read")
READ(2,FMT='(F16.3)', IOSTAT=ioerror2) col1
CLOSE(2)
!write(*,*) col1
OPEN(UNIT=2, FILE = InputDir //'aginc_coeff_interpol_col2.txt', STATUS='old', ACTION="read")
READ(2,FMT='(F16.3)', IOSTAT=ioerror2) col2
CLOSE(2)
!write(*,*) col2
OPEN(UNIT=2, FILE = InputDir //'aginc_coeff_interpol_col3.txt', STATUS='old', ACTION="read")
READ(2,FMT='(F16.3)', IOSTAT=ioerror2) col3
CLOSE(2)
!write(*,*) col3
OPEN(UNIT=2, FILE = InputDir //'aginc_coeff_interpol_col4.txt', STATUS='old', ACTION="read")
READ(2,FMT='(F16.3)', IOSTAT=ioerror2) col4
CLOSE(2)
!write(*,*) col4

n=1
DO it = 1,n_taxyears
	DO ib = 1,n_gridtax-1
		aginc_coeff(it,ib,1) = col1(n)
		aginc_coeff(it,ib,2) = col2(n)
		aginc_coeff(it,ib,3) = col3(n)
		aginc_coeff(it,ib,4) = col4(n)
		n = n+1
	END DO
END DO


END SUBROUTINE LoadData
