PROGRAM Main

USE Parameters
USE Globals

INTEGER	:: count
REAL(8), EXTERNAL	:: FnBeta

IF (ReadParameters==1) THEN
	count = NARGS()
	IF (count<2) THEN
		write(*,*) "need input parameter file name as argument if ReadParameters==1"
		stop
	ELSE
		CALL GETARG(1,InputParamFile)
	END IF
END IF

InitialSteadyState = .false.
FinalSteadyState = .false.
TransitionPath = .false.

IF (MatchKYRatio==0 .and. SolveTransition==0) THEN
	InitialSteadyState = .true.
    CALL SetParameters
    CALL AllocateArrays
    CALL LoadData
    CALL Grids
	CALL SetUpTimeVariables
    CALL DecisionsRet
    CALL Decisions
    CALL Simulate
	CALL LifecycleStats
	IF (DoRebateCalcs==1) THEN
		CALL StoreTimeDecisionRules
		CALL HomoRebate
	END IF
    CALL SaveOutput
END IF



IF (MatchKYRatio==1 .and. SolveTransition==0) THEN
	InitialSteadyState = .true.
    CALL SetParameters
    CALL AllocateArrays
    CALL LoadData
    CALL Grids
	CALL SetUpTimeVariables
    CALL rtflsp(FnBeta,0.98_8,0.99_8,1.0e-9_8,0.025_8)
	CALL LifecycleStats
	IF (DoRebateCalcs==1) THEN
		CALL StoreTimeDecisionRules
		InitialSteadyState = .false.
		TransitionPath = .true.
		CALL DecisionsRebate
		CALL SimulateTransition
		CALL AggregateTransitionPath
		TransitionPath = .false.
		CALL SaveOutput
		CALL RebateRegressions		
	END IF
    CALL SaveOutput
END IF
	
	
IF (SolveTransition==1) THEN

	!Solve initial steady state
	InitialSteadyState = .true.
	CALL SetParameters
	CALL AllocateArrays
	CALL LoadData
	CALL Grids
	write(*,*)'Solving initial steady state'
	CALL SetUpTimeVariables

	IF(MatchKYRatio==1) THEN 
	    CALL rtflsp(FnBeta,0.98_8,0.99_8,1.0e-9_8,0.025_8)
		CALL StoreTimeDecisionRules
	ELSE 
		CALL DecisionsRet
		CALL Decisions
		CALL StoreTimeDecisionRules
		CALL Simulate
	END IF
	CALL LifecycleStats
	CALL SaveOutput
	InitialSteadyState = .false.

	!Solve final steady state
	IF(sunset==0 .or. GovtBudgetConstraint==1) THEN
		IF(BushInc==1) THEN
			CALL SimulateTaxesTransition
		ELSE
			BushDebt=0.0d0
		END IF
		FinalSteadyState = .true.
		write(*,*)'Solving final state'
		CALL SetUpTimeVariables
		CALL DecisionsRet
		CALL Decisions
		CALL StoreTimeDecisionRules
		FinalSteadyState = .false.
	END IF
	
	!Solve Transition
	TransitionPath = .true.
	CALL Transition
	IF(IncRebate == 1) THEN
		CALL IncomeRebate
	ELSE
		CALL HomoRebate
	END IF

END IF


END PROGRAM Main
