SUBROUTINE SaveOutput

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE
REAL(8), ALLOCATABLE		:: larray(:,:)
REAL(8)			:: lincome
INTEGER		:: it,ij

write(*,*) 'Saving output to disk'

!PARAMETERS
OPEN(3, FILE = trim(OutputDir) // 'Jwork.txt', STATUS = 'replace');WRITE(3,*) Jwork;CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // 'Jret.txt', STATUS = 'replace');WRITE(3,*) Jret;CLOSE(3) 
OPEN(3, FILE = trim(OutputDir)// 'nsim.txt', STATUS = 'replace');WRITE(3,*) nsim;CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'nsimtrans.txt', STATUS = 'replace');WRITE(3,*) nsimtrans;CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'nsimrebateB.txt', STATUS = 'replace');WRITE(3,*) nsimrebateB;CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'nsimrebateA.txt', STATUS = 'replace');WRITE(3,*) nsimrebateA;CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'bet.txt', STATUS = 'replace');WRITE(3,*) bet;CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'taxbase.txt', STATUS = 'replace');WRITE(3,*) taxbase;CLOSE(3)

rebateamt = DOT_PRODUCT(rebgrid,rebdist)


OPEN(3, FILE = trim(OutputDir)// 'taxincr.txt', STATUS = 'replace')
WRITE(3,*) (0.5*rebateamt*(1.0+qgov)*(1.0-qgov)/(qgov**npergovbc)+(1.0d0-qgov)*qgov*BushDebt/(qgov**(npergovbc-40)))/taxbase
CLOSE(3)

OPEN(3, FILE = trim(OutputDir)// 'constrained.txt', STATUS = 'replace')
WRITE(3,*) real(SUM(numspells))/real(nsim),real(SUM(spelllength))/(1.0d-3+real(SUM(numspells)))
CLOSE(3)

OPEN(3, FILE = trim(OutputDir)// 'avespellsim.txt', STATUS = 'replace')
CALL WriteVector(3,1,nsim,avespell)
CLOSE(3)

OPEN(3, FILE = trim(OutputDir)// 'numspellsim.txt', STATUS = 'replace')
CALL WriteVectorInteger(3,1,nsim,numspells)
CLOSE(3)

OPEN(3, FILE = trim(OutputDir) // 'DISTALLass.txt', STATUS = 'replace')
CALL WriteVector(3,1,5,DISTALLass)
CLOSE(3)

OPEN(3, FILE = trim(OutputDir) // 'DISTALLcon.txt', STATUS = 'replace')
CALL WriteVector(3,1,5,DISTALLcon)
CLOSE(3)

OPEN(3, FILE = trim(OutputDir) // 'DISTALLliq.txt', STATUS = 'replace')
CALL WriteVector(3,1,5,DISTALLliq)
CLOSE(3)

OPEN(3, FILE = trim(OutputDir) // 'DISTALLlpl3.txt', STATUS = 'replace')
CALL WriteVector(3,1,5,DISTALLlpl3)
CLOSE(3)

OPEN(3, FILE = trim(OutputDir) // 'DISTALLlpl6.txt', STATUS = 'replace')
CALL WriteVector(3,1,5,DISTALLlpl6)
CLOSE(3)




IF(SaveSimulations==1) THEN
	OPEN(3, FILE = trim(OutputDirSims) // 'asim.txt', STATUS = 'replace')
	CALL WriteMatrixCSVExpon(3,nsim,Jtot+1,asim)

	OPEN(3, FILE = trim(OutputDirSims) // 'lsim.txt', STATUS = 'replace')
	CALL WriteMatrixCSVExpon(3,nsim,Jtot+1,lsim)

	OPEN(3, FILE = trim(OutputDirSims)// 'ysim.txt', STATUS = 'replace')
	CALL WriteMatrixCSV(3,nsim,Jwork,ysim)

	OPEN(3, FILE = trim(OutputDirSims)// 'yavsim.txt', STATUS = 'replace')
	CALL WriteMatrixCSV(3,nsim,Jwork,yavsim)

	OPEN(3, FILE = trim(OutputDirSims)// 'ypssim.txt', STATUS = 'replace')
	CALL WriteMatrixCSV(3,nsim,Jwork,ypssim)

	OPEN(3, FILE = trim(OutputDirSims)// 'xsim.txt', STATUS = 'replace')
	CALL WriteMatrixCSV(3,nsim,Jtot,xsim)

	OPEN(3, FILE = trim(OutputDirSims) // 'csim.txt', STATUS = 'replace')
	CALL WriteMatrixCSVExpon(3,nsim,Jtot,csim)
	OPEN(3, FILE = trim(OutputDirSims) // 'ablsim.txt', STATUS = 'replace'); CALL WriteMatrixCSVExpon(3,nsim,Jwork,ablsim)

	OPEN(3, FILE = trim(OutputDirSims) // 'ssim.txt', STATUS = 'replace')
	CALL WriteMatrixCSVExpon(3,nsim,Jtot,ssim)

	OPEN(3, FILE = trim(OutputDirSims) // 'adjsim.txt', STATUS = 'replace')
	CALL WriteMatrixCSV(3,nsim,Jtot,adjsim)

	OPEN(3, FILE = trim(OutputDirSims) // 'Vsim.txt', STATUS = 'replace')
	CALL WriteMatrixCSVExpon(3,nsim,Jtot,Vsim)

	OPEN(3, FILE = trim(OutputDirSims) // 'dVsim.txt', STATUS = 'replace')
	CALL WriteMatrixCSVExpon(3,nsim,Jtot,dVsim)

	OPEN(3, FILE = trim(OutputDirSims) // 'taxsim.txt', STATUS = 'replace')
	CALL WriteMatrixCSV(3,nsim,Jtot,taxsim)


	OPEN(3, FILE = trim(OutputDirSims) // 'psim.txt', STATUS = 'replace')
	CALL WriteMatrixCSV(3,nsim,Jtot,psim)

	OPEN(3, FILE = trim(OutputDirSims) // 'zysimI.txt', STATUS = 'replace')
	CALL WriteMatrixCSVInteger(3,nsim,Jwork,zysimI)

	OPEN(3, FILE = trim(OutputDirSims) // 'eysimI.txt', STATUS = 'replace')
	CALL WriteMatrixCSVInteger(3,nsim,Jwork,eysimI)

	OPEN(3, FILE = trim(OutputDirSims) // 'usimI.txt', STATUS = 'replace')
	CALL WriteMatrixCSVInteger(3,nsim,Jwork,usimI)

	OPEN(3, FILE = trim(OutputDirSims) // 'fysimI.txt', STATUS = 'replace')
	CALL WriteMatrixInteger(3,nsim,1,fysimI)


END IF

!LIFECYCLE PROFILES

OPEN(3, FILE = trim(OutputDir) // 'Eliqpl.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Eliqpl)

OPEN(3, FILE = trim(OutputDir) // 'Eliqpl3.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Elpl3)

OPEN(3, FILE = trim(OutputDir) // 'Elpl6.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Elpl6)

OPEN(3, FILE = trim(OutputDir) // 'Eliq0.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eliq0)

OPEN(3, FILE = trim(OutputDir) // 'Eass.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eass)

OPEN(3, FILE = trim(OutputDir) // 'Easspos.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Easspos)

OPEN(3, FILE = trim(OutputDir) // 'Esavpos.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Esavpos)

OPEN(3, FILE = trim(OutputDir) // 'Eaposliq0.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eaposliq0)

OPEN(3, FILE = trim(OutputDir) // 'Eliqpos.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eliqpos)

OPEN(3, FILE = trim(OutputDir) // 'Eliq.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eliq)

OPEN(3, FILE = trim(OutputDir) // 'Eliqlim.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eliqlim)

OPEN(3, FILE = trim(OutputDir) // 'Eliqlimapos.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eliqlimapos)

OPEN(3, FILE = trim(OutputDir) // 'Eliqposapos.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eliqposapos)

OPEN(3, FILE = trim(OutputDir) // 'PRded.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,ngpd,PRded)

OPEN(3, FILE = trim(OutputDir) // 'Eded.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot+1,1,Eded)

OPEN(3, FILE = trim(OutputDir) // 'Econ.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Econ)

OPEN(3, FILE = trim(OutputDir) // 'Etotcon.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Etotcon)

OPEN(3, FILE = trim(OutputDir) // 'Eflow.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Eflow)

OPEN(3, FILE = trim(OutputDir) // 'Empc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Empc)

OPEN(3, FILE = trim(OutputDir) // 'Empadj.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Empadj)

OPEN(3, FILE = trim(OutputDir) // 'Eadj.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Eadj)

OPEN(3, FILE = trim(OutputDir) // 'Eadjcost.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Eadjcost)

OPEN(3, FILE = trim(OutputDir) // 'Vlogcon.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Vlogcon)

OPEN(3, FILE = trim(OutputDir) // 'Vlogtotcon.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Vlogtotcon)

OPEN(3, FILE = trim(OutputDir) // 'Vlogflow.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Vlogflow)

OPEN(3, FILE = trim(OutputDir) // 'Etax.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,Etax)

OPEN(3, FILE = trim(OutputDir) // 'CORRillliq.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,CORRillliq)

OPEN(3, FILE = trim(OutputDir) // 'CORRillliqpl.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,1,CORRillliqpl)


OPEN(3, FILE = trim(OutputDir) // 'Einc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Einc)

OPEN(3, FILE = trim(OutputDir) // 'Vloginc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Vloginc)

OPEN(3, FILE = trim(OutputDir) // 'Vloglabinc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Vloglabinc)

OPEN(3, FILE = trim(OutputDir) // 'Eyav.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Eyav)

OPEN(3, FILE = trim(OutputDir) // 'Eunemp.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Eunemp)

OPEN(3, FILE = trim(OutputDir) // 'Elabinc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Elabinc)

OPEN(3, FILE = trim(OutputDir) // 'Enetlabinc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Enetlabinc)

OPEN(3, FILE = trim(OutputDir) // 'Euiben.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork,1,Euiben)

OPEN(3, FILE = trim(OutputDir) // 'annEinc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork/4,1,annEinc)

OPEN(3, FILE = trim(OutputDir) // 'annEincfe.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork/4,1,annEincfe)

OPEN(3, FILE = trim(OutputDir) // 'annElabinc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork/4,1,annElabinc)

OPEN(3, FILE = trim(OutputDir) // 'annEuiben.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork/4,1,annEuiben)

OPEN(3, FILE = trim(OutputDir) // 'annEcon.txt', STATUS = 'replace')
CALL WriteMatrix(3,(Jwork+Jret)/4,1,annEcon)

OPEN(3, FILE = trim(OutputDir) // 'Epen.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jret,1,Epen)

OPEN(3, FILE = trim(OutputDir) // 'Vlogpen.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jret,1,Vlogpen)

OPEN(3, FILE = trim(OutputDir) // 'DISTcon.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,5,DISTcon)

OPEN(3, FILE = trim(OutputDir) // 'DISTass.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,5,DISTass)

OPEN(3, FILE = trim(OutputDir) // 'DISTliq.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,5,DISTliq)

OPEN(3, FILE = trim(OutputDir) // 'DISTlpliq.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,5,DISTlpliq)

OPEN(3, FILE = trim(OutputDir) // 'DISTlpl3.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,5,DISTlpl3)

OPEN(3, FILE = trim(OutputDir) // 'DISTlpl6.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,5,DISTlpl6)

OPEN(3, FILE = trim(OutputDir) // 'MedLiqbyAssAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MedLiqbyAssAge)

OPEN(3, FILE = trim(OutputDir) // 'MeanLiqplbyIncAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MeanLiqplbyIncAge)

OPEN(3, FILE = trim(OutputDir) // 'MeanLiqbyIncAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MeanLiqbyIncAge)

OPEN(3, FILE = trim(OutputDir) // 'MedLiqplbyIncAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MedLiqplbyIncAge)

OPEN(3, FILE = trim(OutputDir) // 'MedLiqbyIncAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MedLiqbyIncAge)

OPEN(3, FILE = trim(OutputDir) // 'MeanLiqplbyAssAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MeanLiqplbyAssAge)

OPEN(3, FILE = trim(OutputDir) // 'MedLiqplbyAssAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MedLiqplbyAssAge)

OPEN(3, FILE = trim(OutputDir) // 'MeanLiqbyAssAge.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jtot,4,MeanLiqbyAssAge)


OPEN(3, FILE = trim(OutputDir) // 'Ecstr1.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr1)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr2.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr2)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr3.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr3)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr4.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr4)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr5.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr5)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr1noill.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr1noill)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr2noill.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr2noill)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr3noill.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr3noill)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr4noill.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr4noill)
OPEN(3, FILE = trim(OutputDir) // 'Ecstr5noill.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Ecstr5noill)
OPEN(3, FILE = trim(OutputDir) // 'Empccstr1.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Empccstr1)
OPEN(3, FILE = trim(OutputDir) // 'Empccstr2.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Empccstr2)
OPEN(3, FILE = trim(OutputDir) // 'Empccstr3.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Empccstr3)
OPEN(3, FILE = trim(OutputDir) // 'Empccstr4.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Empccstr4)
OPEN(3, FILE = trim(OutputDir) // 'Empccstr5.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Empccstr5)
OPEN(3, FILE = trim(OutputDir) // 'Empccstr4noill.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Empccstr4noill)
OPEN(3, FILE = trim(OutputDir) // 'Empccstr5noill.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot-1,1,Empccstr5noill)
OPEN(3, FILE = trim(OutputDir) // 'Eliq0negnoadj.txt', STATUS = 'replace');CALL WriteMatrix(3,Jtot,1,Eliq0negnoadj)


!INSURANCE COEFFICIENTS
OPEN(3, FILE = trim(OutputDir) // 'phieps.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork-1,1,phieps)

OPEN(3, FILE = trim(OutputDir) // 'vareps.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork-1,1,vareps)

OPEN(3, FILE = trim(OutputDir) // 'covepsDc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork-1,1,covepsDc)

OPEN(3, FILE = trim(OutputDir) // 'phieta.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork-1,1,phieta)

OPEN(3, FILE = trim(OutputDir) // 'vareta.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork-1,1,vareta)

OPEN(3, FILE = trim(OutputDir) // 'covetaDc.txt', STATUS = 'replace')
CALL WriteMatrix(3,Jwork-1,1,covetaDc)

!10 YEAR INTERVAL STATS
OPEN(3, FILE = trim(OutputDir) // 'Eadj10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,Eadj10yr)

OPEN(3, FILE = trim(OutputDir) // 'Empc10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,Empc10yr)

OPEN(3, FILE = trim(OutputDir) // 'MEDliq10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,MEDliq10yr)

OPEN(3, FILE = trim(OutputDir) // 'MEDass10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,MEDass10yr)

OPEN(3, FILE = trim(OutputDir) // 'MEDtot10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,MEDtot10yr)

OPEN(3, FILE = trim(OutputDir) // 'MEDliq2inc10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,MEDliq2inc10yr)

OPEN(3, FILE = trim(OutputDir) // 'MEDass2inc10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,MEDass2inc10yr)

OPEN(3, FILE = trim(OutputDir) // 'MEDtot2inc10yr.txt', STATUS = 'replace')
CALL WriteMatrix(3,5,1,MEDtot2inc10yr)

IF(SolveTransition==1 .or. DoRebateCalcs==1) THEN
	OPEN(3, FILE = trim(OutputDir) // 'pathEage.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEage)

	OPEN(3, FILE = trim(OutputDir) // 'pathEinc.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEinc)

	OPEN(3, FILE = trim(OutputDir) // 'pathElabinc.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathElabinc)

	OPEN(3, FILE = trim(OutputDir) // 'pathEuiben.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEuiben)

	OPEN(3, FILE = trim(OutputDir) // 'pathEunemp.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEunemp)

	OPEN(3, FILE = trim(OutputDir) // 'pathEcon.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEcon)

	OPEN(3, FILE = trim(OutputDir) // 'pathEass.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEass)

	OPEN(3, FILE = trim(OutputDir) // 'pathEliq.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEliq)

	OPEN(3, FILE = trim(OutputDir) // 'pathEadjust.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEadjust)

	OPEN(3, FILE = trim(OutputDir) // 'pathEtax.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEtax)

	OPEN(3, FILE = trim(OutputDir) // 'pathEasspos.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEasspos)

	OPEN(3, FILE = trim(OutputDir) // 'pathEliqpos.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEliqpos)


	OPEN(3, FILE = trim(OutputDir) // 'pathEcstr5.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEcstr5)
	OPEN(3, FILE = trim(OutputDir) // 'pathEcstr5noill.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEcstr5noill)
	OPEN(3, FILE = trim(OutputDir) // 'pathEliqlim.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEliqlim)
	OPEN(3, FILE = trim(OutputDir) // 'pathEliqlimapos.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEliqlimapos)
	OPEN(3, FILE = trim(OutputDir) // 'path0liq.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,path0liq)
	OPEN(3, FILE = trim(OutputDir) // 'path0liqposill.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,path0liqposill)
	OPEN(3, FILE = trim(OutputDir) // 'pathposliqposill.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathposliqposill)





	OPEN(3, FILE = trim(OutputDir) // 'pathEpen.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEpen)

	OPEN(3, FILE = trim(OutputDir) // 'pathEdie.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEdie)

	OPEN(3, FILE = trim(OutputDir) // 'pathErebate.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathErebate)

	OPEN(3, FILE = trim(OutputDir) // 'pathEavrebsize.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,3,pathEavrebsize)
	
	!REBATE REGRESSIONS
	OPEN(3, FILE = trim(OutputDir) // 'table2coef.txt', STATUS = 'replace')
	CALL WriteMatrix(3,5,4,table2coef)
	
	OPEN(3, FILE = trim(OutputDir) // 'table3coef.txt', STATUS = 'replace')
	CALL WriteMatrix(3,5,4,table3coef)

	OPEN(3, FILE = trim(OutputDir) // 'table4coef.txt', STATUS = 'replace')
	CALL WriteMatrix(3,5,4,table4coef)

	OPEN(3, FILE = trim(OutputDir) // 'table5coef.txt', STATUS = 'replace')
	CALL WriteMatrix(3,5,4,table5coef)

	OPEN(3, FILE = trim(OutputDir) // 'tablecoefbyliq.txt', STATUS = 'replace')
	CALL WriteMatrix3(3,5,4,3,tablecoefbyliq)

	OPEN(3, FILE = trim(OutputDir) // 'tablecoefbylpl.txt', STATUS = 'replace')
	CALL WriteMatrix3(3,5,4,3,tablecoefbylpl)

	OPEN(3, FILE = trim(OutputDir) // 'tablecoefbyinc.txt', STATUS = 'replace')
	CALL WriteMatrix3(3,5,4,3,tablecoefbyinc)

	OPEN(3, FILE = trim(OutputDir) // 'tablecoefbyage.txt', STATUS = 'replace')
	CALL WriteMatrix3(3,5,4,3,tablecoefbyage)

	OPEN(3, FILE = trim(OutputDir) // 'tableliqagecoef.txt', STATUS = 'replace')
	CALL WriteMatrix3(3,4,12,Jtot,tableliqagecoef)

	OPEN(3, FILE = trim(OutputDir) // 'tablelplagecoef.txt', STATUS = 'replace')
	CALL WriteMatrix3(3,4,12,Jtot,tablelplagecoef)

	OPEN(3, FILE = trim(OutputDir) // 'tableagecoef.txt', STATUS = 'replace')
	CALL WriteMatrix3(3,4,4,Jtot,tableagecoef)

	
	
	!AGE PATHS
	OPEN(3, FILE = trim(OutputDir) // 'agepathEage.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEage)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEinc.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEinc)

	OPEN(3, FILE = trim(OutputDir) // 'agepathElabinc.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathElabinc)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEuiben.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEuiben)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEunemp.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEunemp)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEcon.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEcon)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEsav.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEsav)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEass.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEass)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEliq.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEliq)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEcash.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEcash)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEadjust.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEadjust)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEtax.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEtax)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEasspos.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEasspos)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEliqpos.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEliqpos)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEpen.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEpen)

	OPEN(3, FILE = trim(OutputDir) // 'agepathEdie.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathEdie)

	OPEN(3, FILE = trim(OutputDir) // 'agepathErebate.txt', STATUS = 'replace')
	CALL WriteMatrixLH(3,-1,Ttransition+Tadditionalsim,12,agepathErebate)
	
	
	
	!create file with some statistics
	lincome = (1.0-qfree)*SUM(SUM(lsim(:,1:Jtot),DIM = 1,MASK = lsim(:,1:Jtot)>0)*popsize) + (1.0-qill)*SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) + SUM(ysim) + SUM(SUM(psim(:,Jwork+1:Jtot), DIM = 1)*popsize(Jwork+1:Jtot))	
	OPEN(3, FILE = trim(OutputDir) // 'rebatestats.txt', STATUS = 'replace')
	write(3,*) SUM(SUM(adjsim(:,1:Jtot),DIM = 1)*popsize) / SUM(nsim*popsize) !frac adjust
	write(3,*) SUM(SUM(lsim(:,1:Jtot),DIM = 1)*popsize) / lincome !tot liquid ass / tot income is			
	write(3,*) SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) / lincome !tot illiquid ass / tot income is
	write(3,*) (SUM(SUM(asim(:,1:Jtot),DIM = 1)*popsize) + SUM(SUM(lsim(:,1:Jtot),DIM = 1)*popsize))/ lincome !total ass / tot income is			
	write(3,*) (pathEcon(0,2)-pathEcon(0,1))/rebateamt
	write(3,*) (pathEcon(0,3)-pathEcon(0,1))/rebateamt
	write(3,*) (pathEcon(1,2)-pathEcon(1,1))/rebateamt
	write(3,*) (pathEcon(1,3)-pathEcon(1,1))/rebateamt
	write(3,*) (pathEcon(2,2)-pathEcon(2,1))/rebateamt
	write(3,*) (pathEcon(2,3)-pathEcon(2,1))/rebateamt
	write(3,*) (pathEcon(3,2)-pathEcon(3,1))/rebateamt
	write(3,*) (pathEcon(3,3)-pathEcon(3,1))/rebateamt
	write(3,*) table2coef(1,1)
	CLOSE(3)
	
	IF(SaveRebateSims==1) THEN !output sims from t=-1 to t=2
		IF (ALLOCATED(larray)) DEALLOCATE(larray)
		ALLOCATE(larray(nsimtrans,14))

        OPEN(3, FILE = trim(OutputDirSims) // 'simCstr5.txt', STATUS = 'replace');CALL WriteVectorInteger(3,1,nsimtrans,Simcstr5)
        OPEN(3, FILE = trim(OutputDirSims) // 'simCstr5noill.txt', STATUS = 'replace');CALL WriteVectorInteger(3,1,nsimtrans,Simcstr5noill)
                

		DO it = 1,14; larray(:,it) = simtrans(it-2)%jsim(:)*1.0;END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'agesimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)
		
		DO it = 1,14; larray(:,it) = simtrans(it-2)%csim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'csimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)

		DO it = 1,14; larray(:,it) = simtrans(it-2)%ctotsim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'ctotsimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)

		DO it = 1,14; larray(:,it) = simtrans(it-2)%rebsim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'rebsimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)

		DO it = 1,14; larray(:,it) = simtrans(it-2)%lsim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'lsimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)
	
		DO it = 1,14; larray(:,it) = simtrans(it-2)%asim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'asimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)
	
		DO it = 1,14; larray(:,it) = simtrans(it-2)%adjsim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'adjsimREB.txt', STATUS = 'replace');CALL WriteMatrixCSV(3,nsimtrans,14,larray)

		DO it = 1,14; larray(:,it) = simtrans(it-2)%ysim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'ysimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)

		DO it = 1,14; larray(:,it) = simtrans(it-2)%taxsim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'taxsimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)

		DO it = 1,14; larray(:,it) = simtrans(it-2)%psim(:);END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'psimREB.txt', STATUS = 'replace');CALL WriteMatrixCSVExpon(3,nsimtrans,14,larray)
	
	END IF
	
	IF (SaveTransitionSims==1) THEN
		IF (ALLOCATED(larray)) DEALLOCATE(larray)
		ALLOCATE(larray(nsimtrans,Ttransition+Tadditionalsim+3))
		
		DO it = 1,Ttransition+Tadditionalsim+3
			larray(:,it) = simtrans(it-2)%csim(:)
		END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'csimTR.txt', STATUS = 'replace')
		CALL WriteMatrixCSVExpon(3,nsimtrans,Ttransition+Tadditionalsim+3,larray)

		DO it = 1,Ttransition+Tadditionalsim+3
			larray(:,it) = simtrans(it-2)%asim(:)
		END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'asimTR.txt', STATUS = 'replace')
		CALL WriteMatrixCSVExpon(3,nsimtrans,Ttransition+Tadditionalsim+3,larray)
	
		DO it = 1,Ttransition+Tadditionalsim+3
			larray(:,it) = simtrans(it-2)%lsim(:)
		END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'lsimTR.txt', STATUS = 'replace')
		CALL WriteMatrixCSVExpon(3,nsimtrans,Ttransition+Tadditionalsim+3,larray)

		DO it = 1,Ttransition+Tadditionalsim+3
			larray(:,it) = simtrans(it-2)%xsim(:)
		END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'xsimTR.txt', STATUS = 'replace')
		CALL WriteMatrixCSVExpon(3,nsimtrans,Ttransition+Tadditionalsim+3,larray)

		DO it = 1,Ttransition+Tadditionalsim+3
			larray(:,it) = simtrans(it-2)%jsim(:)*1.0
		END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'jsimTR.txt', STATUS = 'replace')
		CALL WriteMatrixCSVExpon(3,nsimtrans,Ttransition+Tadditionalsim+3,larray)
		
		DO it = 1,Ttransition+Tadditionalsim+3
			larray(:,it) = simtrans(it-2)%rebsim(:)
		END DO
		OPEN(3, FILE = trim(OutputDirSims) // 'rebsimTR.txt', STATUS = 'replace')
		CALL WriteMatrixCSVExpon(3,nsimtrans,Ttransition+Tadditionalsim+3,larray)
	
		DEALLOCATE(larray)
	END IF
	
END IF

END SUBROUTINE SaveOutput
