SUBROUTINE SetUpTimeVariables

USE Parameters
USE Globals

IMPLICIT NONE

INTEGER	:: year, quarter,ij

IF(InitialSteadyState == .true.) THEN
	taxincr = 0.0
	taxincrN = 0.0
	
	rebatenext = 0
	IF (NoChangeTaxSystem==1) THEN
		taxsys = WhichTaxSystem
		taxsysN = WhichTaxSystem
	ELSE
		taxsys = 1
		taxsysN = 1 
	END IF
END IF

IF(FinalSteadyState == .true.) THEN
	rebatenext = 0
	IF (NoChangeTaxSystem==1) THEN
		taxsys = WhichTaxSystem
		taxsysN = WhichTaxSystem
	ELSE IF(sunset==1) THEN	
		taxsys = 1
		taxsysN = 1
	ELSE IF (sunset==0) THEN
		taxsys = 6
		taxsysN = 6
	END IF
	
	IF(GovtBudgetConstraint==0) THEN
		taxincr = 0.0
		taxincrN = 0.0
	ELSE IF(GovtBudgetConstraint==1) THEN
		rebateamt = DOT_PRODUCT(rebgrid,rebdist)
		IF(BushInc==1) THEN
			taxincr=(0.5*rebateamt*(1.0+qgov)*(1.0-qgov)/(qgov**npergovbc)+(1.0d0-qgov)*qgov*BushDebt/(qgov**(npergovbc-40)))/taxbase
		ELSE
			taxincr = 0.5*rebateamt*(1.0+qgov)*(1.0-qgov)/((qgov**npergovbc)*taxbase)
		END IF
		taxincrN = taxincr
	END IF

END IF


IF(TransitionPath == .true.) THEN	!time is quarters past announcement
	taxincr = 0.0

	IF (NoChangeTaxSystem==1) THEN
		taxsys = WhichTaxSystem
		taxsysN = WhichTaxSystem
		IF(time==Ttransition) THEN
			rebateamt = DOT_PRODUCT(rebgrid,rebdist)
			IF(GovtBudgetConstraint==1) taxincrN = 0.5*rebateamt*(1.0+qgov)*(1.0-qgov)/((qgov**npergovbc)*taxbase)
			IF(GovtBudgetConstraint==0) taxincrN = 0.0
		END IF
	ELSE
		
		!work out current year and quarter
		IF (time<=4-announcequ) THEN !in 2001
			year = 2001
			quarter = announcequ + time
		ELSE
			year = 2001 + (announcequ+time-1-mod(announcequ+time-1,4))/4
			quarter = mod(announcequ+time-1,4) + 1
		END IF
	
		!set current tax system
		SELECT CASE(year)
			CASE(2001)
				taxsys = 1
			CASE(2002)
				taxsys = 2
			CASE(2003)
				taxsys = 3
			CASE(2004)
				taxsys = 4
			CASE(2005)
				taxsys = 5
			CASE(2006:2010)
				taxsys = 6
			CASE(2011:)
				IF (sunset==1) taxsys = 1
				IF (sunset==0) taxsys = 6
		END SELECT

	
	 	!set next quarter tax system
		IF(quarter<4) THEN
			taxsysN = taxsys
		 
		ELSE IF (quarter==4) THEN

			IF(time<Ttransition) THEN
				IF(year<2006) taxsysN = taxsys+1
				IF(year>=2006) taxsysN = 6				
			END IF 

			IF (time==Ttransition) THEN
				IF(sunset==1) THEN	
					taxsysN = 1
				ELSE IF (sunset==0) THEN
					taxsysN = 6
				END IF				
			END IF

		END IF

		IF(time<Ttransition) THEN
			taxincrN = 0.0
		ELSE IF (time==Ttransition) THEN
			IF(GovtBudgetConstraint==0)taxincrN = 0.0
			IF(GovtBudgetConstraint==1) THEN

				rebateamt = DOT_PRODUCT(rebgrid,rebdist)
				IF(BushInc==1) THEN
					taxincrN=(0.5*rebateamt*(1.0+qgov)*(1.0-qgov)/(qgov**npergovbc)+(1.0d0-qgov)*qgov*BushDebt/(qgov**(npergovbc-40)))/taxbase				
				ELSE
					taxincrN = 0.5*rebateamt*(1.0+qgov)*(1.0-qgov)/((qgov**npergovbc)*taxbase)
				ENDIF
				
			END IF
		END IF


	END IF
	
	IF(ModelRecession==1) THEN
		IF(time<=recndrop-1) THEN	!-1 since time=0 is period of surprise
			ygrid = MERGE((1.0-(time+1)*recdepthcond/real(recndrop))*holdygrid,holdygrid,ygrid .le. recylim)
			ypsgrid = MERGE((1.0-(time+1)*recdepthcond/real(recndrop))*holdypsgrid,holdypsgrid,ypsgrid .le. recylim)
			!pgrid = (1.0-(time+1)*recdepth/real(recndrop))*holdpgrid
			pgrid = holdpgrid
		ELSE IF(time<=recngrow+recndrop-1) THEN
			ygrid = MERGE((1.0-recdepthcond + (time+1-recndrop)*recdepthcond/real(recngrow))*holdygrid,holdygrid,ygrid .le. recylim)
			ypsgrid = MERGE((1.0-recdepthcond + (time+1-recndrop)*recdepthcond/real(recngrow))*holdypsgrid,holdypsgrid,ypsgrid .le. recylim)
! 			pgrid = (1.0-recdepth + (time+1-recndrop)*recdepth/real(recngrow))*holdpgrid
			pgrid = holdpgrid				
		ELSE
			ygrid = holdygrid
			ypsgrid = holdypsgrid
			pgrid = holdpgrid				
		END IF
	END IF
	
	!solve rebate decisions separatelty
	rebatenext = 0
	
	IF(time<Ttransition) THEN
		emucnext = dectrans(time+1)%emuc
		evalnext = dectrans(time+1)%eval
		hfnnext = dectrans(time+1)%hfn
		emucretnext = dectrans(time+1)%emucret
		evalretnext = dectrans(time+1)%evalret
		hfnretnext = dectrans(time+1)%hfnret
		emucretJ1next = dectrans(time+1)%emucretJ1
		evalretJ1next = dectrans(time+1)%evalretJ1
		hfnretJ1next = dectrans(time+1)%hfnretJ1
	ELSE IF (time==Ttransition .and. ((sunset==0 .and. NoChangeTaxSystem==0) .or. GovtBudgetConstraint==1)) THEN
		emucnext = decFinalSS(1)%emuc
		evalnext = decFinalSS(1)%eval
		hfnnext = decFinalSS(1)%hfn
		emucretnext = decFinalSS(1)%emucret
		evalretnext = decFinalSS(1)%evalret
		hfnretnext = decFinalSS(1)%hfnret
		emucretJ1next = decFinalSS(1)%emucretJ1
		evalretJ1next = decFinalSS(1)%evalretJ1
		hfnretJ1next = decFinalSS(1)%hfnretJ1
	ELSE IF (time==Ttransition ) THEN
		emucnext = decInitialSS(1)%emuc
		evalnext = decInitialSS(1)%eval
		hfnnext = decInitialSS(1)%hfn
		emucretnext = decInitialSS(1)%emucret
		evalretnext = decInitialSS(1)%evalret
		hfnretnext = decInitialSS(1)%hfnret
		emucretJ1next = decInitialSS(1)%emucretJ1
		evalretJ1next = decInitialSS(1)%evalretJ1
		hfnretJ1next = decInitialSS(1)%hfnretJ1
	END IF

END IF



END SUBROUTINE SetUpTimeVariables
