SUBROUTINE Simulate

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER		:: in,ij,ijret,iW,iR,id,idedchoice(1),ify,izy,tempdraw
REAL(8)		:: lliqmin,lxA,lxN,lass,lsavmin,lsavmax,lvalded(ngpd),lvaldedret(ngpdret)
REAL(8), EXTERNAL	:: FnTax, FnBondPrice, FnInvQA

IF(Display==1) write(*,*) 'Simulating model'



!initial deduction is zero
dedsimI(:,1) = 1

!$OMP PARALLEL DO PRIVATE(ij,ijret,iW,iR,id,idedchoice,lliqmin,lxA,lxN,lass,lsavmin,lsavmax,lvalded,lvaldedret,ify,izy,tempdraw)
DO in = 1,nsim
	!write(*,*) 'simulating person ',in

	!initial assets
	IF(NoInitialWealth==1) THEN
		asim(in,1) = 0.0
		lsim(in,1) = 0.0
	ELSE
        IF(ngpzy .gt. 1) THEN
        	CALL DiscreteDist1(tempdraw,2,initilldist(zysimI(in,1),:),initss1(in))
			asim(in,1)=(real(tempdraw)-1.0d0)*initill(zysimI(in,1))

        	CALL DiscreteDist1(tempdraw,2,initliqdist(zysimI(in,1),:),initss2(in))
			lsim(in,1)=(real(tempdraw)-1.0d0)*initliq(zysimI(in,1))
		ELSE
        	CALL DiscreteDist1(tempdraw,2,initilldist(fylevsimI(in),:),initss1(in))
        	asim(in,1)=(real(tempdraw)-1.0d0)*initill(fylevsimI(in))

        	CALL DiscreteDist1(tempdraw,2,initliqdist(fylevsimI(in),:),initss2(in))
            lsim(in,1)=(real(tempdraw)-1.0d0)*initliq(fylevsimI(in))
        END IF
	END IF
	
	!working
	DO ij = 1,Jwork

		!pensions
		psimI(in,ij) = 1
		psim(in,ij) = 0.0
	
		iW = Wind(fysimI(in),zysimI(in,ij))
		ify = fysimI(in)
		izy = zysimI(in,ij)
		IF(ij <Jwork) lliqmin = abl(ij+1,fysimI(in),zysimI(in,ij))	
		IF(ij==Jwork) lliqmin = 0.0					
		lsavmin = lliqmin*FnBondPrice(lliqmin,0.0_8)
		
		IF(ij<Jwork) ablsim(in,ij) = abl(ij+1,ify,izy)
		taxsim(in,ij) = FnTax(taxsys,ysim(in,ij),1,INT(usim(in,ij)),taxincr) + mturcg*asim(in,ij)
		
		lxN = lsim(in,ij) + ysim(in,ij) - taxsim(in,ij) - dgrid(dedsimI(in,ij))*(ypssim(in,ij)- taxsim(in,ij))
		lxA = lsim(in,ij) + ysim(in,ij) - taxsim(in,ij) +asim(in,ij)
		lass = asim(in,ij) 


		!adjustment decision 
		! IF(UsePosNegDvalInterp==1) CALL BiPosNegInterp1RatioXAret (nx,x,na,a,f,xi,ai,fi)
		IF(UsePosNegDvalInterp==0) CALL	BiLinInterp1RatioXA (ij,ify,izy,ngpxN,xNgrid(ij,:,:,fysimI(in),zysimI(in,ij),dedsimI(in,ij)),ngpa,agrid(ij,:,fysimI(in),zysimI(in,ij)),dval(ij,:,:,dedsimI(in,ij),iW,usimI(in,ij)),lxN,lass,dVsim(in,ij))

		IF(dVsim(in,ij)>=0.0) THEN!ADJUST
			adjsim(in,ij) = 1.0
			xsim(in,ij) = lxA
			
			lsavmax = lxA -fixcost - varcost*ypssim(in,ij)*(1.0-ugrid(usimI(in,ij))*(1.0-uemprepl))- cmin*(1.0+ctax)
			IF (lxA==xAgrid(ij,1,fysimI(in),zysimI(in,ij))) THEN
				idedchoice = maxloc(valA(ij,1,:,iW,usimI(in,ij)))
				dedsimI(in,ij+1) = idedchoice(1)
				Vsim(in,ij)	= valA(ij,1,dedsimI(in,ij+1),iW,usimI(in,ij))
				ssim(in,ij)	= savA(ij,1,dedsimI(in,ij+1),iW,usimI(in,ij))
				asim(in,ij+1) = assA(ij,1,dedsimI(in,ij+1),iW,usimI(in,ij))
			ELSE
				!interpolate deduction-choice specific value functions
				DO id = 1,ngpd
					CALL LinInterp1(ngpxA,xAgrid(ij,:,fysimI(in),zysimI(in,ij)),valA(ij,:,id,iW,usimI(in,ij)),lxA,lvalded(id))
				END DO
				idedchoice = maxloc(lvalded)
				dedsimI(in,ij+1) = idedchoice(1)
				Vsim(in,ij) = lvalded(dedsimI(in,ij+1))
				CALL LinInterp1(ngpxA,xAgrid(ij,:,fysimI(in),zysimI(in,ij)),savA(ij,:,dedsimI(in,ij+1),iW,usimI(in,ij)),lxA,ssim(in,ij))
				CALL LinInterp1(ngpxA,xAgrid(ij,:,fysimI(in),zysimI(in,ij)),assA(ij,:,dedsimI(in,ij+1),iW,usimI(in,ij)),lxA,asim(in,ij+1))
			END IF
			
			!adjust for interpolating outside constraints
			IF(ssim(in,ij)>lsavmax .or. ssim(in,ij)<lsavmin .or. asim(in,ij+1)<0.0) THEN
				IF(Display==2) write(*,*) 'interpolation problem in simulations (working)'
				ssim(in,ij) = min(max(ssim(in,ij),lsavmin),lsavmax)
				asim(in,ij+1) = max(asim(in,ij+1),0.0)
			END IF
			lsim(in,ij+1) = FnInvQA(ssim(in,ij)-qill*asim(in,ij+1),0.0_8)
			csim(in,ij) = (lxA-fixcost-varcost*ypssim(in,ij)*(1.0-ugrid(usimI(in,ij))*(1.0-uemprepl))-ssim(in,ij))/(1.0+ctax)
			
			IF(isnan(csim(in,ij)) .or. csim(in,ij)<=0.0) THEN
				write(*,*) 'bad consumption (ADJ):',in,ij,xsim(in,ij),asim(in,ij),lsim(in,ij),csim(in,ij),asim(in,ij+1),lsim(in,ij+1),lliqmin
			END IF

		ELSE !DO NOT ADJUST
			adjsim(in,ij) = 0.0
			xsim(in,ij) = lxN
			
			IF(ij<Jwork) dedsimI(in,ij+1) = dedsimI(in,ij)
			IF(ij==Jwork) dedsimI(in,ij+1) = 1	!default is to start retirement without automatic withdrawals
			
			asim(in,ij+1) = (lass + dgrid(dedsimI(in,ij))*(ypssim(in,ij)-taxsim(in,ij)))/qill
			lsavmax = lxN - cmin*(1.0+ctax)

			CALL BiLinInterp1RatioXA(ij,ify,izy,ngpxN,xNgrid(ij,:,:,fysimI(in),zysimI(in,ij),dedsimI(in,ij)),ngpa,agrid(ij,:,fysimI(in),zysimI(in,ij)),valN(ij,:,:,dedsimI(in,ij),iW,usimI(in,ij)),lxN,lass,Vsim(in,ij))
			CALL BiLinInterp1RatioXA(ij,ify,izy,ngpxN,xNgrid(ij,:,:,fysimI(in),zysimI(in,ij),dedsimI(in,ij)),ngpa,agrid(ij,:,fysimI(in),zysimI(in,ij)),savN(ij,:,:,dedsimI(in,ij),iW,usimI(in,ij)),lxN,lass,ssim(in,ij))			

			!adjust for interpolating outside constraints
			IF(ssim(in,ij)>lsavmax .or. ssim(in,ij)<lsavmin) THEN
				IF(Display==2 .and. (ssim(in,ij)<lsavmin-1.0e-4 .or. ssim(in,ij)>lsavmax+1.0e-4)) write(*,*) 'interpolation problem in simulations (working NA)'
				ssim(in,ij) = min(max(ssim(in,ij),lsavmin),lsavmax)				
			END IF
			lsim(in,ij+1) = FnInvQA(ssim(in,ij),0.0_8)
			csim(in,ij) = (lxN-ssim(in,ij))/(1.0+ctax)

			IF(isnan(csim(in,ij)) .or. csim(in,ij)<=0.0) THEN
				if (Display==1) write(*,*) 'bad consumption (NO ADJ):',in,ij,xsim(in,ij),asim(in,ij),lsim(in,ij),csim(in,ij),asim(in,ij+1),lsim(in,ij+1),lliqmin
			END IF

		END IF
		

		!adjust for rounding errors
		IF(abs(asim(in,ij+1))<1.0e-5) asim(in,ij+1) = 0.0
		IF(abs(lsim(in,ij+1))<1.0e-5) lsim(in,ij+1) = 0.0

		incsim(in,ij) =  (1.0-qill)*asim(in,ij)  +ysim(in,ij)
		IF(lsim(in,ij)>0.0) incsim(in,ij) = incsim(in,ij) + (1.0-qfree)*lsim(in,ij)
		
    END DO

	!retirement
	DO ij = Jwork+1,Jwork+Jret
		ijret = ij-Jwork
		
		!pensions
		psimI(in,ij) = (zysimI(in,Jwork)-1)*ngpfy+fysimI(in)
	    psim(in,ij) = pgrid(ij,psimI(in,ij))
		
		iR = Rind(psimI(in,ij))
		lliqmin = 0.0					
		lsavmin = lliqmin*FnBondPrice(lliqmin,0.0_8)
	
		taxsim(in,ij) = FnTax(taxsys,psim(in,ij),0,0,taxincr)+ mturcg*asim(in,ij)
		
		lxN = lsim(in,ij) + psim(in,ij) - taxsim(in,ij) + dgridret(dedsimI(in,ij))*asim(in,ij)
		lxA = lsim(in,ij) + psim(in,ij) - taxsim(in,ij) + asim(in,ij)

		lass = asim(in,ij)
! 		lass = lass*(1.0-dgridret(dedsimI(in,ij))) 


		!adjustment decision 
		IF(UsePosNegDvalInterp==0) CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(ijret,:,:,psimI(in,ij),dedsimI(in,ij)),ngparet,agridret(ijret,:,psimI(in,ij)),dvalret(ijret,:,:,dedsimI(in,ij),iR),lxN,lass,dVsim(in,ij))			

		IF(dVsim(in,ij)>=0.0) THEN!ADJUST
			adjsim(in,ij) = 1.0
			xsim(in,ij) = lxA
			lsavmax = lxA -fixcost - varcost*psim(in,ij) - cmin*(1.0+ctax)
			IF (lxA==xAgridret(ijret,1,psimI(in,ij))) THEN
				idedchoice = maxloc(valAret(ijret,1,:,iR))
				dedsimI(in,ij+1) = idedchoice(1)
				Vsim(in,ij)	= valAret(ijret,1,dedsimI(in,ij+1),iR)
				ssim(in,ij)	= savAret(ijret,1,dedsimI(in,ij+1),iR)
				asim(in,ij+1) = assAret(ijret,1,dedsimI(in,ij+1),iR)

			ELSE
				DO id = 1,ngpdret
					CALL LinInterp1(ngpxAret,xAgridret(ijret,:,psimI(in,ij)),valAret(ijret,:,id,iR),lxA,lvaldedret(id))
				END DO
				idedchoice = maxloc(lvaldedret)
				dedsimI(in,ij+1) = idedchoice(1)
				Vsim(in,ij) = lvaldedret(dedsimI(in,ij+1))
				CALL LinInterp1(ngpxAret,xAgridret(ijret,:,psimI(in,ij)),savAret(ijret,:,dedsimI(in,ij+1),iR),lxA,ssim(in,ij))
				CALL LinInterp1(ngpxAret,xAgridret(ijret,:,psimI(in,ij)),assAret(ijret,:,dedsimI(in,ij+1),iR),lxA,asim(in,ij+1))
			END IF
	
			!adjust for interpolating outside constraints
			IF(ssim(in,ij)>lsavmax .or. ssim(in,ij)<lsavmin .or. asim(in,ij+1)<0.0) THEN
				IF(Display==2) write(*,*) 'interpolation problem in simulations (retirement)'
				ssim(in,ij) = min(max(ssim(in,ij),lsavmin),lsavmax)
				asim(in,ij+1) = max(asim(in,ij+1),0.0)				
			END IF
			lsim(in,ij+1) = FnInvQA(ssim(in,ij)-qill*asim(in,ij+1),0.0_8)
			
			!make sure doesnt leave a small amount in the bank due to interpolation:
			IF(asim(in,ij+1)/(qill**(Jret-ijret)) <= fixcost + varcost*psim(in,ij)) asim(in,ij+1) = 0.0
			csim(in,ij) = (lxA-fixcost-varcost*psim(in,ij) -ssim(in,ij))/(1.0+ctax)

			IF(isnan(csim(in,ij)) .or. csim(in,ij)<=0.0) THEN
			    if (Display==1) write(*,*) 'bad consumption (ADJ):',in,ij,xsim(in,ij),asim(in,ij),lsim(in,ij),csim(in,ij),asim(in,ij+1),lsim(in,ij+1),lliqmin
			END IF

		ELSE !DO NOT ADJUST
			adjsim(in,ij) = 0.0
			xsim(in,ij) = lxN
			dedsimI(in,ij+1) = dedsimI(in,ij)

			asim(in,ij+1) = lass*(1.0-dgridret(dedsimI(in,ij))) /qill
			lsavmax = lxN - cmin*(1.0+ctax)

			CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(ijret,:,:,psimI(in,ij),dedsimI(in,ij)),ngparet,agridret(ijret,:,psimI(in,ij)),valNret(ijret,:,:,dedsimI(in,ij),iR),lxN,lass,Vsim(in,ij))
			CALL BiLinInterp1RatioXAret(ngpxNret,xNgridret(ijret,:,:,psimI(in,ij),dedsimI(in,ij)),ngparet,agridret(ijret,:,psimI(in,ij)),savNret(ijret,:,:,dedsimI(in,ij),iR),lxN,lass,ssim(in,ij))			


			!adjust for interpolating outside constraints
			IF(ssim(in,ij)>lsavmax .or. ssim(in,ij)<lsavmin) THEN
				IF(Display==2) write(*,*) 'interpolation problem in simulations (retirement NA)'
				ssim(in,ij) = min(max(ssim(in,ij),lsavmin),lsavmax)				
			END IF
			lsim(in,ij+1) = FnInvQA(ssim(in,ij),0.0_8)
			csim(in,ij) = (lxN-ssim(in,ij))/(1.0+ctax)

			IF(isnan(csim(in,ij)) .or. csim(in,ij)<=0.0) THEN
				if (Display==2) write(*,*) 'bad consumption (NO ADJ):',in,ij,xsim(in,ij),asim(in,ij),lsim(in,ij),csim(in,ij),asim(in,ij+1),lsim(in,ij+1),lliqmin
			END IF

		END IF

		!adjust for rounding errors
		IF(abs(asim(in,ij+1))<1.0e-5) asim(in,ij+1) = 0.0
		IF(abs(lsim(in,ij+1))<1.0e-5) lsim(in,ij+1) = 0.0


		incsim(in,ij) = (1.0-qill)*asim(in,ij) + psim(in,ij)
		IF(lsim(in,ij)>0.0) incsim(in,ij) = incsim(in,ij) + (1.0-qfree)*lsim(in,ij)

	END DO
	
	

END DO
!$OMP END PARALLEL DO

lplsim(:,1:Jwork) = lsim(:,1:Jwork) + 0.5*(ysim(:,1:Jwork) - taxsim(:,1:Jwork))
lplsim(:,Jwork+1:Jtot) = lsim(:,Jwork+1:Jtot) + 0.5*(psim(:,Jwork+1:Jtot) - taxsim(:,Jwork+1:Jtot))

lpl3sim(:,1:Jwork) = lsim(:,1:Jwork) + (ysim(:,1:Jwork) - taxsim(:,1:Jwork)- (1.0d0+ctax)*0.5d0*csim(:,1:Jwork))/3.0d0
lpl3sim(:,Jwork+1:Jtot) = lsim(:,Jwork+1:Jtot) + (psim(:,Jwork+1:Jtot) - taxsim(:,Jwork+1:Jtot)-(1.0d0+ctax)*0.5d0*csim(:,Jwork+1:Jtot))/3.0d0

lpl6sim(:,1:Jwork) = lsim(:,1:Jwork) + (ysim(:,1:Jwork) - taxsim(:,1:Jwork)- (1.0d0+ctax)*0.5d0*csim(:,1:Jwork))/6.0d0
lpl6sim(:,Jwork+1:Jtot) = lsim(:,Jwork+1:Jtot) + (psim(:,Jwork+1:Jtot) - taxsim(:,Jwork+1:Jtot)-(1.0d0+ctax)*0.5d0*csim(:,Jwork+1:Jtot))/6.0d0


!adjust for housing
 ctotsim = csim
 csim = ndweight*(ctotsim + servflow*asim(:,2:Jtot+1) +liqflow*MAX(lsim(:,2:Jtot+1),0.0))
 flowsim = (1.0d0-ndweight)*(ctotsim + servflow*asim(:,2:Jtot+1)+liqflow*MAX(lsim(:,2:Jtot+1),0.0))
 

END SUBROUTINE Simulate
