SUBROUTINE SimulateEarnings

USE Parameters
USE Globals
USE Procedures
USE random

IMPLICIT NONE

INTEGER		:: iseed(2),isize

INTEGER		:: in,ij,iznext(2)
REAL(8)		:: lpynext(2),lEygreat,lEyless,lEy


!set random number seed
iseed(1) = 6970
iseed(2) = 6971
isize = 2
CALL RANDOM_SEED(size = isize)
CALL RANDOM_SEED(put = iseed)   
CALL RANDOM_NUMBER(initss1)
CALL RANDOM_NUMBER(initss2)

!unemployment
CALL RandomDiscrete(nsim, usimI(:,1), ngpu, (/1.0-initialunemp,initialunemp /))

!earnings
    CALL RandomDiscrete(nsim, fyslosimI(:), ngpfyslo, fyslodist)
    CALL RandomDiscrete(nsim, fylevsimI(:), ngpfylev, fylevdist)
    DO in = 1,nsim
	    fysimI(in) = fyind(fylevsimI(in),fyslosimI(in))
    END DO


CALL RandomDiscrete(nsim, zysimI(:,1), ngpzy, zydist(1,:))

DO in = 1,nsim
	usim(in,1) = ugrid(usimI(in,1))

	IF(SimulateAtMeanTrans==0 .and. ngpey>1) THEN
		IF(SimulateContinuousTrans==0) THEN
			CALL RandomDiscrete1( eysimI(in,1), ngpey, eydist)
			eysim(in,1) = eygrid(eysimI(in,1))
		ELSE IF(SimulateContinuousTrans==1) THEN
			eysim(in,1) = random_normal()*sqrt(Vepsy)
			eysim(in,1) = min(max(eysim(in,1),eygrid(1)),eygrid(ngpey))
		END IF
	ELSE
		eysimI(in,1) = (ngpey+1)/2
		eysim(in,1) = eygrid(eysimI(in,1))
	END IF

	zysim(in,1) = zygrid(1,zysimI(in,1))
    ypssim(in,1) = ypsgrid(1,fysimI(in),zysimI(in,1))
	IF(usimI(in,1)==1) THEN !emp
! 		ysim(in,1) = ygrid(1,fysimI(in),zysimI(in,1),eysimI(in,1))
		ysim(in,1) = ypssim(in,1) *exp(eysim(in,1))
	   	yavsim(in,1) = ysim(in,1)
	   	yavsimforpen(in,1) = min(ysim(in,1),pencap)
	ELSE IF(usimI(in,1)==2) THEN !unemp
		ysim(in,1) = uemprepl*ypssim(in,1)
		yavsim(in,1) = 0.0
		yavsimforpen(in,1) = 0.0
    END IF
 

    DO ij = 2,Jwork
		SELECT CASE(usimI(in,ij-1))	
			CASE(1)	!emp last period
	        	CALL RandomDiscrete1(usimI(in,ij), ngpu, (/1.0-jobloss(ij-1),jobloss(ij-1) /))
				usim(in,ij) = ugrid(usimI(in,ij))
				
				IF(usimI(in,ij)==1) THEN	!emp this period too
			        CALL RandomDiscrete1(zysimI(in,ij), ngpzy, zytrans(ij-1,zysimI(in,ij-1),:))
					IF(SimulateAtMeanTrans==0 .and. ngpey>1) THEN
			        	IF(SimulateContinuousTrans==0) THEN
							CALL RandomDiscrete1(eysimI(in,ij), ngpey, eydist)
							eysim(in,ij) = eygrid(eysimI(in,ij))
						ELSE
							eysim(in,ij) = random_normal()*sqrt(Vepsy)
							eysim(in,ij) = min(max(eysim(in,ij),eygrid(1)),eygrid(ngpey))						
						END IF
					ELSE
						eysimI(in,ij) = (ngpey+1)/2
						eysim(in,ij) = eygrid(eysimI(in,ij))
					END IF
					zysim(in,ij) = zygrid(ij,zysimI(in,ij))
				    ypssim(in,ij) = ypsgrid(ij,fysimI(in),zysimI(in,ij))
! 			        ysim(in,ij) = ygrid(ij,fysimI(in),zysimI(in,ij),eysimI(in,ij))
			        ysim(in,ij) = ypssim(in,ij)*exp(eysim(in,ij))
			        yavsim(in,ij) = ((ij-1)*yavsim(in,ij-1) + ysim(in,ij))/real(ij)
			        yavsimforpen(in,ij) = ((ij-1)*yavsimforpen(in,ij-1) + min(ysim(in,ij),pencap))/real(ij)
								
				ELSE IF(usimI(in,ij)==2) THEN	!lost job
			        !CALL RandomDiscrete1(zysimI(in,ij), ngpzy, zytrans(ij-1,zysimI(in,ij-1),:))
			        zysimI(in,ij) = zysimI(in,ij-1)
					eysimI(in,ij) = 0
					eysim(in,ij) = 0.0
					zysim(in,ij) = zygrid(ij,zysimI(in,ij))
			        ypssim(in,ij) = ypsgrid(ij,fysimI(in),zysimI(in,ij))
					ysim(in,ij) = uemprepl*ypssim(in,ij)
				    yavsim(in,ij) = (ij-1)*yavsim(in,ij-1)/real(ij)
				    yavsimforpen(in,ij) = (ij-1)*yavsimforpen(in,ij-1)/real(ij)
								
				END IF
				
			CASE(2) !unemp last period
				CALL RandomDiscrete1(usimI(in,ij), ngpu, (/jobfind(ij-1),1.0-jobfind(ij-1) /))
				usim(in,ij) = ugrid(usimI(in,ij))	
					
				IF(usimI(in,ij)==1) THEN	!found job
					IF (ngpzy>1) THEN
						CALL FindLinProb1 ((1.0-uemplosspers)*ypsgrid(ij,fysimI(in),zysimI(in,ij-1)),ypsgrid(ij,fysimI(in),:),iznext,lpynext)
				        CALL RandomDiscrete1(zysimI(in,ij), 2, lpynext)
						zysimI(in,ij) = iznext(zysimI(in,ij))
					ELSE
						zysimI(in,ij) = 1
					END IF
					!zysimI(in,ij) = zysimI(in,ij-1)
					eysimI(in,ij) = 0	!use as dummy for back from unemployment
					eysim(in,ij) = log(1.0-uemplosstrans)
					zysim(in,ij) = zygrid(ij,zysimI(in,ij))
			        ypssim(in,ij) = ypsgrid(ij,fysimI(in),zysimI(in,ij))
			        ysim(in,ij) = ypssim(in,ij)*(1.0-uemplosstrans)
			        yavsim(in,ij) = ((ij-1)*yavsim(in,ij-1) + ysim(in,ij))/real(ij)
			        yavsimforpen(in,ij) = ((ij-1)*yavsimforpen(in,ij-1) + min(ysim(in,ij),pencap))/real(ij)
								
				ELSE IF(usimI(in,ij)==2) THEN	!remain unemployed
			        !CALL RandomDiscrete1(zysimI(in,ij), ngpzy, zytrans(ij-1,zysimI(in,ij-1),:))
			        zysimI(in,ij) = zysimI(in,ij-1)
					eysimI(in,ij) = 0
					eysim(in,ij) = 0.0
					zysim(in,ij) = zygrid(ij,zysimI(in,ij))
				    ypssim(in,ij) = ypsgrid(ij,fysimI(in),zysimI(in,ij))
			        ysim(in,ij) = uemprepl*ypssim(in,ij)
			        yavsim(in,ij) = (ij-1)*yavsim(in,ij-1)/real(ij)
			        yavsimforpen(in,ij) = (ij-1)*yavsimforpen(in,ij-1)/real(ij)
								
				END IF

		END SELECT
			

    END DO    

END DO



!adjust so average earnings in economy = 1 
IF (Numeraire==4) yavall = sum(ysim)/real(Jwork*nsim)	!quarterly earnings = 1
IF (Numeraire==1) yavall = 4*sum(ysim)/real(Jwork*nsim)	!annual earnings = 1

!yavall = yavall/2.0	!added by greg for an experiment, needs to deleted	

ygrid = ygrid/yavall
ypsgrid  = ypsgrid/yavall
ysim = ysim/yavall
yavsim = yavsim/yavall
ypssim = ypssim/yavall

!write(*,*) ysim
!pause
!write(*,*) usim
!pause


!calculate recession threshhold if modelling recession
IF (ModelRecession==1) THEN
	IF(recpclim==1.0) THEN
		recdepthcond = recdepth
		recylim = maxval(ysim) + 1.0
	ELSE
		CALL Percentile(nsimforperc*Jwork,RESHAPE(ysim(1:nsimforperc,1:Jwork), (/ nsimforperc*Jwork /)),recpclim,recylim)
		lEy = SUM(ysim)/real(nsim*Jwork)
		lEygreat = SUM(ysim, MASK = ysim>recylim)/real(COUNT(ysim>recylim))
		lEyless = SUM(ysim, MASK = ysim .le. recylim)/real(COUNT(ysim .le. recylim))
		recdepthcond = 1.0 - ((1.0-recdepth)*lEy - (1.0-recpclim)*lEygreat) / (recpclim*lEyless)	
	END IF

!	write(*,*) 'lEy: ', lEy
!	write(*,*) 'lEygreat: ', lEygreat
!	write(*,*) 'lEyless: ', lEyless
!	write(*,*) 'recpclim: ', recpclim
!	write(*,*) 'recylim: ', recylim
!	write(*,*) 'recdepthcond: ', recdepthcond
!	stop


END IF
END SUBROUTINE SimulateEarnings
