clear;
close all;

%% Parameters

numeraire = 53000;
age1 = 22;
ndweight = 0.85;
servflow = 0.01;
savefigs = 1;
fcvec = [-1 125 250 500 750 1000 1500 2000 2500 3000]'; 
fclim = [0 3000];
ucvec = [0];
xtickvec = [0 500 1000 1500 2000 2500 3000];
FirstFigNo = 1;
dg = rgb('dark green');

%% Output Directories

%see readme file for instructions  and definition of models

InputBaseDir = ''; %path to base directory for model output
SaveDir = ''; % path to directory to save figures

%full set of fixed costs in fcvec
type{1} = ''; %path to subdirectory of InputBaseDir for BMK model
type{2} = ''; %path to subdirectory of InputBaseDir for SUR1 model
type{3} = ''; %path to subdirectory of InputBaseDir for SUR2 model
type{4} = ''; %path to subdirectory of InputBaseDir for REB1000 model
type{5} = ''; %path to subdirectory of InputBaseDir for REB2000 model
type{6} = ''; %path to subdirectory of InputBaseDir for REB5000 model
type{7} = ''; %path to subdirectory of InputBaseDir for REC3 model
type{8} = ''; %path to subdirectory of InputBaseDir for REC15 model
type{9} = ''; %path to subdirectory of InputBaseDir for REC-3 model
type{10} = ''; %path to subdirectory of InputBaseDir for TAX model

%size experiments: fixed costs = $1000 only
type{14} = ''; %path to subdirectory of InputBaseDir for REB100 model
type{15} = ''; %path to subdirectory of InputBaseDir for REB200 model
type{16} = ''; %path to subdirectory of InputBaseDir for REB300 model
type{17} = ''; %path to subdirectory of InputBaseDir for REB400 model
type{18} = ''; %path to subdirectory of InputBaseDir for REB500 model
type{19} = ''; %path to subdirectory of InputBaseDir for REB750 model
type{20} = ''; %path to subdirectory of InputBaseDir for REB1000 model
type{21} = ''; %path to subdirectory of InputBaseDir for REB1250 model
type{22} = ''; %path to subdirectory of InputBaseDir for REB1500 model
type{23} = ''; %path to subdirectory of InputBaseDir for REB2000 model
type{24} = ''; %path to subdirectory of InputBaseDir for REB3000 model

%income experiments
ninc = 20;

%% Load Results

%results to load in
typevec = [1:13];
sizevec = [14:24];

% main results
for j = typevec
    for uc = 1:length(ucvec)
    for fc = 1:length(fcvec)
            
        temp = importdata([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/inputparam.txt']);
        inputparam{j}(:,fc) = temp.data; clear temp;
        Jwork = load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Jwork.txt']);
        Jret = load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Jret.txt']);    
        
        Eadj{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Eadj.txt']);
        Eadjwork{j}(fc,1) = mean(Eadj{j}(1:Jwork,fc));
        Eadjret{j}(fc,1) = mean(Eadj{j}(Jwork+1:Jwork+Jret,fc));

        temp = load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/DISTALLlpl3.txt']);
        medianlpl3{j}(fc,1) = temp(3);
        p25lpl3{j}(fc,1) = temp(2);
        p75lpl3{j}(fc,1) = temp(4);
        clear temp;
        
        rebate_coefficients_list{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/rebate_coefficients_list.txt'])';
        rebcoef_st20{j}(fc,1)   = rebate_coefficients_list{j}(1,fc);
        mpc_st20{j}(fc,1)       = rebate_coefficients_list{j}(7,fc);
        
        if j==1
            if fc>1
                mpcconstrainedlist{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/mpc_constrained_list_trunc20.txt'])';
                mpc_notconstr_st20{j}(fc,1)       = mpcconstrainedlist{j}(1,fc);
                mpc_constr_st20{j}(fc,1)       = mpcconstrainedlist{j}(2,fc);
                mpc_constr_wealthy_st20{j}(fc,1)       = mpcconstrainedlist{j}(3,fc);
                mpc_constr_poor_st20{j}(fc,1)       = mpcconstrainedlist{j}(4,fc);
                constr5_st20{j}(fc,1)                    =  mpcconstrainedlist{j}(5,fc);
                constr5_wealthy_st20{j}(fc,1)            =  mpcconstrainedlist{j}(6,fc);
                constr5_poor_st20{j}(fc,1)                    =  mpcconstrainedlist{j}(7,fc);
            elseif fc==1
                mpcconstrainedlist{j}([1:2 4:7],fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/mpc_constrained_list_trunc20.txt'])';
                mpc_notconstr_st20{j}(fc,1)       = mpcconstrainedlist{j}(1,fc);
                mpc_constr_st20{j}(fc,1)       = mpcconstrainedlist{j}(2,fc);
                mpc_constr_wealthy_st20{j}(fc,1)       = NaN;
                mpc_constr_poor_st20{j}(fc,1)       = mpcconstrainedlist{j}(4,fc);
                constr5_st20{j}(fc,1)                    =  mpcconstrainedlist{j}(5,fc);
                constr5_wealthy_st20{j}(fc,1)            =  mpcconstrainedlist{j}(6,fc);
                constr5_poor_st20{j}(fc,1)                    =  mpcconstrainedlist{j}(7,fc);
            end
            
            Eliq{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Eliq.txt']);
            Econ{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Econ.txt']);
            Eass{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Eass.txt']);
            Einc{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Einc.txt']);
            Epen{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Epen.txt']);
            
            Vloginc{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Vloginc.txt']);
            Vlogtotcon{j}(:,fc) =  load([InputBaseDir type{j} '_uc' num2str(ucvec(uc)) '.0_fc' int2str(fcvec(fc)) '/Vlogtotcon.txt']);        
            
        end
    end    
    end
end

%%
% size experiment results
for j = sizevec
    path{j} = importdata([InputBaseDir type{j} '/counterfactual_transition_path.txt']);
    for i = 1:size(path{j}.data,2)
        path{j}.(path{j}.textdata{1,i}) = path{j}.data(:,i);
    end
    grArel{j}   = (path{j}.c_grA-path{j}.c_CF)./path{j}.totreb;
    grBrel{j}   = (path{j}.c_grB-path{j}.c_CF)./path{j}.totreb;
    totrel{j}   = (grArel{j} + grBrel{j})./2;

end


%%

% income experiment results
for j = 1:ninc-1
    is = num2str(j/ninc);
    
    inc_path{j} = importdata([InputBaseDir '/INC' is '_uc0.0_fc1000/counterfactual_transition_path.txt']);
    for i = 1:size(inc_path{j}.data,2)
        inc_path{j}.(inc_path{j}.textdata{1,i}) = inc_path{j}.data(:,i);
    end
    inc_target{j} = j/ninc;
    inc_grArel{j}   = (inc_path{j}.c_grA-inc_path{j}.c_CF)./(inc_path{j}.totreb);
    inc_grBrel{j}   = (inc_path{j}.c_grB-inc_path{j}.c_CF)./(inc_path{j}.totreb);
    inc_totrel{j}   = (inc_grArel{j} + inc_grBrel{j})./2;
    
end

%%
fcvec(1) = 0;

f = FirstFigNo-1;

return;

%% Fig 3a: frac adjust

f = f+1;
figure(f);
hold on
plot(fcvec,[1; Eadjwork{1}(2:length(Eadjwork{1}))].*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec,[1; Eadjret{1}(2:length(Eadjret{1}))].*100,'^-b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
grid on
hold off
legend('Workers','Retirees','Location','NorthEast');
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
ylim([0 100]);
xlabel('Fixed Cost ($)');
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_3a']);
    hgsave(f,[SaveDir 'fig_3a']);
end

%% Fig 3b: liquid wealth dist

f = f+1;
figure(f);
hold on
plot(fcvec(2:length(fcvec)),p25lpl3{1}(2:length(fcvec)).*numeraire,'s--r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec(2:length(fcvec)),medianlpl3{1}(2:length(fcvec)).*numeraire,'o--','Color',dg,'LineWidth',3,'MarkerSize',12,'MarkerFaceColor',dg);
plot(fcvec(2:length(fcvec)),p75lpl3{1}(2:length(fcvec)).*numeraire,'^--b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
grid on
hold off
legend('25th pctile','Median','75th pctile','Location','NorthWest');
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
xlabel('Fixed Cost ($)');
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_3b']);
    hgsave(f,[SaveDir 'fig_3b']);
end


%% Fig 3c: hand to mouth

f = f+1;
figure(f);
hold on
plot(fcvec(1:length(fcvec)),constr5_poor_st20{1}.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec(1:length(fcvec)),constr5_wealthy_st20{1}.*100,'^-b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
grid on
hold off
legend('Hand-to-mouth, no illiquid wealth','Hand-to-mouth, positive illiquid wealth','Location','NorthWest');
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
set(gca,'ytick',[0:5:45]);

ylim([0 45])
xlim(fclim);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlabel('Fixed Cost ($)');
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_3c']);
    hgsave(f,[SaveDir 'fig_3c']);
end

%% Fig 3d: fraction borrowing, working age

f = f+1;
figure(f);
hold on
plot(fcvec,totborrwork{1}*100,'^-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
grid on
hold off
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
set(gca,'ytick',[0:5:45]);
ylim([0 45])
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
ylabel('Quarters');
xlabel('Fixed Cost ($)');
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_3d']);
    hgsave(f,[SaveDir 'fig_3d']);
end
%% Fig 4a: lifecycle means
f = f+1;
figure(f);
Jtot = Jwork+Jret;
fcind1 = 1;  %0
fcind2 = 6;  %1000
yr10ind = [4:10:54]';

hold on;
plot(age1-1+[1:Jtot/4]',annav(Econ{1}(:,fcind2)),'Color',dg,'Linewidth',3.0);
plot(age1-1+[1:Jtot/4]',annav(Eass{1}(2:Jtot+1,fcind2))./10,'r','Linewidth',3.0);
plot(age1-1+[1:Jtot/4]',annav(Eliq{1}(2:Jtot+1,fcind2))./10,'k','Linewidth',3.0);
plot(age1-1+[1:Jtot/4]',annav(Econ{1}(:,fcind1)),'-.','Color',dg,'Linewidth',3.0);
plot(age1-1+[1:Jtot/4]',annav(Eliq{1}(2:Jtot+1,fcind1))./10,'r-.','Linewidth',3.0);

temp = annav(Econ{1}(:,fcind1));
plot([25:10:75]',temp(yr10ind),'o','Color',dg,'MarkerSize',14,'MarkerFaceColor',dg);
temp = annav(Eliq{1}(2:Jtot+1,fcind1))./10
plot([25:10:75]',temp(yr10ind),'rs','MarkerSize',14,'MarkerFaceColor','r');

p1 = plot(age1-1+[1:Jtot/4]',[annav(Einc{1}(:,fcind1));annav(Epen{1}(:,fcind1))],'b','Linewidth',3.5);
temp = annav(Econ{1}(:,fcind2));
p2 = plot([25:10:75]',temp(yr10ind),'o','Color',dg,'MarkerSize',14,'MarkerFaceColor',dg);
temp = annav(Eass{1}(2:Jtot+1,fcind2))./10;
p3 = plot([25:10:75]',temp(yr10ind),'rs','MarkerSize',14,'MarkerFaceColor','r');
temp = annav(Eliq{1}(2:Jtot+1,fcind2))./10;
p4 = plot([25:10:75]',temp(yr10ind),'k^','MarkerSize',14,'MarkerFaceColor','k');

hold off;
grid on;

set(gca,'FontSize',18);
xlabel('Age');
xlim([age1 80]);
ylim([-0.02 0.6]);
h_l =   legend([p1 p2 p3 p4],'Income','Consumption','Iliquid Wealth/10','Liquid Wealth/10','Location','Best');
set(h_l,'FontSize',18)
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_4a']);
    hgsave(f,[SaveDir 'fig_4a']);
end

%% Fig 4b: lifecycle variance
f = f+1;
figure(f);
Jtot = Jwork+Jret;
fcind1 = 1;  %0
fcind2 = 6;  %1000
yr5ind = [4:5:34]';


hold on;
plot(age1-1+[1:Jwork/4]',annav(Vlogtotcon{1}(1:Jwork,fcind2)),'Color',dg,'Linewidth',3.5);
plot(age1-1+[1:Jwork/4]',annav(Vlogtotcon{1}(1:Jwork,fcind1)),'-.','Color',dg,'Linewidth',3.5);
p1 = plot(age1-1+[1:Jwork/4]',annav(Vloginc{1}(:,fcind1)),'b-','Linewidth',3.5);

temp = annav(Vlogtotcon{1}(1:Jwork,fcind2));
p2 = plot([25:5:55]',temp(yr5ind),'o','Color',dg,'MarkerSize',12,'MarkerFaceColor',dg);
temp = annav(Vlogtotcon{1}(1:Jwork,fcind1));
plot([25:5:55]',temp(yr5ind),'o','Color',dg,'MarkerSize',12,'MarkerFaceColor',dg);

hold off;
grid on;
set(gca,'FontSize',18);
xlabel('Age');
xlim([age1 60]);
ylim([0 0.8]);
h_l =   legend([p1 p2], 'Variance Log Income','Variance Log Consumption','Location','Best');
set(h_l,'FontSize',18)
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_4b']);
    hgsave(f,[SaveDir 'fig_4b']);
end

%% Fig 5a: rebate coefficient

f = f+1;
figure(f);
hold on
plot(fcvec,rebcoef_st20{1}.*100,'s-b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
grid on
hold off

set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
ylim([0 25]);
ylabel('Rebate Coefficient (%)');
xlabel('Fixed Cost ($)');
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_5a_rebcoef']);
    hgsave(f,[SaveDir 'fig_5a_rebcoef']);
    
end
%% Fig 5b: mpc: constrained vs notconstrained 

f = f+1;
figure(f);
hold on
plot(fcvec,mpc_constr_st20{1}.*100,'o:r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec,mpc_notconstr_st20{1}.*100,'^-','Color',dg,'LineWidth',3,'MarkerSize',12,'MarkerFaceColor',dg);
grid on
hold off
legend('Hand-to-mouth agents','Non hand-to-mouth agents','Location','NorthWest');
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);

xlim(fclim);
ylim([0 60]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

ylabel('Marginal Propensity to Consume (%)');
xlabel('Fixed Cost ($)');
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_5b']);
    hgsave(f,[SaveDir 'fig_5b']);
end




%% Fig 6: rebate coefficient by information structure

f = f+1;
figure(f);
hold on
plot(fcvec,rebcoef_st20{1}.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec,rebcoef_st20{2}.*100,'s--b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
plot(fcvec,rebcoef_st20{3}.*100,'^:k','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','k');
grid on
hold off
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
ylim([-5 35]);
ylabel('Rebate Coefficient (%)');
xlabel('Fixed Cost ($)');
h_l = legend('Surprise for early recipients only','Surprise for noone','Surprise for all',...
    'Location','SouthEast');
set(h_l,'FontSize',18)
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_6']);
    hgsave(f,[SaveDir 'fig_6']);
end

%% Fig 8: size asymmetry 

f = f+1;
figure(f);
hold on
plot(fcvec,rebcoef_st20{1}.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec,rebcoef_st20{4}.*100,'>:b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
plot(fcvec,rebcoef_st20{5}.*100,'^--','Color',dg,'LineWidth',3,'MarkerSize',12,'MarkerFaceColor',dg);
plot(fcvec,rebcoef_st20{6}.*100,'s-.k','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','k');
grid on
hold off
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
ylim([-5 25]);
ylabel('Rebate Coefficient (%)');
xlabel('Fixed Cost ($)');
h_l = legend('$500 rebate','$1000 rebate','$2000 rebate','$5000 rebate',...
    'Location','NorthWest');
set(h_l,'FontSize',18)
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_8']);
    hgsave(f,[SaveDir 'fig_8']);
end

%% Fig 7: size asymmetry: anticipated

f = f+1;
figure(f);
hold on
plot(fcvec,rebcoef_st20{2}.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec,rebcoef_st20{30}.*100,'>:b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
plot(fcvec,rebcoef_st20{31}.*100,'^--','Color',dg,'LineWidth',3,'MarkerSize',12,'MarkerFaceColor',dg);
% plot(fcvec,rebcoef_st20{6}.*100,'s-.k','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','k');
grid on
hold off
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
ylim([-5 25]);
ylabel('Rebate Coefficient (%)');
xlabel('Fixed Cost ($)');
% h_l = legend('$500 rebate','$1000 rebate','$2000 rebate','$5000 rebate','Location','NorthWest');
h_l = legend('$500 rebate','$1000 rebate','$3000 rebate','Location','NorthWest');
set(h_l,'FontSize',18)
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_7_size_anticipated']);
    hgsave(f,[SaveDir 'fig_7_size_anticipated']);
end

%% Fig 9a: rebate coefficient, tax reform

f = f+1;
figure(f);
hold on
plot(fcvec,rebcoef_st20{1}.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec,rebcoef_st20{10}.*100,'^:b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
grid on
hold off
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);

xlim(fclim);
ylim([-5 25]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

ylabel('Rebate Coefficient (%)');
xlabel('Fixed Cost ($)');
h_l = legend('Baseline','Baseline + Tax reform','No borrowing','No borrowing + tax reform',...
    'Location','SouthEast');
set(h_l,'FontSize',18)
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_9a']);
    hgsave(f,[SaveDir 'fig_9a']);
end

%% Fig 9b: rebate coefficient, recession/expansion

f = f+1;
figure(f);
hold on
plot(fcvec,rebcoef_st20{1}.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(fcvec,rebcoef_st20{7}.*100,'s--b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
plot(fcvec,rebcoef_st20{8}.*100,'^:k','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','k');
plot(fcvec,rebcoef_st20{9}.*100,'>-.','Color',dg,'LineWidth',3,'MarkerSize',12,'MarkerFaceColor',dg);
grid on
hold off
set(gca,'FontSize',18);
set(gca,'xtick',[xtickvec]);
v=vline(1000,'k--');
set(v,'LineWidth', 3);

xlim(fclim);
ylim([-5 25]);
ylabel('Rebate Coefficient (%)');
xlabel('Fixed Cost ($)');
h_l = legend('Baseline','Mild recession','Severe recession','Mild expansion',...
    'Location','SouthEast');
set(h_l,'FontSize',18)
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_8b_recession']);
    hgsave(f,[SaveDir 'fig_8b_recession']);
end


%% Fig 10a: size experiments, cumulative amount spent (group A only)
jindex = [14:24];

for i = 1:length(jindex)
    j = jindex(i);
    rebamt(i) = path{j}.totreb(1).*numeraire;
    percspent_q1(i) = sum(grArel{j}(2:2));
    percspent_q2(i) = sum(grArel{j}(2:3));
    percspent_q4(i) = sum(grArel{j}(2:5));
    percspent_q8(i) = sum(grArel{j}(2:9));
    dollarspent_q1(i) = sum(grArel{j}(2:2)).*rebamt(i);
    dollarspent_q2(i) = sum(grArel{j}(2:3)).*rebamt(i);
    dollarspent_q4(i) = sum(grArel{j}(2:5)).*rebamt(i);
    dollarspent_q8(i) = sum(grArel{j}(2:9)).*rebamt(i);
end

f = f+1;
figure(f);
hold on
plot(rebamt',percspent_q1.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(rebamt',percspent_q2.*100,'>:b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
plot(rebamt',percspent_q4.*100,'^--','Color',dg,'LineWidth',3,'MarkerSize',12,'MarkerFaceColor',dg);
grid on
hold off
legend('One quarter','Two quarters','Four quarters','Location','NorthEast');
set(gca,'FontSize',18);

xlim([0 3000]);
ylim([0 45]);
ylabel('Fraction of Rebate Spent ');
xlabel('Size of Rebate');
if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_10a']);
    hgsave(f,[SaveDir 'fig_10a']);
end

%% Fig 10b: income-targeting, cumulative amount spent by target (group A only)

for j = 1:19
    incfrac(j) = j*5;
    inc_grA_q1(j) = sum(inc_grArel{j}(2:2));
    inc_grA_q2(j) = sum(inc_grArel{j}(2:3));
    inc_grA_q4(j) = sum(inc_grArel{j}(2:5));
    inc_grA_q8(j) = sum(inc_grArel{j}(2:9));
end
incfrac(20) = 100;
inc_grA_q1(20) = sum(grArel{18}(2:2));
inc_grA_q2(20) = sum(grArel{18}(2:3));
inc_grA_q4(20) = sum(grArel{18}(2:5));
inc_grA_q8(20) = sum(grArel{18}(2:9));


f = f+1;
figure(f);
hold on
plot(incfrac',inc_grA_q1.*100,'o-r','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','r');
plot(incfrac',inc_grA_q2.*100,'>:b','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','b');
plot(incfrac',inc_grA_q4.*100,'^--','Color',dg,'LineWidth',3,'MarkerSize',12,'MarkerFaceColor',dg);
grid on
hold off
legend('One quarter','Two quarters','Four quarters','Location','NorthEast');
set(gca,'FontSize',18);

xlim([0 100]);
ylim([0 60]);
ylabel('Fraction of Rebate Spent ');
xlabel('Bottom Percentage of Income Distribution Targeted');

if (savefigs==1)
    print(f,'-depsc',[SaveDir 'fig_10b']);
    hgsave(f,[SaveDir 'fig_10b']);
end



