# delimit;
set more 1;
*----------------------------------------;
clear all;
set mem 100m;
set logtype text;

cd C:\Users\glv2\Dropbox\Dropbox\Taxrebate\SCF\Replication\data;
use C:\Users\glv2\Dropbox\Dropbox\Taxrebate\SCF\Replication\data\scf2001_defs.dta;
*----------------------------------------;

********************************************;
*DATA ON NOMINAL RETURNS (1960-2009);
*zero return on cash and checking account;
********************************************;
gen emplcontrib = 1.35;  *assumed employment contribution;

gen r_vehic = 0.000;
gen r_house = 0.060; 
gen r_eq    = 0.0786; 
gen r_cd    = 0.062;
gen r_safe  = 0.0525;

******************************************************************;
*BROAD DEFINITION OF NET LIQUID ASSETS;  
*Compute returns by household. Then average across population;
******************************************************************;
  
gen r_brliq = (r_eq*direct_eq + r_safe*((liqpos - liqposnoret)+(direct - direct_eq)) 
               + 0*liqposnoret)/brliqpos;
			   
gen r_liqpos = (r_safe*(liqpos - liqposnoret)+ 0*liqposnoret)/liqpos;
			   
gen r_direct = (r_eq*direct_eq + r_safe*(direct - direct_eq))/direct;

gen r_retacc = (r_eq*emplcontrib*retacc_eq+r_safe*emplcontrib*(retacc-retacc_eq))/retacc;

gen r_brilliqnc = (r_house*nethouse + r_eq*emplcontrib*retacc_eq
                  + r_cd*certdep + r_safe*(sb+emplcontrib*(retacc-retacc_eq))
		          + r_safe*lifeins)/(netbrilliq-netcars);  
		  
gen r_brnwnc = (r_brliq*brliqpos + r_brilliqnc*(netbrilliq-netcars))/(netbrilliq-netcars+brliqpos);
	  
***************************************;
*DATA ON TAXES (Kiefer et al. 2001);
***************************************;
gen t_intdiv =.;
gen t_ltcgain =.;


replace t_intdiv  = 0.011 if income<=0; 
replace t_ltcgain = 0.013 if income<=0;
replace t_intdiv  = 0.068 if income>0 & income<=15000;
replace t_ltcgain = 0.088 if income>0 & income<=15000;
replace t_intdiv  = 0.197 if income>15000 & income<=30000;
replace t_ltcgain = 0.107 if income>15000 & income<=30000;
replace t_intdiv  = 0.236 if income>30000 & income<=50000;
replace t_ltcgain = 0.150 if income>30000 & income<=50000;
replace t_intdiv  = 0.238 if income>50000 & income<=75000; 
replace t_ltcgain = 0.164 if income>50000 & income<=75000;
replace t_intdiv  = 0.28 if income>75000 & income<=100000;
replace t_ltcgain = 0.196 if income>75000 & income<=100000;
replace t_intdiv  = 0.30 if income>100000 & income<=200000;
replace t_ltcgain = 0.231 if income>100000 & income<=200000;
replace t_intdiv  = 0.332 if income>200000 & income<=500000;
replace t_ltcgain = 0.221 if income>200000 & income<=500000;
replace t_intdiv  = 0.349 if income>500000 & income<=1000000; 
replace t_ltcgain = 0.202 if income>500000 & income<=1000000;
replace t_intdiv  = 0.337 if income>1000000;
replace t_ltcgain = 0.203 if income>1000000;

gen t_house     = 0.0;
gen t_vehic     = 0.0;
gen t_eqlong    = t_ltcgain;
gen t_eqshort   = t_intdiv;
gen t_cd        = t_intdiv;
gen t_safe      = t_intdiv;

***************************************;
*TAXES BROAD NET LIQUID ASSETS;
***************************************;
gen t_brliq = (t_eqshort*r_eq*direct_eq + t_safe*r_safe*((liqpos - liqposnoret)+(direct - direct_eq)) 
               + 0*liqposnoret)/(r_eq*direct_eq  + r_safe*((liqpos - liqposnoret)+(direct - direct_eq)) 
               + 0*liqposnoret);
			   
gen t_brilliqnc = (t_house*r_house*nethouse + t_eqlong*r_eq*emplcontrib*retacc_eq
          + t_cd*r_cd*certdep + r_safe*(t_safe*(sb+lifeins)+t_eqlong*emplcontrib*(retacc-retacc_eq))
		   )/(r_house*nethouse + r_eq*emplcontrib*retacc_eq
          + r_cd*certdep + r_safe*(sb+lifeins+emplcontrib*(retacc-retacc_eq)));  
		  
gen t_brnwnc = (t_brliq*r_brliq*brliqpos +t_brilliqnc*r_brilliqnc*(netbrilliq-netcars))/(r_brliq*brliqpos +r_brilliqnc*(netbrilliq-netcars));			
 			
 					
save C:\Users\glv2\Dropbox\Dropbox\Taxrebate\SCF\Replication\data\scf2001_returns.dta, replace;

***************************************;
*COLLECT RESULTS;
***************************************;
// TABLE C1
sum r_br* t_br* [fweight=fwgt], d;

