clear

cd "C:\Users\glv2\Dropbox\Dropbox\Taxrebate\SCF\Replication\data"

*---------------------------
*FRACTION OF HTM
*---------------------------
use SCF2001_defs.dta, clear

*MONTHLY INCOME
gen monthlabinc = labinc/12

*LIQUID WEALTH DEFINITION
 gen liqvar   = netbrliq          // broad liquid wealth (including directly held MF, stocks and bonds
// gen liqvar   = netliq            // strict liquid wealth

*ILLIQUID WEALTH DEFINITION
gen illiqvar = netbrilliqnc      // excluding vehicles 
// gen illiqvar = netbrilliq        // including vehicles

*NET WORTH DEFINITION
gen nwvar    = networthnc             // excluding vehicles
// gen nwvar    = netbrilliq+netbrliq       // including vehicles

*ILLIQUID THRESHOLD
   gen ill_tresh = 0
// gen ill_tresh = 3000    //strict illiquid wealth 

*----------------------------------
*FRACTION OF HTM 
*---------------------------------
*TOTAL HTM
gen htm0_bor_2a =0
replace htm0_bor_2a = 1 if (liqvar>=0 & liqvar<=monthlabinc/2) |  (liqvar<0 & liqvar<=monthlabinc/2-maxcredit)
gen htm0_bor_4a =0
replace htm0_bor_4a = 1 if (liqvar>=0 & liqvar<=monthlabinc/4) | (liqvar<0 & liqvar<=monthlabinc/4-maxcredit)
gen htm0_bor_8a =0
replace htm0_bor_8a = 1 if (liqvar>=0 & liqvar<=monthlabinc/8) | (liqvar<0 & liqvar<=monthlabinc/8-maxcredit)

*WEALTHY HTM
gen htm0_bor_2b =0
replace htm0_bor_2b = 1 if (liqvar>=0 & liqvar<=monthlabinc/2 & illiqvar>ill_tresh) | (liqvar<0 & liqvar<=monthlabinc/2-maxcredit & illiqvar>ill_tresh)
gen htm0_bor_4b =0
replace htm0_bor_4b = 1 if (liqvar>=0 & liqvar<=monthlabinc/4 & illiqvar>ill_tresh) | (liqvar<0 & liqvar<=monthlabinc/4-maxcredit & illiqvar>ill_tresh)
gen htm0_bor_8b =0
replace htm0_bor_8b = 1 if (liqvar>=0 & liqvar<=monthlabinc/8 & illiqvar>ill_tresh) | (liqvar<0 & liqvar<=monthlabinc/8-maxcredit & illiqvar>ill_tresh)

*HTM IN NET WORTH
gen htm0_bor_2c =0
replace htm0_bor_2c = 1 if (nwvar>=0 & nwvar<=monthlabinc/2) | (nwvar<0 & nwvar<=monthlabinc/2-maxcredit)
gen htm0_bor_4c =0
replace htm0_bor_4c = 1 if (nwvar>=0 & nwvar<=monthlabinc/4) | (nwvar<0 & nwvar<=monthlabinc/4-maxcredit)
gen htm0_bor_8c =0
replace htm0_bor_8c = 1 if (nwvar>=0 & nwvar<=monthlabinc/8) | (nwvar<0 & nwvar<=monthlabinc/8-maxcredit)

*---------------------------
*ALTERNATIVE MEASURES OF HTM
*---------------------------
* HTM1: usually spend >=y, HTM3: past year spent >=y
gen htm1a = 0
replace htm1a = 1 if htm1==1 & netbrilliqnc>0

gen htm2a = 0
replace htm2a = 1 if htm2==1 & netbrilliqnc>0

gen htm3a = 0
replace htm3a = 1 if htm3==1 & netbrilliqnc>0

gen htm4a = 0
replace htm4a = 1 if htm4==1 & netbrilliqnc>0

/////////////////////////////////////////////////////////////////////////////
// TABLE B1
collapse (mean) htm0_bor_2a=htm0_bor_2a (mean) htm0_bor_4a=htm0_bor_4a (mean) htm0_bor_8a=htm0_bor_8a ///
		 (mean) htm0_bor_2b=htm0_bor_2b (mean) htm0_bor_4b=htm0_bor_4b (mean) htm0_bor_8b=htm0_bor_8b ///
		 (mean) htm0_bor_2c=htm0_bor_2c (mean) htm0_bor_4c=htm0_bor_4c (mean) htm0_bor_8c=htm0_bor_8c ///
		 (mean) htm1=htm1a (mean) htm2=htm2a (mean) htm3=htm3a (mean) htm4=htm4a [fweight=fwgt]

