# delimit;
set more 1;

clear;
cap clear matrix;
set logtype text;

global VarList c y p l reb age;
global Nsim 60000; *set to 600000 for full model;
global Tpath 14; *set to 14 for full model;


clear;
set obs $Nsim;
gen id = _n;
sort id;
compress;
save Simulations.dta, replace;

foreach var in simCstr5 simCstr5noill{;
    clear;
    insheet using sims/`var'.txt;
	rename v1 `var';
    gen id = _n;
    sort id;
    compress;
    merge 1:1 id using Simulations.dta, sorted;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
};


*read in files from fortran;
foreach var in $VarList{; *;
    clear;
    insheet using sims/`var'simREB.txt;
    gen id = _n;
    forvalues i = 1/$Tpath{;
        rename v`i' `var'`i';
    }; 
    sort id;
    compress;
    merge 1:1 id using Simulations.dta, sorted;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
};



*reshape;
use Simulations.dta, clear;
reshape long $VarList, i(id) j(t);
compress;
iis id;
xtset id t;
save Simulations_long.dta, replace;
